﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using DotPrologTest.Execution;
using DotPrologTest.Predicates;
using Microsoft.VisualStudio.TestTools.UnitTesting;
using OpcLabs.DotProlog.Code;
using OpcLabs.DotProlog.Execution;
using OpcLabs.DotProlog.Loading;
using OpcLabs.DotProlog.Terms;
using OpcLabs.DotProlog.Test;

namespace DotPrologTest.Libraries
{
    // ReSharper disable once InconsistentNaming
    public class clrTest
    {
        [TestClass]
        // ReSharper disable once InconsistentNaming
        public class clr_array_to_list_2_Test : SemiDeterministicPredicateTest
        {
            public clr_array_to_list_2_Test() : base("clr_array_to_list", 2)
            {
            }

            [TestMethod]
            public void Test0()
            {
                var list = new Variable();
                Test(
                    new Term[] { new ClrObject(new string[0]), list },
                    new VariableDictionary { { list, new NList() } });
            }

            [TestMethod]
            public void Test1()
            {
                string first = "first";
                var list = new Variable();
                Test(
                    new Term[] { new ClrObject(new[] { first }), list },
                    new VariableDictionary { { list, new NList { new ClrObject(first) } } });
            }

            [TestMethod]
            public void Test2()
            {
                string first = "first";
                string second = "second";
                var list = new Variable();
                Test(
                    new Term[] {new ClrObject(new []{first, second}), list},
                    new VariableDictionary {{list, new NList { new ClrObject(first), new ClrObject(second)} }});
            }

            protected override IProgram CreateProgram()
            {
                var loader = new Loader();
                loader.ConsultLibrary("clr");
                loader.ConsultLibrary("System.Array");

                return new Program(new Module(loader.Database));
            }
        }
    }
}
