﻿using JetBrains.Annotations;
using OpcLabs.BaseLib.ObjectSpace;

namespace OpcLabs.BaseLibFactory.ObjectSpace
{
    static public class BranchInstances
    {
        [NotNull]
        static public Branch Instance0 => new Branch();

        [NotNull]
        static public Branch Instance1 => new Branch { Name = "testName" };

        [NotNull]
        static public Branch Instance2
        {
            get
            {
                var branch = new Branch {Name = "testName"};
                branch.Nodes.Add(LeafInstances.Instance0);
                branch.Nodes.Add(LeafInstances.Instance1);
                branch.Nodes.Add(Instance0);
                branch.Nodes.Add(Instance1);
                return branch;
            }
        }
    }
}
