﻿using JetBrains.Annotations;
using OpcLabs.EasyOpc.UA;
using OpcLabs.EasyOpcFactory.UA.AddressSpace;

namespace OpcLabs.EasyOpcFactory.UA
{
    static public class UAMonitoringParametersInstances
    {
        [NotNull]
        static public UAMonitoringParameters Instance1 => new UAMonitoringParameters
        {
            DataChangeFilter = UADataChangeFilterInstances.Instance1,
            QueueSize = 1001,
            SamplingInterval = 1002,
        };

        [NotNull]
        static public UAMonitoringParameters Instance2 => new UAMonitoringParameters
        {
            EventFilter = UAEventFilterInstances.Instance1,
            QueueSize = 1002,
            SamplingInterval = 1003,
        };

        [NotNull]
        static public UAMonitoringParameters Instance3 => new UAMonitoringParameters
        {
            DataChangeFilter = UADataChangeFilterInstances.Instance2,
            QueueSize = 1003,
            SamplingInterval = 1004,
            EncodingName = UAQualifiedNameInstances.Instance1
        };
    }
}
