﻿using System;
using JetBrains.Annotations;
using Microsoft.VisualStudio.TestTools.UnitTesting;
using OpcLabs.BaseLib.Threading;

namespace OpcLabs.BaseLibTest.Threading
{
    // ReSharper disable once InconsistentNaming
    public abstract class IParallelismTest
    {
        [TestMethod]
        public void ConstructTest()
        {
            CreateParallelism();
        }

        [TestMethod]
        public void PerformTest()
        {
            IParallelism parallelism = CreateParallelism();

            bool done1 = false;
            bool done2 = false;
            parallelism.Perform(new [] {
                // ReSharper disable RedundantDelegateCreation
                new Action(() => done1 = true),
                new Action(() => done2 = true)});
            // ReSharper restore RedundantDelegateCreation
            Assert.IsTrue(done1);
            Assert.IsTrue(done2);
        }



        [NotNull]
        protected abstract IParallelism CreateParallelism();
    }
}
