﻿
using System.Collections.Generic;
using JetBrains.Annotations;
using OpcLabs.EasyOpc.UA;

namespace OpcLabs.EasyOpcLiveTest.UA.Environment
{
    // ReSharper disable once InconsistentNaming
    public class OpcFoundation_UAReferenceServer : UAServer
    {
        public class EndpointDescriptorsInfo
        {
            public EndpointDescriptorsInfo([NotNull] OpcFoundation_UAReferenceServer parent)
            {
                _parent = parent;
            }

            [NotNull]
            public UAEndpointDescriptor Http => new UAEndpointDescriptor(_parent._endpointUrlStrings.Http);

            //[NotNull]
            //public UAEndpointDescriptor Https => new UAEndpointDescriptor(_parent.EndpointUrlStrings.Https);

            [NotNull]
            public UAEndpointDescriptor OpcTcp => new UAEndpointDescriptor(_parent._endpointUrlStrings.OpcTcp);

            [NotNull]
            private readonly OpcFoundation_UAReferenceServer _parent;
        }



        private class EndpointUrlStringsInfo
        {
            public EndpointUrlStringsInfo([NotNull] OpcFoundation_UAReferenceServer parent)
            {
                _parent = parent;
            }

            [NotNull]
            public string Http => "http://" + _parent.HostName + ":62540/Quickstarts/ReferenceServer";
            // https is not on by default
            [NotNull]
            public string OpcTcp => "opc.tcp://" + _parent.HostName + ":62541/Quickstarts/ReferenceServer";

            [NotNull]
            private readonly OpcFoundation_UAReferenceServer _parent;
        }



        public OpcFoundation_UAReferenceServer([NotNull] string hostName)
            : base(hostName)
        {
            EndpointDescriptors = new EndpointDescriptorsInfo(this);
            _endpointUrlStrings = new EndpointUrlStringsInfo(this);
        }

        public override IEnumerable<UAEndpointDescriptor> AllEndpointDescriptors
        {
            get
            {
                yield return EndpointDescriptors.OpcTcp;
                yield return EndpointDescriptors.Http;
                //yield return EndpointDescriptors.Https;
            }
        }

        [NotNull]
        public readonly EndpointDescriptorsInfo EndpointDescriptors;

        [NotNull]
        private readonly EndpointUrlStringsInfo _endpointUrlStrings;
    }
}
