﻿
using System.Collections.Generic;
using JetBrains.Annotations;
using OpcLabs.EasyOpc.UA;

namespace OpcLabs.EasyOpcLiveTest.UA.Environment
{
    // ReSharper disable once InconsistentNaming
    public class Prosys_UASimulationServer : UAServer
    {
        public class EndpointDescriptorsInfo
        {
            public EndpointDescriptorsInfo([NotNull] Prosys_UASimulationServer parent)
            {
                _parent = parent;
            }

            [NotNull]
            public UAEndpointDescriptor Https => new UAEndpointDescriptor(_parent._endpointUrlStrings.Https);

            [NotNull]
            public UAEndpointDescriptor OpcTcp => new UAEndpointDescriptor(_parent._endpointUrlStrings.OpcTcp);

            [NotNull]
            private readonly Prosys_UASimulationServer _parent;
        }



        private class EndpointUrlStringsInfo
        {
            public EndpointUrlStringsInfo([NotNull] Prosys_UASimulationServer parent)
            {
                _parent = parent;
            }

            [NotNull]
            public string Https => "https://" + _parent.HostName + ":53443/OPCUA/SimulationServer";
            [NotNull]
            public string OpcTcp => "opc.tcp://" + _parent.HostName + ":53530/OPCUA/SimulationServer";

            [NotNull]
            private readonly Prosys_UASimulationServer _parent;
        }



        public Prosys_UASimulationServer([NotNull] string hostName)
            : base(hostName)
        {
            EndpointDescriptors = new EndpointDescriptorsInfo(this);
            _endpointUrlStrings = new EndpointUrlStringsInfo(this);
        }

        public override IEnumerable<UAEndpointDescriptor> AllEndpointDescriptors
        {
            get
            {
                yield return EndpointDescriptors.OpcTcp;
                yield return EndpointDescriptors.Https;
            }
        }

        [NotNull]
        public readonly EndpointDescriptorsInfo EndpointDescriptors;

        [NotNull]
        private readonly EndpointUrlStringsInfo _endpointUrlStrings;
    }
}
