﻿using JetBrains.Annotations;
using Microsoft.VisualStudio.TestTools.UnitTesting;
using OpcLabs.BaseLib.Collections.ObjectModel.Extensions;
using OpcLabs.EasyOpc.AlarmsAndEvents.AddressSpace;
using OpcLabs.UnitTestLib;

namespace OpcLabs.EasyOpcTest.AlarmsAndEvents.AddressSpace
{
    public partial class AECategoryElementTest
    {
        [TestCategory("BinarySerialization")]
        [TestCategory("OpcAlarmsAndEvents")]
        [TestCategory("OpcClassic")]
        [TestMethod]
        public void BinarySerializationTest0()
        {
            Tests.BinarySerializationTest(CreateSerializationTarget0());
        }

        [TestCategory("BinarySerialization")]
        [TestCategory("OpcAlarmsAndEvents")]
        [TestCategory("OpcClassic")]
        [TestMethod]
        public void BinarySerializationTest1()
        {
            Tests.BinarySerializationTest(CreateSerializationTarget1());
        }

        [TestCategory("OpcAlarmsAndEvents")]
        [TestCategory("OpcClassic")]
        [TestCategory("XmlSerialization")]
        [TestMethod]
        public void XmlSerializationTest0()
        {
            Tests.XmlSerializationTest(CreateSerializationTarget0());
        }

        [TestCategory("OpcAlarmsAndEvents")]
        [TestCategory("OpcClassic")]
        [TestCategory("XmlSerialization")]
        [TestMethod]
        public void XmlSerializationTest1()
        {
            Tests.XmlSerializationTest(CreateSerializationTarget1());
        }

        [NotNull]
        public AECategoryElement CreateSerializationTarget0()
        {
            return new AECategoryElement();
        }

        [NotNull]
        public AECategoryElement CreateSerializationTarget1()
        {
            var categoryElement = new AECategoryElement
            {
                CategoryId = 2222,
                Description = "TestDescription"
            };

            categoryElement.AttributeElements.AddNew(_attributeElementTest.CreateSerializationTarget1());
            categoryElement.AttributeElements.AddNew(_attributeElementTest.CreateSerializationTarget2());

            categoryElement.ConditionElements.AddNew(_conditionElementTest.CreateSerializationTarget1());
            categoryElement.ConditionElements.AddNew(_conditionElementTest.CreateSerializationTarget2());

            return categoryElement;
        }

        [NotNull]
        private readonly AEAttributeElementTest _attributeElementTest = new AEAttributeElementTest();

        [NotNull]
        private readonly AEConditionElementTest _conditionElementTest = new AEConditionElementTest();
    }
}
