﻿using System.Collections.Generic;
using System.Linq;
using Microsoft.VisualStudio.TestTools.UnitTesting;
using OpcLabs.EasyOpc.UA;
using OpcLabs.EasyOpc.UA.AddressSpace.Standard;

namespace OpcLabs.OpcInteroperabilityTest.UA.Servers
{
    [TestClass]
    // ReSharper disable once InconsistentNaming
    public class MatrikonOpc_FlexOpcUASdkStandard_Test : UAInteroperabilityWorkshopTest
    {
        //public override IEnumerable<UANodeDescriptor> ArrayReadableNodes => new UANodeDescriptor[] { "" };

        //public override IEnumerable<UANodeDescriptor> ArrayWriteableNodes => new UANodeDescriptor[] { "" };

        public override IEnumerable<UANodeDescriptor> DynamicNodes => new UANodeDescriptor[]
        {
            "ns=1;s=Objects/MyFolder/MyAsynchronousVariable",
            "ns=1;s=Objects/MyFolder/MySynchronousVariable",
            UAVariableIds.Server_ServerStatus_CurrentTime
        };

        public override IEnumerable<UAEndpointDescriptor> EndpointDescriptors => new UAEndpointDescriptor[] { "opc.tcp://192.168.1.222:55001" };

        public override IEnumerable<string> ServerNotSupportedTests => base.ServerNotSupportedTests.Concat(new[]
        {
            nameof(Group001_Session_Test09_CreateSession_Https_None),  // by me
            nameof(Group001_Session_Test10_ActivateSession_X509Certificate),  // by me
            nameof(Group005_InformationModel_Test04_Browse_Read_SessionDiagnosticsArray),
            //nameof(Group102_Session2_Test01_CreateSession_UaTcp_Basic256),
            //nameof(Group102_Session2_Test02_CreateSession_UaTcp_Basic256Sha256),
            //nameof(Group102_Session2_Test03_CreateSession_Https_Basic256Sha256)
        });

        public override string Password => "matrikon";

        public override IEnumerable<UANodeDescriptor> StaticNodes => new UANodeDescriptor[] { "ns=2;i=1008" };

        public override string UserName => "user1";

        public override IEnumerable<UANodeDescriptor> WriteableNodes => new UANodeDescriptor[] { "nsu=urn:MatrikonOpcUaServer/StandardProfile ;ns=1;s=Objects/MyFolder/MyStoredVariable" };
    }
}
