﻿
using JetBrains.Annotations;
using Microsoft.VisualStudio.TestTools.UnitTesting;
using OpcLabs.BaseLib.Collections.ObjectModel.Extensions;
using OpcLabs.UnitTestLib;
using System.Diagnostics;

// Assemblies:
//   OpcLabs.BaseLibForms, Version=5.59.0.18, Culture=neutral, PublicKeyToken=6faddca41dacb409

// ReSharper disable CheckNamespace
namespace OpcLabs.BaseLibTest.Forms
// ReSharper restore CheckNamespace
// ReSharper disable RedundantNameQualifier
{

    [TestClass]
    // ReSharper disable InconsistentNaming
    // ReSharper disable PartialTypeWithSinglePart
    public partial class AutomaticValueControlTest
    // ReSharper restore PartialTypeWithSinglePart
    // ReSharper restore InconsistentNaming
    {
        public AutomaticValueControlTest()
        {
            Testers = TestSuite.GetTypeTesters(typeof(global::OpcLabs.BaseLib.Forms.AutomaticValueControl));
        }

        [TestInitialize]
        public void InitializeTest()
        {
            AssertUtilities.WriteLine("Initializing test for OpcLabs.BaseLib.Forms.AutomaticValueControl...");
        }

        [NotNull]
        public TesterCollection Testers { get; }

        [TestCategory("GeneratedTest")]
        [TestCategory("Forms")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultCtorTester()
        {
            if (!Testers.TryGetValue("DefaultCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("Forms")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultValueDataMemberTester()
        {
            if (!Testers.TryGetValue("DefaultValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }
    }

// ReSharper restore RedundantNameQualifier
}

// ReSharper disable CheckNamespace
namespace OpcLabs.BaseLibTest.Forms.Browsing
// ReSharper restore CheckNamespace
// ReSharper disable RedundantNameQualifier
{

    [TestClass]
    // ReSharper disable InconsistentNaming
    // ReSharper disable PartialTypeWithSinglePart
    public partial class BrowseColumnParametersTest
    // ReSharper restore PartialTypeWithSinglePart
    // ReSharper restore InconsistentNaming
    {
        public BrowseColumnParametersTest()
        {
            Testers = TestSuite.GetTypeTesters(typeof(global::OpcLabs.BaseLib.Forms.Browsing.BrowseColumnParameters));
        }

        [TestInitialize]
        public void InitializeTest()
        {
            AssertUtilities.WriteLine("Initializing test for OpcLabs.BaseLib.Forms.Browsing.BrowseColumnParameters...");
        }

        [NotNull]
        public TesterCollection Testers { get; }

        [TestCategory("GeneratedTest")]
        [TestCategory("Forms")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultCtorTester()
        {
            if (!Testers.TryGetValue("DefaultCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }
    }

// ReSharper restore RedundantNameQualifier
}

// ReSharper disable CheckNamespace
namespace OpcLabs.BaseLibTest.Forms.Browsing
// ReSharper restore CheckNamespace
// ReSharper disable RedundantNameQualifier
{

    [TestClass]
    // ReSharper disable InconsistentNaming
    // ReSharper disable PartialTypeWithSinglePart
    public partial class BrowseStateIconTest
    // ReSharper restore PartialTypeWithSinglePart
    // ReSharper restore InconsistentNaming
    {
        public BrowseStateIconTest()
        {
            Testers = TestSuite.GetTypeTesters(typeof(global::OpcLabs.BaseLib.Forms.Browsing.BrowseStateIcon));
        }

        [TestInitialize]
        public void InitializeTest()
        {
            AssertUtilities.WriteLine("Initializing test for OpcLabs.BaseLib.Forms.Browsing.BrowseStateIcon...");
        }

        [NotNull]
        public TesterCollection Testers { get; }

        [TestCategory("GeneratedTest")]
        [TestCategory("Forms")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultCtorTester()
        {
            if (!Testers.TryGetValue("DefaultCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }
    }

// ReSharper restore RedundantNameQualifier
}

// ReSharper disable CheckNamespace
namespace OpcLabs.BaseLibTest.Forms.Browsing
// ReSharper restore CheckNamespace
// ReSharper disable RedundantNameQualifier
{

    [TestClass]
    // ReSharper disable InconsistentNaming
    // ReSharper disable PartialTypeWithSinglePart
    public partial class CompositeNodePresentationTest
    // ReSharper restore PartialTypeWithSinglePart
    // ReSharper restore InconsistentNaming
    {
        public CompositeNodePresentationTest()
        {
            Testers = TestSuite.GetTypeTesters(typeof(global::OpcLabs.BaseLib.Forms.Browsing.CompositeNodePresentation));
        }

        [TestInitialize]
        public void InitializeTest()
        {
            AssertUtilities.WriteLine("Initializing test for OpcLabs.BaseLib.Forms.Browsing.CompositeNodePresentation...");
        }

        [NotNull]
        public TesterCollection Testers { get; }

        [TestCategory("GeneratedTest")]
        [TestCategory("Forms")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultCtorTester()
        {
            if (!Testers.TryGetValue("DefaultCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }
    }

// ReSharper restore RedundantNameQualifier
}

// ReSharper disable CheckNamespace
namespace OpcLabs.BaseLibTest.Forms.Browsing
// ReSharper restore CheckNamespace
// ReSharper disable RedundantNameQualifier
{

    [TestClass]
    // ReSharper disable InconsistentNaming
    // ReSharper disable PartialTypeWithSinglePart
    public partial class FolderNodePresentationTest
    // ReSharper restore PartialTypeWithSinglePart
    // ReSharper restore InconsistentNaming
    {
        public FolderNodePresentationTest()
        {
            Testers = TestSuite.GetTypeTesters(typeof(global::OpcLabs.BaseLib.Forms.Browsing.FolderNodePresentation));
        }

        [TestInitialize]
        public void InitializeTest()
        {
            AssertUtilities.WriteLine("Initializing test for OpcLabs.BaseLib.Forms.Browsing.FolderNodePresentation...");
        }

        [NotNull]
        public TesterCollection Testers { get; }

        [TestCategory("GeneratedTest")]
        [TestCategory("Forms")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultCtorTester()
        {
            if (!Testers.TryGetValue("DefaultCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }
    }

// ReSharper restore RedundantNameQualifier
}

// ReSharper disable CheckNamespace
namespace OpcLabs.BaseLibTest.Forms.Browsing.Generalized
// ReSharper restore CheckNamespace
// ReSharper disable RedundantNameQualifier
{

    [TestClass]
    // ReSharper disable InconsistentNaming
    // ReSharper disable PartialTypeWithSinglePart
    public partial class BrowseControlTest
    // ReSharper restore PartialTypeWithSinglePart
    // ReSharper restore InconsistentNaming
    {
        public BrowseControlTest()
        {
            Testers = TestSuite.GetTypeTesters(typeof(global::OpcLabs.BaseLib.Forms.Browsing.Generalized.BrowseControl));
        }

        [TestInitialize]
        public void InitializeTest()
        {
            AssertUtilities.WriteLine("Initializing test for OpcLabs.BaseLib.Forms.Browsing.Generalized.BrowseControl...");
        }

        [NotNull]
        public TesterCollection Testers { get; }

        [TestCategory("GeneratedTest")]
        [TestCategory("Forms")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultCtorTester()
        {
            if (!Testers.TryGetValue("DefaultCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("Forms")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultValueDataMemberTester()
        {
            if (!Testers.TryGetValue("DefaultValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("Forms")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void InvalidValueDataMemberTester()
        {
            if (!Testers.TryGetValue("InvalidValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("Forms")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ShouldSerializeTester()
        {
            if (!Testers.TryGetValue("ShouldSerializeTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }
    }

// ReSharper restore RedundantNameQualifier
}

// ReSharper disable CheckNamespace
namespace OpcLabs.BaseLibTest.Forms.Browsing.Generalized
// ReSharper restore CheckNamespace
// ReSharper disable RedundantNameQualifier
{

    [TestClass]
    // ReSharper disable InconsistentNaming
    // ReSharper disable PartialTypeWithSinglePart
    public partial class BrowseDialogTest
    // ReSharper restore PartialTypeWithSinglePart
    // ReSharper restore InconsistentNaming
    {
        public BrowseDialogTest()
        {
            Testers = TestSuite.GetTypeTesters(typeof(global::OpcLabs.BaseLib.Forms.Browsing.Generalized.BrowseDialog));
        }

        [TestInitialize]
        public void InitializeTest()
        {
            AssertUtilities.WriteLine("Initializing test for OpcLabs.BaseLib.Forms.Browsing.Generalized.BrowseDialog...");
        }

        [NotNull]
        public TesterCollection Testers { get; }

        [TestCategory("GeneratedTest")]
        [TestCategory("Forms")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultCtorTester()
        {
            if (!Testers.TryGetValue("DefaultCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("Forms")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultValueDataMemberTester()
        {
            if (!Testers.TryGetValue("DefaultValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("Forms")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ShouldSerializeTester()
        {
            if (!Testers.TryGetValue("ShouldSerializeTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }
    }

// ReSharper restore RedundantNameQualifier
}

// ReSharper disable CheckNamespace
namespace OpcLabs.BaseLibTest.Forms.Browsing.Generalized
// ReSharper restore CheckNamespace
// ReSharper disable RedundantNameQualifier
{

    [TestClass]
    // ReSharper disable InconsistentNaming
    // ReSharper disable PartialTypeWithSinglePart
    public partial class BrowseModeTest
    // ReSharper restore PartialTypeWithSinglePart
    // ReSharper restore InconsistentNaming
    {
        public BrowseModeTest()
        {
            Testers = TestSuite.GetTypeTesters(typeof(global::OpcLabs.BaseLib.Forms.Browsing.Generalized.BrowseMode));
        }

        [TestInitialize]
        public void InitializeTest()
        {
            AssertUtilities.WriteLine("Initializing test for OpcLabs.BaseLib.Forms.Browsing.Generalized.BrowseMode...");
        }

        [NotNull]
        public TesterCollection Testers { get; }

        [TestCategory("GeneratedTest")]
        [TestCategory("Forms")]
        [TestCategory("BinarySerialization")]
        [TestCategory("Serialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void BinarySerializationTester()
        {
            if (!Testers.TryGetValue("BinarySerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("Forms")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void CopyCtorTester()
        {
            if (!Testers.TryGetValue("CopyCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("Forms")]
        [TestCategory("DataContractSerialization")]
        [TestCategory("Serialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DataContractSerializationTester()
        {
            if (!Testers.TryGetValue("DataContractSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("Forms")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultCtorTester()
        {
            if (!Testers.TryGetValue("DefaultCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("Forms")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultValueDataMemberTester()
        {
            if (!Testers.TryGetValue("DefaultValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("Forms")]
        [TestCategory("Equality")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void EqualityOperatorsTester()
        {
            if (!Testers.TryGetValue("EqualityOperatorsTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("Forms")]
        [TestCategory("Equality")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void EquivalenceTester()
        {
            if (!Testers.TryGetValue("EquivalenceTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("Forms")]
        [TestCategory("Cloning")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ICloneableTester()
        {
            if (!Testers.TryGetValue("ICloneableTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("Forms")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void InvalidValueDataMemberTester()
        {
            if (!Testers.TryGetValue("InvalidValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("Forms")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void PropertyBehaviorTester()
        {
            if (!Testers.TryGetValue("PropertyBehaviorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("Forms")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ShouldSerializeTester()
        {
            if (!Testers.TryGetValue("ShouldSerializeTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("Forms")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ValidValueDataMemberTester()
        {
            if (!Testers.TryGetValue("ValidValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("Forms")]
        [TestCategory("Serialization")]
        [TestCategory("XamlSerialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void XamlSerializationTester()
        {
            if (!Testers.TryGetValue("XamlSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("Forms")]
        [TestCategory("Serialization")]
        [TestCategory("XmlSerialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void XmlSerializationTester()
        {
            if (!Testers.TryGetValue("XmlSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }
    }

// ReSharper restore RedundantNameQualifier
}

// ReSharper disable CheckNamespace
namespace OpcLabs.BaseLibTest.Forms.Browsing.Parts
// ReSharper restore CheckNamespace
// ReSharper disable RedundantNameQualifier
{

    [TestClass]
    // ReSharper disable InconsistentNaming
    // ReSharper disable PartialTypeWithSinglePart
    public partial class BrowseErrorCollectionTest
    // ReSharper restore PartialTypeWithSinglePart
    // ReSharper restore InconsistentNaming
    {
        public BrowseErrorCollectionTest()
        {
            Testers = TestSuite.GetTypeTesters(typeof(global::OpcLabs.BaseLib.Forms.Browsing.Parts.BrowseErrorCollection));
        }

        [TestInitialize]
        public void InitializeTest()
        {
            AssertUtilities.WriteLine("Initializing test for OpcLabs.BaseLib.Forms.Browsing.Parts.BrowseErrorCollection...");
        }

        [NotNull]
        public TesterCollection Testers { get; }

        [TestCategory("GeneratedTest")]
        [TestCategory("Forms")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultCtorTester()
        {
            if (!Testers.TryGetValue("DefaultCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }
    }

// ReSharper restore RedundantNameQualifier
}

// ReSharper disable CheckNamespace
namespace OpcLabs.BaseLibTest.Forms.Browsing.Parts
// ReSharper restore CheckNamespace
// ReSharper disable RedundantNameQualifier
{

    [TestClass]
    // ReSharper disable InconsistentNaming
    // ReSharper disable PartialTypeWithSinglePart
    public partial class BrowseErrorMessageTest
    // ReSharper restore PartialTypeWithSinglePart
    // ReSharper restore InconsistentNaming
    {
        public BrowseErrorMessageTest()
        {
            Testers = TestSuite.GetTypeTesters(typeof(global::OpcLabs.BaseLib.Forms.Browsing.Parts.BrowseErrorMessage));
        }

        [TestInitialize]
        public void InitializeTest()
        {
            AssertUtilities.WriteLine("Initializing test for OpcLabs.BaseLib.Forms.Browsing.Parts.BrowseErrorMessage...");
        }

        [NotNull]
        public TesterCollection Testers { get; }

        [TestCategory("GeneratedTest")]
        [TestCategory("Forms")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultCtorTester()
        {
            if (!Testers.TryGetValue("DefaultCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }
    }

// ReSharper restore RedundantNameQualifier
}

// ReSharper disable CheckNamespace
namespace OpcLabs.BaseLibTest.Forms.Browsing.Parts
// ReSharper restore CheckNamespace
// ReSharper disable RedundantNameQualifier
{

    [TestClass]
    // ReSharper disable InconsistentNaming
    // ReSharper disable PartialTypeWithSinglePart
    public partial class BrowseErrorsControlTest
    // ReSharper restore PartialTypeWithSinglePart
    // ReSharper restore InconsistentNaming
    {
        public BrowseErrorsControlTest()
        {
            Testers = TestSuite.GetTypeTesters(typeof(global::OpcLabs.BaseLib.Forms.Browsing.Parts.BrowseErrorsControl));
        }

        [TestInitialize]
        public void InitializeTest()
        {
            AssertUtilities.WriteLine("Initializing test for OpcLabs.BaseLib.Forms.Browsing.Parts.BrowseErrorsControl...");
        }

        [NotNull]
        public TesterCollection Testers { get; }

        [TestCategory("GeneratedTest")]
        [TestCategory("Forms")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultCtorTester()
        {
            if (!Testers.TryGetValue("DefaultCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("Forms")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultValueDataMemberTester()
        {
            if (!Testers.TryGetValue("DefaultValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("Forms")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ShouldSerializeTester()
        {
            if (!Testers.TryGetValue("ShouldSerializeTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }
    }

// ReSharper restore RedundantNameQualifier
}

// ReSharper disable CheckNamespace
namespace OpcLabs.BaseLibTest.Forms.Browsing.Parts
// ReSharper restore CheckNamespace
// ReSharper disable RedundantNameQualifier
{

    [TestClass]
    // ReSharper disable InconsistentNaming
    // ReSharper disable PartialTypeWithSinglePart
    public partial class BrowseErrorsEventArgsTest
    // ReSharper restore PartialTypeWithSinglePart
    // ReSharper restore InconsistentNaming
    {
        public BrowseErrorsEventArgsTest()
        {
            Testers = TestSuite.GetTypeTesters(typeof(global::OpcLabs.BaseLib.Forms.Browsing.Parts.BrowseErrorsEventArgs));
        }

        [TestInitialize]
        public void InitializeTest()
        {
            AssertUtilities.WriteLine("Initializing test for OpcLabs.BaseLib.Forms.Browsing.Parts.BrowseErrorsEventArgs...");
        }

        [NotNull]
        public TesterCollection Testers { get; }

        [TestCategory("GeneratedTest")]
        [TestCategory("Forms")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultCtorTester()
        {
            if (!Testers.TryGetValue("DefaultCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }
    }

// ReSharper restore RedundantNameQualifier
}

// ReSharper disable CheckNamespace
namespace OpcLabs.BaseLibTest.Forms.Browsing.Parts
// ReSharper restore CheckNamespace
// ReSharper disable RedundantNameQualifier
{

    [TestClass]
    // ReSharper disable InconsistentNaming
    // ReSharper disable PartialTypeWithSinglePart
    public partial class BrowseIconTest
    // ReSharper restore PartialTypeWithSinglePart
    // ReSharper restore InconsistentNaming
    {
        public BrowseIconTest()
        {
            Testers = TestSuite.GetTypeTesters(typeof(global::OpcLabs.BaseLib.Forms.Browsing.Parts.BrowseIcon));
        }

        [TestInitialize]
        public void InitializeTest()
        {
            AssertUtilities.WriteLine("Initializing test for OpcLabs.BaseLib.Forms.Browsing.Parts.BrowseIcon...");
        }

        [NotNull]
        public TesterCollection Testers { get; }

        [TestCategory("GeneratedTest")]
        [TestCategory("Forms")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultCtorTester()
        {
            if (!Testers.TryGetValue("DefaultCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }
    }

// ReSharper restore RedundantNameQualifier
}

// ReSharper disable CheckNamespace
namespace OpcLabs.BaseLibTest.Forms.Browsing.Parts
// ReSharper restore CheckNamespace
// ReSharper disable RedundantNameQualifier
{

    [TestClass]
    // ReSharper disable InconsistentNaming
    // ReSharper disable PartialTypeWithSinglePart
    public partial class BrowseNodeCommandBrowseableTest
    // ReSharper restore PartialTypeWithSinglePart
    // ReSharper restore InconsistentNaming
    {
        public BrowseNodeCommandBrowseableTest()
        {
            Testers = TestSuite.GetTypeTesters(typeof(global::OpcLabs.BaseLib.Forms.Browsing.Parts.BrowseNodeCommandBrowseable));
        }

        [TestInitialize]
        public void InitializeTest()
        {
            AssertUtilities.WriteLine("Initializing test for OpcLabs.BaseLib.Forms.Browsing.Parts.BrowseNodeCommandBrowseable...");
        }

        [NotNull]
        public TesterCollection Testers { get; }

        [TestCategory("GeneratedTest")]
        [TestCategory("Forms")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultCtorTester()
        {
            if (!Testers.TryGetValue("DefaultCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }
    }

// ReSharper restore RedundantNameQualifier
}

// ReSharper disable CheckNamespace
namespace OpcLabs.BaseLibTest.Forms.Browsing.Parts
// ReSharper restore CheckNamespace
// ReSharper disable RedundantNameQualifier
{

    [TestClass]
    // ReSharper disable InconsistentNaming
    // ReSharper disable PartialTypeWithSinglePart
    public partial class BrowseNodeCommandNodePresentationTest
    // ReSharper restore PartialTypeWithSinglePart
    // ReSharper restore InconsistentNaming
    {
        public BrowseNodeCommandNodePresentationTest()
        {
            Testers = TestSuite.GetTypeTesters(typeof(global::OpcLabs.BaseLib.Forms.Browsing.Parts.BrowseNodeCommandNodePresentation));
        }

        [TestInitialize]
        public void InitializeTest()
        {
            AssertUtilities.WriteLine("Initializing test for OpcLabs.BaseLib.Forms.Browsing.Parts.BrowseNodeCommandNodePresentation...");
        }

        [NotNull]
        public TesterCollection Testers { get; }

        [TestCategory("GeneratedTest")]
        [TestCategory("Forms")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultCtorTester()
        {
            if (!Testers.TryGetValue("DefaultCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("Forms")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void InvalidValueDataMemberTester()
        {
            if (!Testers.TryGetValue("InvalidValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }
    }

// ReSharper restore RedundantNameQualifier
}

// ReSharper disable CheckNamespace
namespace OpcLabs.BaseLibTest.Forms.Browsing.Parts
// ReSharper restore CheckNamespace
// ReSharper disable RedundantNameQualifier
{

    [TestClass]
    // ReSharper disable InconsistentNaming
    // ReSharper disable PartialTypeWithSinglePart
    public partial class BrowseNodesControlTest
    // ReSharper restore PartialTypeWithSinglePart
    // ReSharper restore InconsistentNaming
    {
        public BrowseNodesControlTest()
        {
            Testers = TestSuite.GetTypeTesters(typeof(global::OpcLabs.BaseLib.Forms.Browsing.Parts.BrowseNodesControl));
        }

        [TestInitialize]
        public void InitializeTest()
        {
            AssertUtilities.WriteLine("Initializing test for OpcLabs.BaseLib.Forms.Browsing.Parts.BrowseNodesControl...");
        }

        [NotNull]
        public TesterCollection Testers { get; }

        [TestCategory("GeneratedTest")]
        [TestCategory("Forms")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultCtorTester()
        {
            if (!Testers.TryGetValue("DefaultCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("Forms")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultValueDataMemberTester()
        {
            if (!Testers.TryGetValue("DefaultValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("Forms")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void InvalidValueDataMemberTester()
        {
            if (!Testers.TryGetValue("InvalidValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("Forms")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ShouldSerializeTester()
        {
            if (!Testers.TryGetValue("ShouldSerializeTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }
    }

// ReSharper restore RedundantNameQualifier
}

// ReSharper disable CheckNamespace
namespace OpcLabs.BaseLibTest.Forms.Browsing.Parts
// ReSharper restore CheckNamespace
// ReSharper disable RedundantNameQualifier
{

    [TestClass]
    // ReSharper disable InconsistentNaming
    // ReSharper disable PartialTypeWithSinglePart
    public partial class BrowseNodesControlOptionsTest
    // ReSharper restore PartialTypeWithSinglePart
    // ReSharper restore InconsistentNaming
    {
        public BrowseNodesControlOptionsTest()
        {
            Testers = TestSuite.GetTypeTesters(typeof(global::OpcLabs.BaseLib.Forms.Browsing.Parts.BrowseNodesControlOptions));
        }

        [TestInitialize]
        public void InitializeTest()
        {
            AssertUtilities.WriteLine("Initializing test for OpcLabs.BaseLib.Forms.Browsing.Parts.BrowseNodesControlOptions...");
        }

        [NotNull]
        public TesterCollection Testers { get; }

        [TestCategory("GeneratedTest")]
        [TestCategory("Forms")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultCtorTester()
        {
            if (!Testers.TryGetValue("DefaultCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("Forms")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultValueDataMemberTester()
        {
            if (!Testers.TryGetValue("DefaultValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }
    }

// ReSharper restore RedundantNameQualifier
}

// ReSharper disable CheckNamespace
namespace OpcLabs.BaseLibTest.Forms.Browsing.Parts
// ReSharper restore CheckNamespace
// ReSharper disable RedundantNameQualifier
{

    [TestClass]
    // ReSharper disable InconsistentNaming
    // ReSharper disable PartialTypeWithSinglePart
    public partial class BrowseNodesExceptionTest
    // ReSharper restore PartialTypeWithSinglePart
    // ReSharper restore InconsistentNaming
    {
        public BrowseNodesExceptionTest()
        {
            Testers = TestSuite.GetTypeTesters(typeof(global::OpcLabs.BaseLib.Forms.Browsing.Parts.BrowseNodesException));
        }

        [TestInitialize]
        public void InitializeTest()
        {
            AssertUtilities.WriteLine("Initializing test for OpcLabs.BaseLib.Forms.Browsing.Parts.BrowseNodesException...");
        }

        [NotNull]
        public TesterCollection Testers { get; }

        [TestCategory("GeneratedTest")]
        [TestCategory("Forms")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultCtorTester()
        {
            if (!Testers.TryGetValue("DefaultCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }
    }

// ReSharper restore RedundantNameQualifier
}

// ReSharper disable CheckNamespace
namespace OpcLabs.BaseLibTest.Forms.Browsing.Parts
// ReSharper restore CheckNamespace
// ReSharper disable RedundantNameQualifier
{

    [TestClass]
    // ReSharper disable InconsistentNaming
    // ReSharper disable PartialTypeWithSinglePart
    public partial class BrowseNodesFormTest
    // ReSharper restore PartialTypeWithSinglePart
    // ReSharper restore InconsistentNaming
    {
        public BrowseNodesFormTest()
        {
            Testers = TestSuite.GetTypeTesters(typeof(global::OpcLabs.BaseLib.Forms.Browsing.Parts.BrowseNodesForm));
        }

        [TestInitialize]
        public void InitializeTest()
        {
            AssertUtilities.WriteLine("Initializing test for OpcLabs.BaseLib.Forms.Browsing.Parts.BrowseNodesForm...");
        }

        [NotNull]
        public TesterCollection Testers { get; }

        [TestCategory("GeneratedTest")]
        [TestCategory("Forms")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultCtorTester()
        {
            if (!Testers.TryGetValue("DefaultCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("Forms")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultValueDataMemberTester()
        {
            if (!Testers.TryGetValue("DefaultValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("Forms")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void InvalidValueDataMemberTester()
        {
            if (!Testers.TryGetValue("InvalidValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }
    }

// ReSharper restore RedundantNameQualifier
}

// ReSharper disable CheckNamespace
namespace OpcLabs.BaseLibTest.Forms.Browsing.Parts
// ReSharper restore CheckNamespace
// ReSharper disable RedundantNameQualifier
{

    [TestClass]
    // ReSharper disable InconsistentNaming
    // ReSharper disable PartialTypeWithSinglePart
    public partial class BrowseNodesPresentationOptionsTest
    // ReSharper restore PartialTypeWithSinglePart
    // ReSharper restore InconsistentNaming
    {
        public BrowseNodesPresentationOptionsTest()
        {
            Testers = TestSuite.GetTypeTesters(typeof(global::OpcLabs.BaseLib.Forms.Browsing.Parts.BrowseNodesPresentationOptions));
        }

        [TestInitialize]
        public void InitializeTest()
        {
            AssertUtilities.WriteLine("Initializing test for OpcLabs.BaseLib.Forms.Browsing.Parts.BrowseNodesPresentationOptions...");
        }

        [NotNull]
        public TesterCollection Testers { get; }

        [TestCategory("GeneratedTest")]
        [TestCategory("Forms")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultCtorTester()
        {
            if (!Testers.TryGetValue("DefaultCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }
    }

// ReSharper restore RedundantNameQualifier
}

// ReSharper disable CheckNamespace
namespace OpcLabs.BaseLibTest.Forms.Browsing.Parts
// ReSharper restore CheckNamespace
// ReSharper disable RedundantNameQualifier
{

    [TestClass]
    // ReSharper disable InconsistentNaming
    // ReSharper disable PartialTypeWithSinglePart
    public partial class DefaultBrowsePresentationTest
    // ReSharper restore PartialTypeWithSinglePart
    // ReSharper restore InconsistentNaming
    {
        public DefaultBrowsePresentationTest()
        {
            Testers = TestSuite.GetTypeTesters(typeof(global::OpcLabs.BaseLib.Forms.Browsing.Parts.DefaultBrowsePresentation));
        }

        [TestInitialize]
        public void InitializeTest()
        {
            AssertUtilities.WriteLine("Initializing test for OpcLabs.BaseLib.Forms.Browsing.Parts.DefaultBrowsePresentation...");
        }

        [NotNull]
        public TesterCollection Testers { get; }

        [TestCategory("GeneratedTest")]
        [TestCategory("Forms")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultCtorTester()
        {
            if (!Testers.TryGetValue("DefaultCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }
    }

// ReSharper restore RedundantNameQualifier
}

// ReSharper disable CheckNamespace
namespace OpcLabs.BaseLibTest.Forms.Browsing.Parts
// ReSharper restore CheckNamespace
// ReSharper disable RedundantNameQualifier
{

    [TestClass]
    // ReSharper disable InconsistentNaming
    // ReSharper disable PartialTypeWithSinglePart
    public partial class DefaultNodePresentationTest
    // ReSharper restore PartialTypeWithSinglePart
    // ReSharper restore InconsistentNaming
    {
        public DefaultNodePresentationTest()
        {
            Testers = TestSuite.GetTypeTesters(typeof(global::OpcLabs.BaseLib.Forms.Browsing.Parts.DefaultNodePresentation));
        }

        [TestInitialize]
        public void InitializeTest()
        {
            AssertUtilities.WriteLine("Initializing test for OpcLabs.BaseLib.Forms.Browsing.Parts.DefaultNodePresentation...");
        }

        [NotNull]
        public TesterCollection Testers { get; }

        [TestCategory("GeneratedTest")]
        [TestCategory("Forms")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultCtorTester()
        {
            if (!Testers.TryGetValue("DefaultCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }
    }

// ReSharper restore RedundantNameQualifier
}

// ReSharper disable CheckNamespace
namespace OpcLabs.BaseLibTest.Forms.Browsing
// ReSharper restore CheckNamespace
// ReSharper disable RedundantNameQualifier
{

    [TestClass]
    // ReSharper disable InconsistentNaming
    // ReSharper disable PartialTypeWithSinglePart
    public partial class RootNodePresentationTest
    // ReSharper restore PartialTypeWithSinglePart
    // ReSharper restore InconsistentNaming
    {
        public RootNodePresentationTest()
        {
            Testers = TestSuite.GetTypeTesters(typeof(global::OpcLabs.BaseLib.Forms.Browsing.RootNodePresentation));
        }

        [TestInitialize]
        public void InitializeTest()
        {
            AssertUtilities.WriteLine("Initializing test for OpcLabs.BaseLib.Forms.Browsing.RootNodePresentation...");
        }

        [NotNull]
        public TesterCollection Testers { get; }

        [TestCategory("GeneratedTest")]
        [TestCategory("Forms")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultCtorTester()
        {
            if (!Testers.TryGetValue("DefaultCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("Forms")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void InvalidValueDataMemberTester()
        {
            if (!Testers.TryGetValue("InvalidValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }
    }

// ReSharper restore RedundantNameQualifier
}

// ReSharper disable CheckNamespace
namespace OpcLabs.BaseLibTest.Forms.Browsing.Specialized
// ReSharper restore CheckNamespace
// ReSharper disable RedundantNameQualifier
{

    [TestClass]
    // ReSharper disable InconsistentNaming
    // ReSharper disable PartialTypeWithSinglePart
    public partial class ComputerBrowserDialogTest
    // ReSharper restore PartialTypeWithSinglePart
    // ReSharper restore InconsistentNaming
    {
        public ComputerBrowserDialogTest()
        {
            Testers = TestSuite.GetTypeTesters(typeof(global::OpcLabs.BaseLib.Forms.Browsing.Specialized.ComputerBrowserDialog));
        }

        [TestInitialize]
        public void InitializeTest()
        {
            AssertUtilities.WriteLine("Initializing test for OpcLabs.BaseLib.Forms.Browsing.Specialized.ComputerBrowserDialog...");
        }

        [NotNull]
        public TesterCollection Testers { get; }

        [TestCategory("GeneratedTest")]
        [TestCategory("Forms")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultCtorTester()
        {
            if (!Testers.TryGetValue("DefaultCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("Forms")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultValueDataMemberTester()
        {
            if (!Testers.TryGetValue("DefaultValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("Forms")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void InvalidValueDataMemberTester()
        {
            if (!Testers.TryGetValue("InvalidValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }
    }

// ReSharper restore RedundantNameQualifier
}

// ReSharper disable CheckNamespace
namespace OpcLabs.BaseLibTest.Forms.Browsing.Specialized.Internal
// ReSharper restore CheckNamespace
// ReSharper disable RedundantNameQualifier
{

    [TestClass]
    // ReSharper disable InconsistentNaming
    // ReSharper disable PartialTypeWithSinglePart
    public partial class ComputerNodePresentationTest
    // ReSharper restore PartialTypeWithSinglePart
    // ReSharper restore InconsistentNaming
    {
        public ComputerNodePresentationTest()
        {
            Testers = TestSuite.GetTypeTesters(typeof(global::OpcLabs.BaseLib.Forms.Browsing.Specialized.Internal.ComputerNodePresentation));
        }

        [TestInitialize]
        public void InitializeTest()
        {
            AssertUtilities.WriteLine("Initializing test for OpcLabs.BaseLib.Forms.Browsing.Specialized.Internal.ComputerNodePresentation...");
        }

        [NotNull]
        public TesterCollection Testers { get; }

        [TestCategory("GeneratedTest")]
        [TestCategory("Forms")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultCtorTester()
        {
            if (!Testers.TryGetValue("DefaultCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("Forms")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void InvalidValueDataMemberTester()
        {
            if (!Testers.TryGetValue("InvalidValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }
    }

// ReSharper restore RedundantNameQualifier
}

// ReSharper disable CheckNamespace
namespace OpcLabs.BaseLibTest.Forms.Browsing.Specialized.Internal
// ReSharper restore CheckNamespace
// ReSharper disable RedundantNameQualifier
{

    [TestClass]
    // ReSharper disable InconsistentNaming
    // ReSharper disable PartialTypeWithSinglePart
    public partial class EndpointBrowsePresentationTest
    // ReSharper restore PartialTypeWithSinglePart
    // ReSharper restore InconsistentNaming
    {
        public EndpointBrowsePresentationTest()
        {
            Testers = TestSuite.GetTypeTesters(typeof(global::OpcLabs.BaseLib.Forms.Browsing.Specialized.Internal.EndpointBrowsePresentation));
        }

        [TestInitialize]
        public void InitializeTest()
        {
            AssertUtilities.WriteLine("Initializing test for OpcLabs.BaseLib.Forms.Browsing.Specialized.Internal.EndpointBrowsePresentation...");
        }

        [NotNull]
        public TesterCollection Testers { get; }

        [TestCategory("GeneratedTest")]
        [TestCategory("Forms")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultCtorTester()
        {
            if (!Testers.TryGetValue("DefaultCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("Forms")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void InvalidValueDataMemberTester()
        {
            if (!Testers.TryGetValue("InvalidValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }
    }

// ReSharper restore RedundantNameQualifier
}

// ReSharper disable CheckNamespace
namespace OpcLabs.BaseLibTest.Forms.Browsing.Specialized.Internal
// ReSharper restore CheckNamespace
// ReSharper disable RedundantNameQualifier
{

    [TestClass]
    // ReSharper disable InconsistentNaming
    // ReSharper disable PartialTypeWithSinglePart
    public partial class FileSystemBrowseControlTest
    // ReSharper restore PartialTypeWithSinglePart
    // ReSharper restore InconsistentNaming
    {
        public FileSystemBrowseControlTest()
        {
            Testers = TestSuite.GetTypeTesters(typeof(global::OpcLabs.BaseLib.Forms.Browsing.Specialized.Internal.FileSystemBrowseControl));
        }

        [TestInitialize]
        public void InitializeTest()
        {
            AssertUtilities.WriteLine("Initializing test for OpcLabs.BaseLib.Forms.Browsing.Specialized.Internal.FileSystemBrowseControl...");
        }

        [NotNull]
        public TesterCollection Testers { get; }

        [TestCategory("GeneratedTest")]
        [TestCategory("Forms")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultCtorTester()
        {
            if (!Testers.TryGetValue("DefaultCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("Forms")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultValueDataMemberTester()
        {
            if (!Testers.TryGetValue("DefaultValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("Forms")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void InvalidValueDataMemberTester()
        {
            if (!Testers.TryGetValue("InvalidValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("Forms")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ShouldSerializeTester()
        {
            if (!Testers.TryGetValue("ShouldSerializeTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }
    }

// ReSharper restore RedundantNameQualifier
}

// ReSharper disable CheckNamespace
namespace OpcLabs.BaseLibTest.Forms.Browsing.Specialized.Internal
// ReSharper restore CheckNamespace
// ReSharper disable RedundantNameQualifier
{

    [TestClass]
    // ReSharper disable InconsistentNaming
    // ReSharper disable PartialTypeWithSinglePart
    public partial class FileSystemBrowseInputsTest
    // ReSharper restore PartialTypeWithSinglePart
    // ReSharper restore InconsistentNaming
    {
        public FileSystemBrowseInputsTest()
        {
            Testers = TestSuite.GetTypeTesters(typeof(global::OpcLabs.BaseLib.Forms.Browsing.Specialized.Internal.FileSystemBrowseInputs));
        }

        [TestInitialize]
        public void InitializeTest()
        {
            AssertUtilities.WriteLine("Initializing test for OpcLabs.BaseLib.Forms.Browsing.Specialized.Internal.FileSystemBrowseInputs...");
        }

        [NotNull]
        public TesterCollection Testers { get; }

        [TestCategory("GeneratedTest")]
        [TestCategory("Forms")]
        [TestCategory("BinarySerialization")]
        [TestCategory("Serialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void BinarySerializationTester()
        {
            if (!Testers.TryGetValue("BinarySerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("Forms")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void CopyCtorTester()
        {
            if (!Testers.TryGetValue("CopyCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("Forms")]
        [TestCategory("DataContractSerialization")]
        [TestCategory("Serialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DataContractSerializationTester()
        {
            if (!Testers.TryGetValue("DataContractSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("Forms")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultCtorTester()
        {
            if (!Testers.TryGetValue("DefaultCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("Forms")]
        [TestCategory("Equality")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void EqualityOperatorsTester()
        {
            if (!Testers.TryGetValue("EqualityOperatorsTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("Forms")]
        [TestCategory("Equality")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void EquivalenceTester()
        {
            if (!Testers.TryGetValue("EquivalenceTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("Forms")]
        [TestCategory("Cloning")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ICloneableTester()
        {
            if (!Testers.TryGetValue("ICloneableTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("Forms")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void InvalidValueDataMemberTester()
        {
            if (!Testers.TryGetValue("InvalidValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("Forms")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void PropertyBehaviorTester()
        {
            if (!Testers.TryGetValue("PropertyBehaviorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("Forms")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ValidValueDataMemberTester()
        {
            if (!Testers.TryGetValue("ValidValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("Forms")]
        [TestCategory("Serialization")]
        [TestCategory("XamlSerialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void XamlSerializationTester()
        {
            if (!Testers.TryGetValue("XamlSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("Forms")]
        [TestCategory("Serialization")]
        [TestCategory("XmlSerialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void XmlSerializationTester()
        {
            if (!Testers.TryGetValue("XmlSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }
    }

// ReSharper restore RedundantNameQualifier
}

// ReSharper disable CheckNamespace
namespace OpcLabs.BaseLibTest.Forms.Browsing.Specialized.Internal
// ReSharper restore CheckNamespace
// ReSharper disable RedundantNameQualifier
{

    [TestClass]
    // ReSharper disable InconsistentNaming
    // ReSharper disable PartialTypeWithSinglePart
    public partial class FileSystemBrowseInputsOutputsTest
    // ReSharper restore PartialTypeWithSinglePart
    // ReSharper restore InconsistentNaming
    {
        public FileSystemBrowseInputsOutputsTest()
        {
            Testers = TestSuite.GetTypeTesters(typeof(global::OpcLabs.BaseLib.Forms.Browsing.Specialized.Internal.FileSystemBrowseInputsOutputs));
        }

        [TestInitialize]
        public void InitializeTest()
        {
            AssertUtilities.WriteLine("Initializing test for OpcLabs.BaseLib.Forms.Browsing.Specialized.Internal.FileSystemBrowseInputsOutputs...");
        }

        [NotNull]
        public TesterCollection Testers { get; }

        [TestCategory("GeneratedTest")]
        [TestCategory("Forms")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultCtorTester()
        {
            if (!Testers.TryGetValue("DefaultCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("Forms")]
        [TestCategory("Equality")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void EqualityOperatorsTester()
        {
            if (!Testers.TryGetValue("EqualityOperatorsTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("Forms")]
        [TestCategory("Equality")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void EquivalenceTester()
        {
            if (!Testers.TryGetValue("EquivalenceTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("Forms")]
        [TestCategory("Cloning")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ICloneableTester()
        {
            if (!Testers.TryGetValue("ICloneableTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("Forms")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void InvalidValueDataMemberTester()
        {
            if (!Testers.TryGetValue("InvalidValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("Forms")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void PropertyBehaviorTester()
        {
            if (!Testers.TryGetValue("PropertyBehaviorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("Forms")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ValidValueDataMemberTester()
        {
            if (!Testers.TryGetValue("ValidValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }
    }

// ReSharper restore RedundantNameQualifier
}

// ReSharper disable CheckNamespace
namespace OpcLabs.BaseLibTest.Forms.Browsing.Specialized.Internal
// ReSharper restore CheckNamespace
// ReSharper disable RedundantNameQualifier
{

    [TestClass]
    // ReSharper disable InconsistentNaming
    // ReSharper disable PartialTypeWithSinglePart
    public partial class FileSystemBrowseModeTest
    // ReSharper restore PartialTypeWithSinglePart
    // ReSharper restore InconsistentNaming
    {
        public FileSystemBrowseModeTest()
        {
            Testers = TestSuite.GetTypeTesters(typeof(global::OpcLabs.BaseLib.Forms.Browsing.Specialized.Internal.FileSystemBrowseMode));
        }

        [TestInitialize]
        public void InitializeTest()
        {
            AssertUtilities.WriteLine("Initializing test for OpcLabs.BaseLib.Forms.Browsing.Specialized.Internal.FileSystemBrowseMode...");
        }

        [NotNull]
        public TesterCollection Testers { get; }

        [TestCategory("GeneratedTest")]
        [TestCategory("Forms")]
        [TestCategory("BinarySerialization")]
        [TestCategory("Serialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void BinarySerializationTester()
        {
            if (!Testers.TryGetValue("BinarySerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("Forms")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void CopyCtorTester()
        {
            if (!Testers.TryGetValue("CopyCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("Forms")]
        [TestCategory("DataContractSerialization")]
        [TestCategory("Serialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DataContractSerializationTester()
        {
            if (!Testers.TryGetValue("DataContractSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("Forms")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultCtorTester()
        {
            if (!Testers.TryGetValue("DefaultCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("Forms")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultValueDataMemberTester()
        {
            if (!Testers.TryGetValue("DefaultValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("Forms")]
        [TestCategory("Equality")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void EqualityOperatorsTester()
        {
            if (!Testers.TryGetValue("EqualityOperatorsTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("Forms")]
        [TestCategory("Equality")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void EquivalenceTester()
        {
            if (!Testers.TryGetValue("EquivalenceTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("Forms")]
        [TestCategory("Cloning")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ICloneableTester()
        {
            if (!Testers.TryGetValue("ICloneableTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("Forms")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void InvalidValueDataMemberTester()
        {
            if (!Testers.TryGetValue("InvalidValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("Forms")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void PropertyBehaviorTester()
        {
            if (!Testers.TryGetValue("PropertyBehaviorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("Forms")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ShouldSerializeTester()
        {
            if (!Testers.TryGetValue("ShouldSerializeTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("Forms")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ValidValueDataMemberTester()
        {
            if (!Testers.TryGetValue("ValidValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("Forms")]
        [TestCategory("Serialization")]
        [TestCategory("XamlSerialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void XamlSerializationTester()
        {
            if (!Testers.TryGetValue("XamlSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("Forms")]
        [TestCategory("Serialization")]
        [TestCategory("XmlSerialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void XmlSerializationTester()
        {
            if (!Testers.TryGetValue("XmlSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }
    }

// ReSharper restore RedundantNameQualifier
}

// ReSharper disable CheckNamespace
namespace OpcLabs.BaseLibTest.Forms.Browsing.Specialized.Internal
// ReSharper restore CheckNamespace
// ReSharper disable RedundantNameQualifier
{

    [TestClass]
    // ReSharper disable InconsistentNaming
    // ReSharper disable PartialTypeWithSinglePart
    public partial class FileSystemBrowseOutputsTest
    // ReSharper restore PartialTypeWithSinglePart
    // ReSharper restore InconsistentNaming
    {
        public FileSystemBrowseOutputsTest()
        {
            Testers = TestSuite.GetTypeTesters(typeof(global::OpcLabs.BaseLib.Forms.Browsing.Specialized.Internal.FileSystemBrowseOutputs));
        }

        [TestInitialize]
        public void InitializeTest()
        {
            AssertUtilities.WriteLine("Initializing test for OpcLabs.BaseLib.Forms.Browsing.Specialized.Internal.FileSystemBrowseOutputs...");
        }

        [NotNull]
        public TesterCollection Testers { get; }

        [TestCategory("GeneratedTest")]
        [TestCategory("Forms")]
        [TestCategory("BinarySerialization")]
        [TestCategory("Serialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void BinarySerializationTester()
        {
            if (!Testers.TryGetValue("BinarySerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("Forms")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void CopyCtorTester()
        {
            if (!Testers.TryGetValue("CopyCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("Forms")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultCtorTester()
        {
            if (!Testers.TryGetValue("DefaultCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("Forms")]
        [TestCategory("Equality")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void EqualityOperatorsTester()
        {
            if (!Testers.TryGetValue("EqualityOperatorsTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("Forms")]
        [TestCategory("Equality")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void EquivalenceTester()
        {
            if (!Testers.TryGetValue("EquivalenceTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("Forms")]
        [TestCategory("Cloning")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ICloneableTester()
        {
            if (!Testers.TryGetValue("ICloneableTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("Forms")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void InvalidValueDataMemberTester()
        {
            if (!Testers.TryGetValue("InvalidValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("Forms")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void PropertyBehaviorTester()
        {
            if (!Testers.TryGetValue("PropertyBehaviorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("Forms")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ValidValueDataMemberTester()
        {
            if (!Testers.TryGetValue("ValidValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("Forms")]
        [TestCategory("Serialization")]
        [TestCategory("XamlSerialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void XamlSerializationTester()
        {
            if (!Testers.TryGetValue("XamlSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }
    }

// ReSharper restore RedundantNameQualifier
}

// ReSharper disable CheckNamespace
namespace OpcLabs.BaseLibTest.Forms.Browsing.Specialized.Internal
// ReSharper restore CheckNamespace
// ReSharper disable RedundantNameQualifier
{

    [TestClass]
    // ReSharper disable InconsistentNaming
    // ReSharper disable PartialTypeWithSinglePart
    public partial class FileSystemInfoNodePresentationTest
    // ReSharper restore PartialTypeWithSinglePart
    // ReSharper restore InconsistentNaming
    {
        public FileSystemInfoNodePresentationTest()
        {
            Testers = TestSuite.GetTypeTesters(typeof(global::OpcLabs.BaseLib.Forms.Browsing.Specialized.Internal.FileSystemInfoNodePresentation));
        }

        [TestInitialize]
        public void InitializeTest()
        {
            AssertUtilities.WriteLine("Initializing test for OpcLabs.BaseLib.Forms.Browsing.Specialized.Internal.FileSystemInfoNodePresentation...");
        }

        [NotNull]
        public TesterCollection Testers { get; }

        [TestCategory("GeneratedTest")]
        [TestCategory("Forms")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultCtorTester()
        {
            if (!Testers.TryGetValue("DefaultCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("Forms")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void InvalidValueDataMemberTester()
        {
            if (!Testers.TryGetValue("InvalidValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }
    }

// ReSharper restore RedundantNameQualifier
}

// ReSharper disable CheckNamespace
namespace OpcLabs.BaseLibTest.Forms.Browsing.Specialized.Internal
// ReSharper restore CheckNamespace
// ReSharper disable RedundantNameQualifier
{

    [TestClass]
    // ReSharper disable InconsistentNaming
    // ReSharper disable PartialTypeWithSinglePart
    public partial class HostAndEndpointBrowsePresentationTest
    // ReSharper restore PartialTypeWithSinglePart
    // ReSharper restore InconsistentNaming
    {
        public HostAndEndpointBrowsePresentationTest()
        {
            Testers = TestSuite.GetTypeTesters(typeof(global::OpcLabs.BaseLib.Forms.Browsing.Specialized.Internal.HostAndEndpointBrowsePresentation));
        }

        [TestInitialize]
        public void InitializeTest()
        {
            AssertUtilities.WriteLine("Initializing test for OpcLabs.BaseLib.Forms.Browsing.Specialized.Internal.HostAndEndpointBrowsePresentation...");
        }

        [NotNull]
        public TesterCollection Testers { get; }

        [TestCategory("GeneratedTest")]
        [TestCategory("Forms")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultCtorTester()
        {
            if (!Testers.TryGetValue("DefaultCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("Forms")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void InvalidValueDataMemberTester()
        {
            if (!Testers.TryGetValue("InvalidValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }
    }

// ReSharper restore RedundantNameQualifier
}

// ReSharper disable CheckNamespace
namespace OpcLabs.BaseLibTest.Forms.Browsing.Specialized.Internal
// ReSharper restore CheckNamespace
// ReSharper disable RedundantNameQualifier
{

    [TestClass]
    // ReSharper disable InconsistentNaming
    // ReSharper disable PartialTypeWithSinglePart
    public partial class NetworkDomainNodePresentationTest
    // ReSharper restore PartialTypeWithSinglePart
    // ReSharper restore InconsistentNaming
    {
        public NetworkDomainNodePresentationTest()
        {
            Testers = TestSuite.GetTypeTesters(typeof(global::OpcLabs.BaseLib.Forms.Browsing.Specialized.Internal.NetworkDomainNodePresentation));
        }

        [TestInitialize]
        public void InitializeTest()
        {
            AssertUtilities.WriteLine("Initializing test for OpcLabs.BaseLib.Forms.Browsing.Specialized.Internal.NetworkDomainNodePresentation...");
        }

        [NotNull]
        public TesterCollection Testers { get; }

        [TestCategory("GeneratedTest")]
        [TestCategory("Forms")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultCtorTester()
        {
            if (!Testers.TryGetValue("DefaultCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }
    }

// ReSharper restore RedundantNameQualifier
}

// ReSharper disable CheckNamespace
namespace OpcLabs.BaseLibTest.Forms.CommandRouting.Runtime
// ReSharper restore CheckNamespace
// ReSharper disable RedundantNameQualifier
{

    [TestClass]
    // ReSharper disable InconsistentNaming
    // ReSharper disable PartialTypeWithSinglePart
    public partial class UICommandTest
    // ReSharper restore PartialTypeWithSinglePart
    // ReSharper restore InconsistentNaming
    {
        public UICommandTest()
        {
            Testers = TestSuite.GetTypeTesters(typeof(global::OpcLabs.BaseLib.Forms.CommandRouting.Runtime.UICommand));
        }

        [TestInitialize]
        public void InitializeTest()
        {
            AssertUtilities.WriteLine("Initializing test for OpcLabs.BaseLib.Forms.CommandRouting.Runtime.UICommand...");
        }

        [NotNull]
        public TesterCollection Testers { get; }

        [TestCategory("GeneratedTest")]
        [TestCategory("Forms")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultCtorTester()
        {
            if (!Testers.TryGetValue("DefaultCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }
    }

// ReSharper restore RedundantNameQualifier
}

// ReSharper disable CheckNamespace
namespace OpcLabs.BaseLibTest.Forms.CommandRouting.Runtime
// ReSharper restore CheckNamespace
// ReSharper disable RedundantNameQualifier
{

    [TestClass]
    // ReSharper disable InconsistentNaming
    // ReSharper disable PartialTypeWithSinglePart
    public partial class UICommandEventArgsTest
    // ReSharper restore PartialTypeWithSinglePart
    // ReSharper restore InconsistentNaming
    {
        public UICommandEventArgsTest()
        {
            Testers = TestSuite.GetTypeTesters(typeof(global::OpcLabs.BaseLib.Forms.CommandRouting.Runtime.UICommandEventArgs));
        }

        [TestInitialize]
        public void InitializeTest()
        {
            AssertUtilities.WriteLine("Initializing test for OpcLabs.BaseLib.Forms.CommandRouting.Runtime.UICommandEventArgs...");
        }

        [NotNull]
        public TesterCollection Testers { get; }

        [TestCategory("GeneratedTest")]
        [TestCategory("Forms")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultCtorTester()
        {
            if (!Testers.TryGetValue("DefaultCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }
    }

// ReSharper restore RedundantNameQualifier
}

// ReSharper disable CheckNamespace
namespace OpcLabs.BaseLibTest.Forms.CommandRouting.Runtime
// ReSharper restore CheckNamespace
// ReSharper disable RedundantNameQualifier
{

    [TestClass]
    // ReSharper disable InconsistentNaming
    // ReSharper disable PartialTypeWithSinglePart
    public partial class UICommandResultInformationTest
    // ReSharper restore PartialTypeWithSinglePart
    // ReSharper restore InconsistentNaming
    {
        public UICommandResultInformationTest()
        {
            Testers = TestSuite.GetTypeTesters(typeof(global::OpcLabs.BaseLib.Forms.CommandRouting.Runtime.UICommandResultInformation));
        }

        [TestInitialize]
        public void InitializeTest()
        {
            AssertUtilities.WriteLine("Initializing test for OpcLabs.BaseLib.Forms.CommandRouting.Runtime.UICommandResultInformation...");
        }

        [NotNull]
        public TesterCollection Testers { get; }

        [TestCategory("GeneratedTest")]
        [TestCategory("Forms")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultCtorTester()
        {
            if (!Testers.TryGetValue("DefaultCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }
    }

// ReSharper restore RedundantNameQualifier
}

// ReSharper disable CheckNamespace
namespace OpcLabs.BaseLibTest.Forms.CommandRouting
// ReSharper restore CheckNamespace
// ReSharper disable RedundantNameQualifier
{

    [TestClass]
    // ReSharper disable InconsistentNaming
    // ReSharper disable PartialTypeWithSinglePart
    public partial class UICommandRouterTest
    // ReSharper restore PartialTypeWithSinglePart
    // ReSharper restore InconsistentNaming
    {
        public UICommandRouterTest()
        {
            Testers = TestSuite.GetTypeTesters(typeof(global::OpcLabs.BaseLib.Forms.CommandRouting.UICommandRouter));
        }

        [TestInitialize]
        public void InitializeTest()
        {
            AssertUtilities.WriteLine("Initializing test for OpcLabs.BaseLib.Forms.CommandRouting.UICommandRouter...");
        }

        [NotNull]
        public TesterCollection Testers { get; }

        [TestCategory("GeneratedTest")]
        [TestCategory("Forms")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultCtorTester()
        {
            if (!Testers.TryGetValue("DefaultCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("Forms")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultValueDataMemberTester()
        {
            if (!Testers.TryGetValue("DefaultValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }
    }

// ReSharper restore RedundantNameQualifier
}

// ReSharper disable CheckNamespace
namespace OpcLabs.BaseLibTest.Forms.CommandRouting
// ReSharper restore CheckNamespace
// ReSharper disable RedundantNameQualifier
{

    [TestClass]
    // ReSharper disable InconsistentNaming
    // ReSharper disable PartialTypeWithSinglePart
    public partial class UICommandRoutingExceptionTest
    // ReSharper restore PartialTypeWithSinglePart
    // ReSharper restore InconsistentNaming
    {
        public UICommandRoutingExceptionTest()
        {
            Testers = TestSuite.GetTypeTesters(typeof(global::OpcLabs.BaseLib.Forms.CommandRouting.UICommandRoutingException));
        }

        [TestInitialize]
        public void InitializeTest()
        {
            AssertUtilities.WriteLine("Initializing test for OpcLabs.BaseLib.Forms.CommandRouting.UICommandRoutingException...");
        }

        [NotNull]
        public TesterCollection Testers { get; }

        [TestCategory("GeneratedTest")]
        [TestCategory("Forms")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultCtorTester()
        {
            if (!Testers.TryGetValue("DefaultCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }
    }

// ReSharper restore RedundantNameQualifier
}

// ReSharper disable CheckNamespace
namespace OpcLabs.BaseLibTest.Forms.CommandRouting
// ReSharper restore CheckNamespace
// ReSharper disable RedundantNameQualifier
{

    [TestClass]
    // ReSharper disable InconsistentNaming
    // ReSharper disable PartialTypeWithSinglePart
    public partial class UICommandTargetTest
    // ReSharper restore PartialTypeWithSinglePart
    // ReSharper restore InconsistentNaming
    {
        public UICommandTargetTest()
        {
            Testers = TestSuite.GetTypeTesters(typeof(global::OpcLabs.BaseLib.Forms.CommandRouting.UICommandTarget));
        }

        [TestInitialize]
        public void InitializeTest()
        {
            AssertUtilities.WriteLine("Initializing test for OpcLabs.BaseLib.Forms.CommandRouting.UICommandTarget...");
        }

        [NotNull]
        public TesterCollection Testers { get; }

        [TestCategory("GeneratedTest")]
        [TestCategory("Forms")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultCtorTester()
        {
            if (!Testers.TryGetValue("DefaultCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }
    }

// ReSharper restore RedundantNameQualifier
}

// ReSharper disable CheckNamespace
namespace OpcLabs.BaseLibTest.Forms.CommandRouting
// ReSharper restore CheckNamespace
// ReSharper disable RedundantNameQualifier
{

    [TestClass]
    // ReSharper disable InconsistentNaming
    // ReSharper disable PartialTypeWithSinglePart
    public partial class UISourceObjectAttributeTest
    // ReSharper restore PartialTypeWithSinglePart
    // ReSharper restore InconsistentNaming
    {
        public UISourceObjectAttributeTest()
        {
            Testers = TestSuite.GetTypeTesters(typeof(global::OpcLabs.BaseLib.Forms.CommandRouting.UISourceObjectAttribute));
        }

        [TestInitialize]
        public void InitializeTest()
        {
            AssertUtilities.WriteLine("Initializing test for OpcLabs.BaseLib.Forms.CommandRouting.UISourceObjectAttribute...");
        }

        [NotNull]
        public TesterCollection Testers { get; }

        [TestCategory("GeneratedTest")]
        [TestCategory("Forms")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultCtorTester()
        {
            if (!Testers.TryGetValue("DefaultCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }
    }

// ReSharper restore RedundantNameQualifier
}

// ReSharper disable CheckNamespace
namespace OpcLabs.BaseLibTest.Forms.Common
// ReSharper restore CheckNamespace
// ReSharper disable RedundantNameQualifier
{

    [TestClass]
    // ReSharper disable InconsistentNaming
    // ReSharper disable PartialTypeWithSinglePart
    public partial class AboutFormTest
    // ReSharper restore PartialTypeWithSinglePart
    // ReSharper restore InconsistentNaming
    {
        public AboutFormTest()
        {
            Testers = TestSuite.GetTypeTesters(typeof(global::OpcLabs.BaseLib.Forms.Common.AboutForm));
        }

        [TestInitialize]
        public void InitializeTest()
        {
            AssertUtilities.WriteLine("Initializing test for OpcLabs.BaseLib.Forms.Common.AboutForm...");
        }

        [NotNull]
        public TesterCollection Testers { get; }

        [TestCategory("GeneratedTest")]
        [TestCategory("Forms")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultValueDataMemberTester()
        {
            if (!Testers.TryGetValue("DefaultValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("Forms")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ShouldSerializeTester()
        {
            if (!Testers.TryGetValue("ShouldSerializeTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }
    }

// ReSharper restore RedundantNameQualifier
}

// ReSharper disable CheckNamespace
namespace OpcLabs.BaseLibTest.Forms.Common
// ReSharper restore CheckNamespace
// ReSharper disable RedundantNameQualifier
{

    [TestClass]
    // ReSharper disable InconsistentNaming
    // ReSharper disable PartialTypeWithSinglePart
    public partial class AllMemberInfoProviderTest
    // ReSharper restore PartialTypeWithSinglePart
    // ReSharper restore InconsistentNaming
    {
        public AllMemberInfoProviderTest()
        {
            Testers = TestSuite.GetTypeTesters(typeof(global::OpcLabs.BaseLib.Forms.Common.AllMemberInfoProvider));
        }

        [TestInitialize]
        public void InitializeTest()
        {
            AssertUtilities.WriteLine("Initializing test for OpcLabs.BaseLib.Forms.Common.AllMemberInfoProvider...");
        }

        [NotNull]
        public TesterCollection Testers { get; }

        [TestCategory("GeneratedTest")]
        [TestCategory("Forms")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultCtorTester()
        {
            if (!Testers.TryGetValue("DefaultCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }
    }

// ReSharper restore RedundantNameQualifier
}

// ReSharper disable CheckNamespace
namespace OpcLabs.BaseLibTest.Forms.Common
// ReSharper restore CheckNamespace
// ReSharper disable RedundantNameQualifier
{

    [TestClass]
    // ReSharper disable InconsistentNaming
    // ReSharper disable PartialTypeWithSinglePart
    public partial class AttributedPropertyToolTipTest
    // ReSharper restore PartialTypeWithSinglePart
    // ReSharper restore InconsistentNaming
    {
        public AttributedPropertyToolTipTest()
        {
            Testers = TestSuite.GetTypeTesters(typeof(global::OpcLabs.BaseLib.Forms.Common.AttributedPropertyToolTip));
        }

        [TestInitialize]
        public void InitializeTest()
        {
            AssertUtilities.WriteLine("Initializing test for OpcLabs.BaseLib.Forms.Common.AttributedPropertyToolTip...");
        }

        [NotNull]
        public TesterCollection Testers { get; }

        [TestCategory("GeneratedTest")]
        [TestCategory("Forms")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultCtorTester()
        {
            if (!Testers.TryGetValue("DefaultCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("Forms")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultValueDataMemberTester()
        {
            if (!Testers.TryGetValue("DefaultValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("Forms")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ShouldSerializeTester()
        {
            if (!Testers.TryGetValue("ShouldSerializeTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }
    }

// ReSharper restore RedundantNameQualifier
}

// ReSharper disable CheckNamespace
namespace OpcLabs.BaseLibTest.Forms.Common
// ReSharper restore CheckNamespace
// ReSharper disable RedundantNameQualifier
{

    [TestClass]
    // ReSharper disable InconsistentNaming
    // ReSharper disable PartialTypeWithSinglePart
    public partial class BalloonTest
    // ReSharper restore PartialTypeWithSinglePart
    // ReSharper restore InconsistentNaming
    {
        public BalloonTest()
        {
            Testers = TestSuite.GetTypeTesters(typeof(global::OpcLabs.BaseLib.Forms.Common.Balloon));
        }

        [TestInitialize]
        public void InitializeTest()
        {
            AssertUtilities.WriteLine("Initializing test for OpcLabs.BaseLib.Forms.Common.Balloon...");
        }

        [NotNull]
        public TesterCollection Testers { get; }

        [TestCategory("GeneratedTest")]
        [TestCategory("Forms")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultValueDataMemberTester()
        {
            if (!Testers.TryGetValue("DefaultValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }
    }

// ReSharper restore RedundantNameQualifier
}

// ReSharper disable CheckNamespace
namespace OpcLabs.BaseLibTest.Forms.Common
// ReSharper restore CheckNamespace
// ReSharper disable RedundantNameQualifier
{

    [TestClass]
    // ReSharper disable InconsistentNaming
    // ReSharper disable PartialTypeWithSinglePart
    public partial class BindingSourceValueControlTest
    // ReSharper restore PartialTypeWithSinglePart
    // ReSharper restore InconsistentNaming
    {
        public BindingSourceValueControlTest()
        {
            Testers = TestSuite.GetTypeTesters(typeof(global::OpcLabs.BaseLib.Forms.Common.BindingSourceValueControl));
        }

        [TestInitialize]
        public void InitializeTest()
        {
            AssertUtilities.WriteLine("Initializing test for OpcLabs.BaseLib.Forms.Common.BindingSourceValueControl...");
        }

        [NotNull]
        public TesterCollection Testers { get; }

        [TestCategory("GeneratedTest")]
        [TestCategory("Forms")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultCtorTester()
        {
            if (!Testers.TryGetValue("DefaultCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("Forms")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultValueDataMemberTester()
        {
            if (!Testers.TryGetValue("DefaultValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }
    }

// ReSharper restore RedundantNameQualifier
}

// ReSharper disable CheckNamespace
namespace OpcLabs.BaseLibTest.Forms.Common
// ReSharper restore CheckNamespace
// ReSharper disable RedundantNameQualifier
{

    [TestClass]
    // ReSharper disable InconsistentNaming
    // ReSharper disable PartialTypeWithSinglePart
    public partial class DataGridViewRichTextBoxCellTest
    // ReSharper restore PartialTypeWithSinglePart
    // ReSharper restore InconsistentNaming
    {
        public DataGridViewRichTextBoxCellTest()
        {
            Testers = TestSuite.GetTypeTesters(typeof(global::OpcLabs.BaseLib.Forms.Common.DataGridViewRichTextBoxCell));
        }

        [TestInitialize]
        public void InitializeTest()
        {
            AssertUtilities.WriteLine("Initializing test for OpcLabs.BaseLib.Forms.Common.DataGridViewRichTextBoxCell...");
        }

        [NotNull]
        public TesterCollection Testers { get; }

        [TestCategory("GeneratedTest")]
        [TestCategory("Forms")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultCtorTester()
        {
            if (!Testers.TryGetValue("DefaultCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("Forms")]
        [TestCategory("Cloning")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ICloneableTester()
        {
            if (!Testers.TryGetValue("ICloneableTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }
    }

// ReSharper restore RedundantNameQualifier
}

// ReSharper disable CheckNamespace
namespace OpcLabs.BaseLibTest.Forms.Common
// ReSharper restore CheckNamespace
// ReSharper disable RedundantNameQualifier
{

    [TestClass]
    // ReSharper disable InconsistentNaming
    // ReSharper disable PartialTypeWithSinglePart
    public partial class DataGridViewRichTextBoxColumnTest
    // ReSharper restore PartialTypeWithSinglePart
    // ReSharper restore InconsistentNaming
    {
        public DataGridViewRichTextBoxColumnTest()
        {
            Testers = TestSuite.GetTypeTesters(typeof(global::OpcLabs.BaseLib.Forms.Common.DataGridViewRichTextBoxColumn));
        }

        [TestInitialize]
        public void InitializeTest()
        {
            AssertUtilities.WriteLine("Initializing test for OpcLabs.BaseLib.Forms.Common.DataGridViewRichTextBoxColumn...");
        }

        [NotNull]
        public TesterCollection Testers { get; }

        [TestCategory("GeneratedTest")]
        [TestCategory("Forms")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultCtorTester()
        {
            if (!Testers.TryGetValue("DefaultCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("Forms")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultValueDataMemberTester()
        {
            if (!Testers.TryGetValue("DefaultValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("Forms")]
        [TestCategory("Cloning")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ICloneableTester()
        {
            if (!Testers.TryGetValue("ICloneableTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }
    }

// ReSharper restore RedundantNameQualifier
}

// ReSharper disable CheckNamespace
namespace OpcLabs.BaseLibTest.Forms.Common
// ReSharper restore CheckNamespace
// ReSharper disable RedundantNameQualifier
{

    [TestClass]
    // ReSharper disable InconsistentNaming
    // ReSharper disable PartialTypeWithSinglePart
    public partial class DataGridViewTypedValueCellTest
    // ReSharper restore PartialTypeWithSinglePart
    // ReSharper restore InconsistentNaming
    {
        public DataGridViewTypedValueCellTest()
        {
            Testers = TestSuite.GetTypeTesters(typeof(global::OpcLabs.BaseLib.Forms.Common.DataGridViewTypedValueCell));
        }

        [TestInitialize]
        public void InitializeTest()
        {
            AssertUtilities.WriteLine("Initializing test for OpcLabs.BaseLib.Forms.Common.DataGridViewTypedValueCell...");
        }

        [NotNull]
        public TesterCollection Testers { get; }

        [TestCategory("GeneratedTest")]
        [TestCategory("Forms")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultCtorTester()
        {
            if (!Testers.TryGetValue("DefaultCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("Forms")]
        [TestCategory("Cloning")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ICloneableTester()
        {
            if (!Testers.TryGetValue("ICloneableTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }
    }

// ReSharper restore RedundantNameQualifier
}

// ReSharper disable CheckNamespace
namespace OpcLabs.BaseLibTest.Forms.Common
// ReSharper restore CheckNamespace
// ReSharper disable RedundantNameQualifier
{

    [TestClass]
    // ReSharper disable InconsistentNaming
    // ReSharper disable PartialTypeWithSinglePart
    public partial class DataGridViewTypedValueColumnTest
    // ReSharper restore PartialTypeWithSinglePart
    // ReSharper restore InconsistentNaming
    {
        public DataGridViewTypedValueColumnTest()
        {
            Testers = TestSuite.GetTypeTesters(typeof(global::OpcLabs.BaseLib.Forms.Common.DataGridViewTypedValueColumn));
        }

        [TestInitialize]
        public void InitializeTest()
        {
            AssertUtilities.WriteLine("Initializing test for OpcLabs.BaseLib.Forms.Common.DataGridViewTypedValueColumn...");
        }

        [NotNull]
        public TesterCollection Testers { get; }

        [TestCategory("GeneratedTest")]
        [TestCategory("Forms")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultCtorTester()
        {
            if (!Testers.TryGetValue("DefaultCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("Forms")]
        [TestCategory("Cloning")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ICloneableTester()
        {
            if (!Testers.TryGetValue("ICloneableTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }
    }

// ReSharper restore RedundantNameQualifier
}

// ReSharper disable CheckNamespace
namespace OpcLabs.BaseLibTest.Forms.Common
// ReSharper restore CheckNamespace
// ReSharper disable RedundantNameQualifier
{

    [TestClass]
    // ReSharper disable InconsistentNaming
    // ReSharper disable PartialTypeWithSinglePart
    public partial class DateTimeInputWithKindTest
    // ReSharper restore PartialTypeWithSinglePart
    // ReSharper restore InconsistentNaming
    {
        public DateTimeInputWithKindTest()
        {
            Testers = TestSuite.GetTypeTesters(typeof(global::OpcLabs.BaseLib.Forms.Common.DateTimeInputWithKind));
        }

        [TestInitialize]
        public void InitializeTest()
        {
            AssertUtilities.WriteLine("Initializing test for OpcLabs.BaseLib.Forms.Common.DateTimeInputWithKind...");
        }

        [NotNull]
        public TesterCollection Testers { get; }

        [TestCategory("GeneratedTest")]
        [TestCategory("Forms")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultCtorTester()
        {
            if (!Testers.TryGetValue("DefaultCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("Forms")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultValueDataMemberTester()
        {
            if (!Testers.TryGetValue("DefaultValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }
    }

// ReSharper restore RedundantNameQualifier
}

// ReSharper disable CheckNamespace
namespace OpcLabs.BaseLibTest.Forms.Common
// ReSharper restore CheckNamespace
// ReSharper disable RedundantNameQualifier
{

    [TestClass]
    // ReSharper disable InconsistentNaming
    // ReSharper disable PartialTypeWithSinglePart
    public partial class DateTimeKindButtonTest
    // ReSharper restore PartialTypeWithSinglePart
    // ReSharper restore InconsistentNaming
    {
        public DateTimeKindButtonTest()
        {
            Testers = TestSuite.GetTypeTesters(typeof(global::OpcLabs.BaseLib.Forms.Common.DateTimeKindButton));
        }

        [TestInitialize]
        public void InitializeTest()
        {
            AssertUtilities.WriteLine("Initializing test for OpcLabs.BaseLib.Forms.Common.DateTimeKindButton...");
        }

        [NotNull]
        public TesterCollection Testers { get; }

        [TestCategory("GeneratedTest")]
        [TestCategory("Forms")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultCtorTester()
        {
            if (!Testers.TryGetValue("DefaultCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("Forms")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultValueDataMemberTester()
        {
            if (!Testers.TryGetValue("DefaultValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }
    }

// ReSharper restore RedundantNameQualifier
}

// ReSharper disable CheckNamespace
namespace OpcLabs.BaseLibTest.Forms.Common
// ReSharper restore CheckNamespace
// ReSharper disable RedundantNameQualifier
{

    [TestClass]
    // ReSharper disable InconsistentNaming
    // ReSharper disable PartialTypeWithSinglePart
    public partial class DesignerVerbsDropButtonTest
    // ReSharper restore PartialTypeWithSinglePart
    // ReSharper restore InconsistentNaming
    {
        public DesignerVerbsDropButtonTest()
        {
            Testers = TestSuite.GetTypeTesters(typeof(global::OpcLabs.BaseLib.Forms.Common.DesignerVerbsDropButton));
        }

        [TestInitialize]
        public void InitializeTest()
        {
            AssertUtilities.WriteLine("Initializing test for OpcLabs.BaseLib.Forms.Common.DesignerVerbsDropButton...");
        }

        [NotNull]
        public TesterCollection Testers { get; }

        [TestCategory("GeneratedTest")]
        [TestCategory("Forms")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultCtorTester()
        {
            if (!Testers.TryGetValue("DefaultCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("Forms")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultValueDataMemberTester()
        {
            if (!Testers.TryGetValue("DefaultValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }
    }

// ReSharper restore RedundantNameQualifier
}

// ReSharper disable CheckNamespace
namespace OpcLabs.BaseLibTest.Forms.Common
// ReSharper restore CheckNamespace
// ReSharper disable RedundantNameQualifier
{

    [TestClass]
    // ReSharper disable InconsistentNaming
    // ReSharper disable PartialTypeWithSinglePart
    public partial class DialogControlTest
    // ReSharper restore PartialTypeWithSinglePart
    // ReSharper restore InconsistentNaming
    {
        public DialogControlTest()
        {
            Testers = TestSuite.GetTypeTesters(typeof(global::OpcLabs.BaseLib.Forms.Common.DialogControl));
        }

        [TestInitialize]
        public void InitializeTest()
        {
            AssertUtilities.WriteLine("Initializing test for OpcLabs.BaseLib.Forms.Common.DialogControl...");
        }

        [NotNull]
        public TesterCollection Testers { get; }

        [TestCategory("GeneratedTest")]
        [TestCategory("Forms")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultCtorTester()
        {
            if (!Testers.TryGetValue("DefaultCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("Forms")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultValueDataMemberTester()
        {
            if (!Testers.TryGetValue("DefaultValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("Forms")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ShouldSerializeTester()
        {
            if (!Testers.TryGetValue("ShouldSerializeTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }
    }

// ReSharper restore RedundantNameQualifier
}

// ReSharper disable CheckNamespace
namespace OpcLabs.BaseLibTest.Forms.Common
// ReSharper restore CheckNamespace
// ReSharper disable RedundantNameQualifier
{

    [TestClass]
    // ReSharper disable InconsistentNaming
    // ReSharper disable PartialTypeWithSinglePart
    public partial class ElementValueControlTest
    // ReSharper restore PartialTypeWithSinglePart
    // ReSharper restore InconsistentNaming
    {
        public ElementValueControlTest()
        {
            Testers = TestSuite.GetTypeTesters(typeof(global::OpcLabs.BaseLib.Forms.Common.ElementValueControl));
        }

        [TestInitialize]
        public void InitializeTest()
        {
            AssertUtilities.WriteLine("Initializing test for OpcLabs.BaseLib.Forms.Common.ElementValueControl...");
        }

        [NotNull]
        public TesterCollection Testers { get; }

        [TestCategory("GeneratedTest")]
        [TestCategory("Forms")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultCtorTester()
        {
            if (!Testers.TryGetValue("DefaultCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("Forms")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultValueDataMemberTester()
        {
            if (!Testers.TryGetValue("DefaultValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }
    }

// ReSharper restore RedundantNameQualifier
}

// ReSharper disable CheckNamespace
namespace OpcLabs.BaseLibTest.Forms.Common
// ReSharper restore CheckNamespace
// ReSharper disable RedundantNameQualifier
{

    [TestClass]
    // ReSharper disable InconsistentNaming
    // ReSharper disable PartialTypeWithSinglePart
    public partial class EndpointDescriptorControlTest
    // ReSharper restore PartialTypeWithSinglePart
    // ReSharper restore InconsistentNaming
    {
        public EndpointDescriptorControlTest()
        {
            Testers = TestSuite.GetTypeTesters(typeof(global::OpcLabs.BaseLib.Forms.Common.EndpointDescriptorControl));
        }

        [TestInitialize]
        public void InitializeTest()
        {
            AssertUtilities.WriteLine("Initializing test for OpcLabs.BaseLib.Forms.Common.EndpointDescriptorControl...");
        }

        [NotNull]
        public TesterCollection Testers { get; }

        [TestCategory("GeneratedTest")]
        [TestCategory("Forms")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultCtorTester()
        {
            if (!Testers.TryGetValue("DefaultCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("Forms")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultValueDataMemberTester()
        {
            if (!Testers.TryGetValue("DefaultValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }
    }

// ReSharper restore RedundantNameQualifier
}

// ReSharper disable CheckNamespace
namespace OpcLabs.BaseLibTest.Forms.Common
// ReSharper restore CheckNamespace
// ReSharper disable RedundantNameQualifier
{

    [TestClass]
    // ReSharper disable InconsistentNaming
    // ReSharper disable PartialTypeWithSinglePart
    public partial class EnumComboBoxTest
    // ReSharper restore PartialTypeWithSinglePart
    // ReSharper restore InconsistentNaming
    {
        public EnumComboBoxTest()
        {
            Testers = TestSuite.GetTypeTesters(typeof(global::OpcLabs.BaseLib.Forms.Common.EnumComboBox));
        }

        [TestInitialize]
        public void InitializeTest()
        {
            AssertUtilities.WriteLine("Initializing test for OpcLabs.BaseLib.Forms.Common.EnumComboBox...");
        }

        [NotNull]
        public TesterCollection Testers { get; }

        [TestCategory("GeneratedTest")]
        [TestCategory("Forms")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultCtorTester()
        {
            if (!Testers.TryGetValue("DefaultCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("Forms")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultValueDataMemberTester()
        {
            if (!Testers.TryGetValue("DefaultValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }
    }

// ReSharper restore RedundantNameQualifier
}

// ReSharper disable CheckNamespace
namespace OpcLabs.BaseLibTest.Forms.Common
// ReSharper restore CheckNamespace
// ReSharper disable RedundantNameQualifier
{

    [TestClass]
    // ReSharper disable InconsistentNaming
    // ReSharper disable PartialTypeWithSinglePart
    public partial class ErrorListFormTest
    // ReSharper restore PartialTypeWithSinglePart
    // ReSharper restore InconsistentNaming
    {
        public ErrorListFormTest()
        {
            Testers = TestSuite.GetTypeTesters(typeof(global::OpcLabs.BaseLib.Forms.Common.ErrorListForm));
        }

        [TestInitialize]
        public void InitializeTest()
        {
            AssertUtilities.WriteLine("Initializing test for OpcLabs.BaseLib.Forms.Common.ErrorListForm...");
        }

        [NotNull]
        public TesterCollection Testers { get; }

        [TestCategory("GeneratedTest")]
        [TestCategory("Forms")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultCtorTester()
        {
            if (!Testers.TryGetValue("DefaultCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("Forms")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultValueDataMemberTester()
        {
            if (!Testers.TryGetValue("DefaultValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("Forms")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void InvalidValueDataMemberTester()
        {
            if (!Testers.TryGetValue("InvalidValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("Forms")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ShouldSerializeTester()
        {
            if (!Testers.TryGetValue("ShouldSerializeTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }
    }

// ReSharper restore RedundantNameQualifier
}

// ReSharper disable CheckNamespace
namespace OpcLabs.BaseLibTest.Forms.Common
// ReSharper restore CheckNamespace
// ReSharper disable RedundantNameQualifier
{

    [TestClass]
    // ReSharper disable InconsistentNaming
    // ReSharper disable PartialTypeWithSinglePart
    public partial class EventsPropertyGridPanelTest
    // ReSharper restore PartialTypeWithSinglePart
    // ReSharper restore InconsistentNaming
    {
        public EventsPropertyGridPanelTest()
        {
            Testers = TestSuite.GetTypeTesters(typeof(global::OpcLabs.BaseLib.Forms.Common.EventsPropertyGridPanel));
        }

        [TestInitialize]
        public void InitializeTest()
        {
            AssertUtilities.WriteLine("Initializing test for OpcLabs.BaseLib.Forms.Common.EventsPropertyGridPanel...");
        }

        [NotNull]
        public TesterCollection Testers { get; }

        [TestCategory("GeneratedTest")]
        [TestCategory("Forms")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultCtorTester()
        {
            if (!Testers.TryGetValue("DefaultCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("Forms")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultValueDataMemberTester()
        {
            if (!Testers.TryGetValue("DefaultValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("Forms")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ShouldSerializeTester()
        {
            if (!Testers.TryGetValue("ShouldSerializeTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }
    }

// ReSharper restore RedundantNameQualifier
}

// ReSharper disable CheckNamespace
namespace OpcLabs.BaseLibTest.Forms.Common
// ReSharper restore CheckNamespace
// ReSharper disable RedundantNameQualifier
{

    [TestClass]
    // ReSharper disable InconsistentNaming
    // ReSharper disable PartialTypeWithSinglePart
    public partial class ExceptionFormTest
    // ReSharper restore PartialTypeWithSinglePart
    // ReSharper restore InconsistentNaming
    {
        public ExceptionFormTest()
        {
            Testers = TestSuite.GetTypeTesters(typeof(global::OpcLabs.BaseLib.Forms.Common.ExceptionForm));
        }

        [TestInitialize]
        public void InitializeTest()
        {
            AssertUtilities.WriteLine("Initializing test for OpcLabs.BaseLib.Forms.Common.ExceptionForm...");
        }

        [NotNull]
        public TesterCollection Testers { get; }

        [TestCategory("GeneratedTest")]
        [TestCategory("Forms")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultCtorTester()
        {
            if (!Testers.TryGetValue("DefaultCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("Forms")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultValueDataMemberTester()
        {
            if (!Testers.TryGetValue("DefaultValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("Forms")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ShouldSerializeTester()
        {
            if (!Testers.TryGetValue("ShouldSerializeTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }
    }

// ReSharper restore RedundantNameQualifier
}

// ReSharper disable CheckNamespace
namespace OpcLabs.BaseLibTest.Forms.Common
// ReSharper restore CheckNamespace
// ReSharper disable RedundantNameQualifier
{

    [TestClass]
    // ReSharper disable InconsistentNaming
    // ReSharper disable PartialTypeWithSinglePart
    public partial class ExpandableInstanceObjectConverterTest
    // ReSharper restore PartialTypeWithSinglePart
    // ReSharper restore InconsistentNaming
    {
        public ExpandableInstanceObjectConverterTest()
        {
            Testers = TestSuite.GetTypeTesters(typeof(global::OpcLabs.BaseLib.Forms.Common.ExpandableInstanceObjectConverter));
        }

        [TestInitialize]
        public void InitializeTest()
        {
            AssertUtilities.WriteLine("Initializing test for OpcLabs.BaseLib.Forms.Common.ExpandableInstanceObjectConverter...");
        }

        [NotNull]
        public TesterCollection Testers { get; }

        [TestCategory("GeneratedTest")]
        [TestCategory("Forms")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultCtorTester()
        {
            if (!Testers.TryGetValue("DefaultCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }
    }

// ReSharper restore RedundantNameQualifier
}

// ReSharper disable CheckNamespace
namespace OpcLabs.BaseLibTest.Forms.Common
// ReSharper restore CheckNamespace
// ReSharper disable RedundantNameQualifier
{

    [TestClass]
    // ReSharper disable InconsistentNaming
    // ReSharper disable PartialTypeWithSinglePart
    public partial class ExpandableStaticObjectConverterTest
    // ReSharper restore PartialTypeWithSinglePart
    // ReSharper restore InconsistentNaming
    {
        public ExpandableStaticObjectConverterTest()
        {
            Testers = TestSuite.GetTypeTesters(typeof(global::OpcLabs.BaseLib.Forms.Common.ExpandableStaticObjectConverter));
        }

        [TestInitialize]
        public void InitializeTest()
        {
            AssertUtilities.WriteLine("Initializing test for OpcLabs.BaseLib.Forms.Common.ExpandableStaticObjectConverter...");
        }

        [NotNull]
        public TesterCollection Testers { get; }

        [TestCategory("GeneratedTest")]
        [TestCategory("Forms")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultCtorTester()
        {
            if (!Testers.TryGetValue("DefaultCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }
    }

// ReSharper restore RedundantNameQualifier
}

// ReSharper disable CheckNamespace
namespace OpcLabs.BaseLibTest.Forms.Common
// ReSharper restore CheckNamespace
// ReSharper disable RedundantNameQualifier
{

    [TestClass]
    // ReSharper disable InconsistentNaming
    // ReSharper disable PartialTypeWithSinglePart
    public partial class FlagsListViewTest
    // ReSharper restore PartialTypeWithSinglePart
    // ReSharper restore InconsistentNaming
    {
        public FlagsListViewTest()
        {
            Testers = TestSuite.GetTypeTesters(typeof(global::OpcLabs.BaseLib.Forms.Common.FlagsListView));
        }

        [TestInitialize]
        public void InitializeTest()
        {
            AssertUtilities.WriteLine("Initializing test for OpcLabs.BaseLib.Forms.Common.FlagsListView...");
        }

        [NotNull]
        public TesterCollection Testers { get; }

        [TestCategory("GeneratedTest")]
        [TestCategory("Forms")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultCtorTester()
        {
            if (!Testers.TryGetValue("DefaultCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("Forms")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultValueDataMemberTester()
        {
            if (!Testers.TryGetValue("DefaultValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("Forms")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ShouldSerializeTester()
        {
            if (!Testers.TryGetValue("ShouldSerializeTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }
    }

// ReSharper restore RedundantNameQualifier
}

// ReSharper disable CheckNamespace
namespace OpcLabs.BaseLibTest.Forms.Common
// ReSharper restore CheckNamespace
// ReSharper disable RedundantNameQualifier
{

    [TestClass]
    // ReSharper disable InconsistentNaming
    // ReSharper disable PartialTypeWithSinglePart
    public partial class GuidInputTest
    // ReSharper restore PartialTypeWithSinglePart
    // ReSharper restore InconsistentNaming
    {
        public GuidInputTest()
        {
            Testers = TestSuite.GetTypeTesters(typeof(global::OpcLabs.BaseLib.Forms.Common.GuidInput));
        }

        [TestInitialize]
        public void InitializeTest()
        {
            AssertUtilities.WriteLine("Initializing test for OpcLabs.BaseLib.Forms.Common.GuidInput...");
        }

        [NotNull]
        public TesterCollection Testers { get; }

        [TestCategory("GeneratedTest")]
        [TestCategory("Forms")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultCtorTester()
        {
            if (!Testers.TryGetValue("DefaultCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("Forms")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultValueDataMemberTester()
        {
            if (!Testers.TryGetValue("DefaultValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }
    }

// ReSharper restore RedundantNameQualifier
}

// ReSharper disable CheckNamespace
namespace OpcLabs.BaseLibTest.Forms.Common
// ReSharper restore CheckNamespace
// ReSharper disable RedundantNameQualifier
{

    [TestClass]
    // ReSharper disable InconsistentNaming
    // ReSharper disable PartialTypeWithSinglePart
    public partial class Int32HexConverterTest
    // ReSharper restore PartialTypeWithSinglePart
    // ReSharper restore InconsistentNaming
    {
        public Int32HexConverterTest()
        {
            Testers = TestSuite.GetTypeTesters(typeof(global::OpcLabs.BaseLib.Forms.Common.Int32HexConverter));
        }

        [TestInitialize]
        public void InitializeTest()
        {
            AssertUtilities.WriteLine("Initializing test for OpcLabs.BaseLib.Forms.Common.Int32HexConverter...");
        }

        [NotNull]
        public TesterCollection Testers { get; }

        [TestCategory("GeneratedTest")]
        [TestCategory("Forms")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultCtorTester()
        {
            if (!Testers.TryGetValue("DefaultCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }
    }

// ReSharper restore RedundantNameQualifier
}

// ReSharper disable CheckNamespace
namespace OpcLabs.BaseLibTest.Forms.Common
// ReSharper restore CheckNamespace
// ReSharper disable RedundantNameQualifier
{

    [TestClass]
    // ReSharper disable InconsistentNaming
    // ReSharper disable PartialTypeWithSinglePart
    public partial class ListView2Test
    // ReSharper restore PartialTypeWithSinglePart
    // ReSharper restore InconsistentNaming
    {
        public ListView2Test()
        {
            Testers = TestSuite.GetTypeTesters(typeof(global::OpcLabs.BaseLib.Forms.Common.ListView2));
        }

        [TestInitialize]
        public void InitializeTest()
        {
            AssertUtilities.WriteLine("Initializing test for OpcLabs.BaseLib.Forms.Common.ListView2...");
        }

        [NotNull]
        public TesterCollection Testers { get; }

        [TestCategory("GeneratedTest")]
        [TestCategory("Forms")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultCtorTester()
        {
            if (!Testers.TryGetValue("DefaultCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("Forms")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultValueDataMemberTester()
        {
            if (!Testers.TryGetValue("DefaultValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }
    }

// ReSharper restore RedundantNameQualifier
}

// ReSharper disable CheckNamespace
namespace OpcLabs.BaseLibTest.Forms.Common
// ReSharper restore CheckNamespace
// ReSharper disable RedundantNameQualifier
{

    [TestClass]
    // ReSharper disable InconsistentNaming
    // ReSharper disable PartialTypeWithSinglePart
    public partial class ListViewGroupHeaderComparerTest
    // ReSharper restore PartialTypeWithSinglePart
    // ReSharper restore InconsistentNaming
    {
        public ListViewGroupHeaderComparerTest()
        {
            Testers = TestSuite.GetTypeTesters(typeof(global::OpcLabs.BaseLib.Forms.Common.ListViewGroupHeaderComparer));
        }

        [TestInitialize]
        public void InitializeTest()
        {
            AssertUtilities.WriteLine("Initializing test for OpcLabs.BaseLib.Forms.Common.ListViewGroupHeaderComparer...");
        }

        [NotNull]
        public TesterCollection Testers { get; }

        [TestCategory("GeneratedTest")]
        [TestCategory("Forms")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultCtorTester()
        {
            if (!Testers.TryGetValue("DefaultCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }
    }

// ReSharper restore RedundantNameQualifier
}

// ReSharper disable CheckNamespace
namespace OpcLabs.BaseLibTest.Forms.Common
// ReSharper restore CheckNamespace
// ReSharper disable RedundantNameQualifier
{

    [TestClass]
    // ReSharper disable InconsistentNaming
    // ReSharper disable PartialTypeWithSinglePart
    public partial class ListViewItemWithPropertiesTest
    // ReSharper restore PartialTypeWithSinglePart
    // ReSharper restore InconsistentNaming
    {
        public ListViewItemWithPropertiesTest()
        {
            Testers = TestSuite.GetTypeTesters(typeof(global::OpcLabs.BaseLib.Forms.Common.ListViewItemWithProperties));
        }

        [TestInitialize]
        public void InitializeTest()
        {
            AssertUtilities.WriteLine("Initializing test for OpcLabs.BaseLib.Forms.Common.ListViewItemWithProperties...");
        }

        [NotNull]
        public TesterCollection Testers { get; }

        [TestCategory("GeneratedTest")]
        [TestCategory("Forms")]
        [TestCategory("Cloning")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ICloneableTester()
        {
            if (!Testers.TryGetValue("ICloneableTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }
    }

// ReSharper restore RedundantNameQualifier
}

// ReSharper disable CheckNamespace
namespace OpcLabs.BaseLibTest.Forms.Common
// ReSharper restore CheckNamespace
// ReSharper disable RedundantNameQualifier
{

    [TestClass]
    // ReSharper disable InconsistentNaming
    // ReSharper disable PartialTypeWithSinglePart
    public partial class MemberInputTest
    // ReSharper restore PartialTypeWithSinglePart
    // ReSharper restore InconsistentNaming
    {
        public MemberInputTest()
        {
            Testers = TestSuite.GetTypeTesters(typeof(global::OpcLabs.BaseLib.Forms.Common.MemberInput));
        }

        [TestInitialize]
        public void InitializeTest()
        {
            AssertUtilities.WriteLine("Initializing test for OpcLabs.BaseLib.Forms.Common.MemberInput...");
        }

        [NotNull]
        public TesterCollection Testers { get; }

        [TestCategory("GeneratedTest")]
        [TestCategory("Forms")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultCtorTester()
        {
            if (!Testers.TryGetValue("DefaultCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("Forms")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultValueDataMemberTester()
        {
            if (!Testers.TryGetValue("DefaultValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("Forms")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void InvalidValueDataMemberTester()
        {
            if (!Testers.TryGetValue("InvalidValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("Forms")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ShouldSerializeTester()
        {
            if (!Testers.TryGetValue("ShouldSerializeTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }
    }

// ReSharper restore RedundantNameQualifier
}

// ReSharper disable CheckNamespace
namespace OpcLabs.BaseLibTest.Forms.Common
// ReSharper restore CheckNamespace
// ReSharper disable RedundantNameQualifier
{

    [TestClass]
    // ReSharper disable InconsistentNaming
    // ReSharper disable PartialTypeWithSinglePart
    public partial class MemberPathInputTest
    // ReSharper restore PartialTypeWithSinglePart
    // ReSharper restore InconsistentNaming
    {
        public MemberPathInputTest()
        {
            Testers = TestSuite.GetTypeTesters(typeof(global::OpcLabs.BaseLib.Forms.Common.MemberPathInput));
        }

        [TestInitialize]
        public void InitializeTest()
        {
            AssertUtilities.WriteLine("Initializing test for OpcLabs.BaseLib.Forms.Common.MemberPathInput...");
        }

        [NotNull]
        public TesterCollection Testers { get; }

        [TestCategory("GeneratedTest")]
        [TestCategory("Forms")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultCtorTester()
        {
            if (!Testers.TryGetValue("DefaultCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("Forms")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultValueDataMemberTester()
        {
            if (!Testers.TryGetValue("DefaultValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("Forms")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void InvalidValueDataMemberTester()
        {
            if (!Testers.TryGetValue("InvalidValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("Forms")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ShouldSerializeTester()
        {
            if (!Testers.TryGetValue("ShouldSerializeTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }
    }

// ReSharper restore RedundantNameQualifier
}

// ReSharper disable CheckNamespace
namespace OpcLabs.BaseLibTest.Forms.Common
// ReSharper restore CheckNamespace
// ReSharper disable RedundantNameQualifier
{

    [TestClass]
    // ReSharper disable InconsistentNaming
    // ReSharper disable PartialTypeWithSinglePart
    public partial class MessageControlTest
    // ReSharper restore PartialTypeWithSinglePart
    // ReSharper restore InconsistentNaming
    {
        public MessageControlTest()
        {
            Testers = TestSuite.GetTypeTesters(typeof(global::OpcLabs.BaseLib.Forms.Common.MessageControl));
        }

        [TestInitialize]
        public void InitializeTest()
        {
            AssertUtilities.WriteLine("Initializing test for OpcLabs.BaseLib.Forms.Common.MessageControl...");
        }

        [NotNull]
        public TesterCollection Testers { get; }

        [TestCategory("GeneratedTest")]
        [TestCategory("Forms")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultCtorTester()
        {
            if (!Testers.TryGetValue("DefaultCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("Forms")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultValueDataMemberTester()
        {
            if (!Testers.TryGetValue("DefaultValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("Forms")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void InvalidValueDataMemberTester()
        {
            if (!Testers.TryGetValue("InvalidValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("Forms")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ShouldSerializeTester()
        {
            if (!Testers.TryGetValue("ShouldSerializeTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }
    }

// ReSharper restore RedundantNameQualifier
}

// ReSharper disable CheckNamespace
namespace OpcLabs.BaseLibTest.Forms.Common
// ReSharper restore CheckNamespace
// ReSharper disable RedundantNameQualifier
{

    [TestClass]
    // ReSharper disable InconsistentNaming
    // ReSharper disable PartialTypeWithSinglePart
    public partial class MessageListFormTest
    // ReSharper restore PartialTypeWithSinglePart
    // ReSharper restore InconsistentNaming
    {
        public MessageListFormTest()
        {
            Testers = TestSuite.GetTypeTesters(typeof(global::OpcLabs.BaseLib.Forms.Common.MessageListForm));
        }

        [TestInitialize]
        public void InitializeTest()
        {
            AssertUtilities.WriteLine("Initializing test for OpcLabs.BaseLib.Forms.Common.MessageListForm...");
        }

        [NotNull]
        public TesterCollection Testers { get; }

        [TestCategory("GeneratedTest")]
        [TestCategory("Forms")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultCtorTester()
        {
            if (!Testers.TryGetValue("DefaultCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("Forms")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultValueDataMemberTester()
        {
            if (!Testers.TryGetValue("DefaultValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("Forms")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void InvalidValueDataMemberTester()
        {
            if (!Testers.TryGetValue("InvalidValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("Forms")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ShouldSerializeTester()
        {
            if (!Testers.TryGetValue("ShouldSerializeTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }
    }

// ReSharper restore RedundantNameQualifier
}

// ReSharper disable CheckNamespace
namespace OpcLabs.BaseLibTest.Forms.Common
// ReSharper restore CheckNamespace
// ReSharper disable RedundantNameQualifier
{

    [TestClass]
    // ReSharper disable InconsistentNaming
    // ReSharper disable PartialTypeWithSinglePart
    public partial class MessagesPanelTest
    // ReSharper restore PartialTypeWithSinglePart
    // ReSharper restore InconsistentNaming
    {
        public MessagesPanelTest()
        {
            Testers = TestSuite.GetTypeTesters(typeof(global::OpcLabs.BaseLib.Forms.Common.MessagesPanel));
        }

        [TestInitialize]
        public void InitializeTest()
        {
            AssertUtilities.WriteLine("Initializing test for OpcLabs.BaseLib.Forms.Common.MessagesPanel...");
        }

        [NotNull]
        public TesterCollection Testers { get; }

        [TestCategory("GeneratedTest")]
        [TestCategory("Forms")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultCtorTester()
        {
            if (!Testers.TryGetValue("DefaultCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }
    }

// ReSharper restore RedundantNameQualifier
}

// ReSharper disable CheckNamespace
namespace OpcLabs.BaseLibTest.Forms.Common
// ReSharper restore CheckNamespace
// ReSharper disable RedundantNameQualifier
{

    [TestClass]
    // ReSharper disable InconsistentNaming
    // ReSharper disable PartialTypeWithSinglePart
    public partial class MillisecondsInputTest
    // ReSharper restore PartialTypeWithSinglePart
    // ReSharper restore InconsistentNaming
    {
        public MillisecondsInputTest()
        {
            Testers = TestSuite.GetTypeTesters(typeof(global::OpcLabs.BaseLib.Forms.Common.MillisecondsInput));
        }

        [TestInitialize]
        public void InitializeTest()
        {
            AssertUtilities.WriteLine("Initializing test for OpcLabs.BaseLib.Forms.Common.MillisecondsInput...");
        }

        [NotNull]
        public TesterCollection Testers { get; }

        [TestCategory("GeneratedTest")]
        [TestCategory("Forms")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultCtorTester()
        {
            if (!Testers.TryGetValue("DefaultCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("Forms")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultValueDataMemberTester()
        {
            if (!Testers.TryGetValue("DefaultValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }
    }

// ReSharper restore RedundantNameQualifier
}

// ReSharper disable CheckNamespace
namespace OpcLabs.BaseLibTest.Forms.Common
// ReSharper restore CheckNamespace
// ReSharper disable RedundantNameQualifier
{

    [TestClass]
    // ReSharper disable InconsistentNaming
    // ReSharper disable PartialTypeWithSinglePart
    public partial class MultilineTextEditorTest
    // ReSharper restore PartialTypeWithSinglePart
    // ReSharper restore InconsistentNaming
    {
        public MultilineTextEditorTest()
        {
            Testers = TestSuite.GetTypeTesters(typeof(global::OpcLabs.BaseLib.Forms.Common.MultilineTextEditor));
        }

        [TestInitialize]
        public void InitializeTest()
        {
            AssertUtilities.WriteLine("Initializing test for OpcLabs.BaseLib.Forms.Common.MultilineTextEditor...");
        }

        [NotNull]
        public TesterCollection Testers { get; }

        [TestCategory("GeneratedTest")]
        [TestCategory("Forms")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultCtorTester()
        {
            if (!Testers.TryGetValue("DefaultCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }
    }

// ReSharper restore RedundantNameQualifier
}

// ReSharper disable CheckNamespace
namespace OpcLabs.BaseLibTest.Forms.Common
// ReSharper restore CheckNamespace
// ReSharper disable RedundantNameQualifier
{

    [TestClass]
    // ReSharper disable InconsistentNaming
    // ReSharper disable PartialTypeWithSinglePart
    public partial class MultilineTextViewerConverterTest
    // ReSharper restore PartialTypeWithSinglePart
    // ReSharper restore InconsistentNaming
    {
        public MultilineTextViewerConverterTest()
        {
            Testers = TestSuite.GetTypeTesters(typeof(global::OpcLabs.BaseLib.Forms.Common.MultilineTextViewerConverter));
        }

        [TestInitialize]
        public void InitializeTest()
        {
            AssertUtilities.WriteLine("Initializing test for OpcLabs.BaseLib.Forms.Common.MultilineTextViewerConverter...");
        }

        [NotNull]
        public TesterCollection Testers { get; }

        [TestCategory("GeneratedTest")]
        [TestCategory("Forms")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultCtorTester()
        {
            if (!Testers.TryGetValue("DefaultCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }
    }

// ReSharper restore RedundantNameQualifier
}

// ReSharper disable CheckNamespace
namespace OpcLabs.BaseLibTest.Forms.Common
// ReSharper restore CheckNamespace
// ReSharper disable RedundantNameQualifier
{

    [TestClass]
    // ReSharper disable InconsistentNaming
    // ReSharper disable PartialTypeWithSinglePart
    public partial class NullableValueControlTest
    // ReSharper restore PartialTypeWithSinglePart
    // ReSharper restore InconsistentNaming
    {
        public NullableValueControlTest()
        {
            Testers = TestSuite.GetTypeTesters(typeof(global::OpcLabs.BaseLib.Forms.Common.NullableValueControl));
        }

        [TestInitialize]
        public void InitializeTest()
        {
            AssertUtilities.WriteLine("Initializing test for OpcLabs.BaseLib.Forms.Common.NullableValueControl...");
        }

        [NotNull]
        public TesterCollection Testers { get; }

        [TestCategory("GeneratedTest")]
        [TestCategory("Forms")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultCtorTester()
        {
            if (!Testers.TryGetValue("DefaultCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("Forms")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultValueDataMemberTester()
        {
            if (!Testers.TryGetValue("DefaultValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("Forms")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ShouldSerializeTester()
        {
            if (!Testers.TryGetValue("ShouldSerializeTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }
    }

// ReSharper restore RedundantNameQualifier
}

// ReSharper disable CheckNamespace
namespace OpcLabs.BaseLibTest.Forms.Common
// ReSharper restore CheckNamespace
// ReSharper disable RedundantNameQualifier
{

    [TestClass]
    // ReSharper disable InconsistentNaming
    // ReSharper disable PartialTypeWithSinglePart
    public partial class NumberBaseButtonTest
    // ReSharper restore PartialTypeWithSinglePart
    // ReSharper restore InconsistentNaming
    {
        public NumberBaseButtonTest()
        {
            Testers = TestSuite.GetTypeTesters(typeof(global::OpcLabs.BaseLib.Forms.Common.NumberBaseButton));
        }

        [TestInitialize]
        public void InitializeTest()
        {
            AssertUtilities.WriteLine("Initializing test for OpcLabs.BaseLib.Forms.Common.NumberBaseButton...");
        }

        [NotNull]
        public TesterCollection Testers { get; }

        [TestCategory("GeneratedTest")]
        [TestCategory("Forms")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultCtorTester()
        {
            if (!Testers.TryGetValue("DefaultCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("Forms")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultValueDataMemberTester()
        {
            if (!Testers.TryGetValue("DefaultValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }
    }

// ReSharper restore RedundantNameQualifier
}

// ReSharper disable CheckNamespace
namespace OpcLabs.BaseLibTest.Forms.Common
// ReSharper restore CheckNamespace
// ReSharper disable RedundantNameQualifier
{

    [TestClass]
    // ReSharper disable InconsistentNaming
    // ReSharper disable PartialTypeWithSinglePart
    public partial class NumericInputWithBaseTest
    // ReSharper restore PartialTypeWithSinglePart
    // ReSharper restore InconsistentNaming
    {
        public NumericInputWithBaseTest()
        {
            Testers = TestSuite.GetTypeTesters(typeof(global::OpcLabs.BaseLib.Forms.Common.NumericInputWithBase));
        }

        [TestInitialize]
        public void InitializeTest()
        {
            AssertUtilities.WriteLine("Initializing test for OpcLabs.BaseLib.Forms.Common.NumericInputWithBase...");
        }

        [NotNull]
        public TesterCollection Testers { get; }

        [TestCategory("GeneratedTest")]
        [TestCategory("Forms")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultCtorTester()
        {
            if (!Testers.TryGetValue("DefaultCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("Forms")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultValueDataMemberTester()
        {
            if (!Testers.TryGetValue("DefaultValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }
    }

// ReSharper restore RedundantNameQualifier
}

// ReSharper disable CheckNamespace
namespace OpcLabs.BaseLibTest.Forms.Common
// ReSharper restore CheckNamespace
// ReSharper disable RedundantNameQualifier
{

    [TestClass]
    // ReSharper disable InconsistentNaming
    // ReSharper disable PartialTypeWithSinglePart
    public partial class NumericUpDown2Test
    // ReSharper restore PartialTypeWithSinglePart
    // ReSharper restore InconsistentNaming
    {
        public NumericUpDown2Test()
        {
            Testers = TestSuite.GetTypeTesters(typeof(global::OpcLabs.BaseLib.Forms.Common.NumericUpDown2));
        }

        [TestInitialize]
        public void InitializeTest()
        {
            AssertUtilities.WriteLine("Initializing test for OpcLabs.BaseLib.Forms.Common.NumericUpDown2...");
        }

        [NotNull]
        public TesterCollection Testers { get; }

        [TestCategory("GeneratedTest")]
        [TestCategory("Forms")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultCtorTester()
        {
            if (!Testers.TryGetValue("DefaultCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("Forms")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultValueDataMemberTester()
        {
            if (!Testers.TryGetValue("DefaultValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }
    }

// ReSharper restore RedundantNameQualifier
}

// ReSharper disable CheckNamespace
namespace OpcLabs.BaseLibTest.Forms.Common
// ReSharper restore CheckNamespace
// ReSharper disable RedundantNameQualifier
{

    [TestClass]
    // ReSharper disable InconsistentNaming
    // ReSharper disable PartialTypeWithSinglePart
    public partial class ObjectEditorControlTest
    // ReSharper restore PartialTypeWithSinglePart
    // ReSharper restore InconsistentNaming
    {
        public ObjectEditorControlTest()
        {
            Testers = TestSuite.GetTypeTesters(typeof(global::OpcLabs.BaseLib.Forms.Common.ObjectEditorControl));
        }

        [TestInitialize]
        public void InitializeTest()
        {
            AssertUtilities.WriteLine("Initializing test for OpcLabs.BaseLib.Forms.Common.ObjectEditorControl...");
        }

        [NotNull]
        public TesterCollection Testers { get; }

        [TestCategory("GeneratedTest")]
        [TestCategory("Forms")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultCtorTester()
        {
            if (!Testers.TryGetValue("DefaultCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("Forms")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultValueDataMemberTester()
        {
            if (!Testers.TryGetValue("DefaultValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }
    }

// ReSharper restore RedundantNameQualifier
}

// ReSharper disable CheckNamespace
namespace OpcLabs.BaseLibTest.Forms.Common
// ReSharper restore CheckNamespace
// ReSharper disable RedundantNameQualifier
{

    [TestClass]
    // ReSharper disable InconsistentNaming
    // ReSharper disable PartialTypeWithSinglePart
    public partial class ParallelNotifierTest
    // ReSharper restore PartialTypeWithSinglePart
    // ReSharper restore InconsistentNaming
    {
        public ParallelNotifierTest()
        {
            Testers = TestSuite.GetTypeTesters(typeof(global::OpcLabs.BaseLib.Forms.Common.ParallelNotifier));
        }

        [TestInitialize]
        public void InitializeTest()
        {
            AssertUtilities.WriteLine("Initializing test for OpcLabs.BaseLib.Forms.Common.ParallelNotifier...");
        }

        [NotNull]
        public TesterCollection Testers { get; }

        [TestCategory("GeneratedTest")]
        [TestCategory("Forms")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultCtorTester()
        {
            if (!Testers.TryGetValue("DefaultCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }
    }

// ReSharper restore RedundantNameQualifier
}

// ReSharper disable CheckNamespace
namespace OpcLabs.BaseLibTest.Forms.Common
// ReSharper restore CheckNamespace
// ReSharper disable RedundantNameQualifier
{

    [TestClass]
    // ReSharper disable InconsistentNaming
    // ReSharper disable PartialTypeWithSinglePart
    public partial class ParallelNotifierFormTest
    // ReSharper restore PartialTypeWithSinglePart
    // ReSharper restore InconsistentNaming
    {
        public ParallelNotifierFormTest()
        {
            Testers = TestSuite.GetTypeTesters(typeof(global::OpcLabs.BaseLib.Forms.Common.ParallelNotifierForm));
        }

        [TestInitialize]
        public void InitializeTest()
        {
            AssertUtilities.WriteLine("Initializing test for OpcLabs.BaseLib.Forms.Common.ParallelNotifierForm...");
        }

        [NotNull]
        public TesterCollection Testers { get; }

        [TestCategory("GeneratedTest")]
        [TestCategory("Forms")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultCtorTester()
        {
            if (!Testers.TryGetValue("DefaultCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("Forms")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultValueDataMemberTester()
        {
            if (!Testers.TryGetValue("DefaultValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("Forms")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ShouldSerializeTester()
        {
            if (!Testers.TryGetValue("ShouldSerializeTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }
    }

// ReSharper restore RedundantNameQualifier
}

// ReSharper disable CheckNamespace
namespace OpcLabs.BaseLibTest.Forms.Common
// ReSharper restore CheckNamespace
// ReSharper disable RedundantNameQualifier
{

    [TestClass]
    // ReSharper disable InconsistentNaming
    // ReSharper disable PartialTypeWithSinglePart
    public partial class PercentInputTest
    // ReSharper restore PartialTypeWithSinglePart
    // ReSharper restore InconsistentNaming
    {
        public PercentInputTest()
        {
            Testers = TestSuite.GetTypeTesters(typeof(global::OpcLabs.BaseLib.Forms.Common.PercentInput));
        }

        [TestInitialize]
        public void InitializeTest()
        {
            AssertUtilities.WriteLine("Initializing test for OpcLabs.BaseLib.Forms.Common.PercentInput...");
        }

        [NotNull]
        public TesterCollection Testers { get; }

        [TestCategory("GeneratedTest")]
        [TestCategory("Forms")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultCtorTester()
        {
            if (!Testers.TryGetValue("DefaultCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }
    }

// ReSharper restore RedundantNameQualifier
}

// ReSharper disable CheckNamespace
namespace OpcLabs.BaseLibTest.Forms.Common
// ReSharper restore CheckNamespace
// ReSharper disable RedundantNameQualifier
{

    [TestClass]
    // ReSharper disable InconsistentNaming
    // ReSharper disable PartialTypeWithSinglePart
    public partial class PersistenceTest
    // ReSharper restore PartialTypeWithSinglePart
    // ReSharper restore InconsistentNaming
    {
        public PersistenceTest()
        {
            Testers = TestSuite.GetTypeTesters(typeof(global::OpcLabs.BaseLib.Forms.Common.Persistence));
        }

        [TestInitialize]
        public void InitializeTest()
        {
            AssertUtilities.WriteLine("Initializing test for OpcLabs.BaseLib.Forms.Common.Persistence...");
        }

        [NotNull]
        public TesterCollection Testers { get; }

        [TestCategory("GeneratedTest")]
        [TestCategory("Forms")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultCtorTester()
        {
            if (!Testers.TryGetValue("DefaultCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }
    }

// ReSharper restore RedundantNameQualifier
}

// ReSharper disable CheckNamespace
namespace OpcLabs.BaseLibTest.Forms.Common
// ReSharper restore CheckNamespace
// ReSharper disable RedundantNameQualifier
{

    [TestClass]
    // ReSharper disable InconsistentNaming
    // ReSharper disable PartialTypeWithSinglePart
    public partial class PolymorphicValueControlTest
    // ReSharper restore PartialTypeWithSinglePart
    // ReSharper restore InconsistentNaming
    {
        public PolymorphicValueControlTest()
        {
            Testers = TestSuite.GetTypeTesters(typeof(global::OpcLabs.BaseLib.Forms.Common.PolymorphicValueControl));
        }

        [TestInitialize]
        public void InitializeTest()
        {
            AssertUtilities.WriteLine("Initializing test for OpcLabs.BaseLib.Forms.Common.PolymorphicValueControl...");
        }

        [NotNull]
        public TesterCollection Testers { get; }

        [TestCategory("GeneratedTest")]
        [TestCategory("Forms")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultCtorTester()
        {
            if (!Testers.TryGetValue("DefaultCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("Forms")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultValueDataMemberTester()
        {
            if (!Testers.TryGetValue("DefaultValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }
    }

// ReSharper restore RedundantNameQualifier
}

// ReSharper disable CheckNamespace
namespace OpcLabs.BaseLibTest.Forms.Common
// ReSharper restore CheckNamespace
// ReSharper disable RedundantNameQualifier
{

    [TestClass]
    // ReSharper disable InconsistentNaming
    // ReSharper disable PartialTypeWithSinglePart
    public partial class PopupListViewTest
    // ReSharper restore PartialTypeWithSinglePart
    // ReSharper restore InconsistentNaming
    {
        public PopupListViewTest()
        {
            Testers = TestSuite.GetTypeTesters(typeof(global::OpcLabs.BaseLib.Forms.Common.PopupListView));
        }

        [TestInitialize]
        public void InitializeTest()
        {
            AssertUtilities.WriteLine("Initializing test for OpcLabs.BaseLib.Forms.Common.PopupListView...");
        }

        [NotNull]
        public TesterCollection Testers { get; }

        [TestCategory("GeneratedTest")]
        [TestCategory("Forms")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultValueDataMemberTester()
        {
            if (!Testers.TryGetValue("DefaultValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }
    }

// ReSharper restore RedundantNameQualifier
}

// ReSharper disable CheckNamespace
namespace OpcLabs.BaseLibTest.Forms.Common
// ReSharper restore CheckNamespace
// ReSharper disable RedundantNameQualifier
{

    [TestClass]
    // ReSharper disable InconsistentNaming
    // ReSharper disable PartialTypeWithSinglePart
    public partial class PresentationSchemeTest
    // ReSharper restore PartialTypeWithSinglePart
    // ReSharper restore InconsistentNaming
    {
        public PresentationSchemeTest()
        {
            Testers = TestSuite.GetTypeTesters(typeof(global::OpcLabs.BaseLib.Forms.Common.PresentationScheme));
        }

        [TestInitialize]
        public void InitializeTest()
        {
            AssertUtilities.WriteLine("Initializing test for OpcLabs.BaseLib.Forms.Common.PresentationScheme...");
        }

        [NotNull]
        public TesterCollection Testers { get; }

        [TestCategory("GeneratedTest")]
        [TestCategory("Forms")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultCtorTester()
        {
            if (!Testers.TryGetValue("DefaultCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("Forms")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void InvalidValueDataMemberTester()
        {
            if (!Testers.TryGetValue("InvalidValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }
    }

// ReSharper restore RedundantNameQualifier
}

// ReSharper disable CheckNamespace
namespace OpcLabs.BaseLibTest.Forms.Common
// ReSharper restore CheckNamespace
// ReSharper disable RedundantNameQualifier
{

    [TestClass]
    // ReSharper disable InconsistentNaming
    // ReSharper disable PartialTypeWithSinglePart
    public partial class ProgressFormTest
    // ReSharper restore PartialTypeWithSinglePart
    // ReSharper restore InconsistentNaming
    {
        public ProgressFormTest()
        {
            Testers = TestSuite.GetTypeTesters(typeof(global::OpcLabs.BaseLib.Forms.Common.ProgressForm));
        }

        [TestInitialize]
        public void InitializeTest()
        {
            AssertUtilities.WriteLine("Initializing test for OpcLabs.BaseLib.Forms.Common.ProgressForm...");
        }

        [NotNull]
        public TesterCollection Testers { get; }

        [TestCategory("GeneratedTest")]
        [TestCategory("Forms")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultCtorTester()
        {
            if (!Testers.TryGetValue("DefaultCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }
    }

// ReSharper restore RedundantNameQualifier
}

// ReSharper disable CheckNamespace
namespace OpcLabs.BaseLibTest.Forms.Common
// ReSharper restore CheckNamespace
// ReSharper disable RedundantNameQualifier
{

    [TestClass]
    // ReSharper disable InconsistentNaming
    // ReSharper disable PartialTypeWithSinglePart
    public partial class PropertyCustomOrderTabTest
    // ReSharper restore PartialTypeWithSinglePart
    // ReSharper restore InconsistentNaming
    {
        public PropertyCustomOrderTabTest()
        {
            Testers = TestSuite.GetTypeTesters(typeof(global::OpcLabs.BaseLib.Forms.Common.PropertyCustomOrderTab));
        }

        [TestInitialize]
        public void InitializeTest()
        {
            AssertUtilities.WriteLine("Initializing test for OpcLabs.BaseLib.Forms.Common.PropertyCustomOrderTab...");
        }

        [NotNull]
        public TesterCollection Testers { get; }

        [TestCategory("GeneratedTest")]
        [TestCategory("Forms")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultCtorTester()
        {
            if (!Testers.TryGetValue("DefaultCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("Forms")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ShouldSerializeTester()
        {
            if (!Testers.TryGetValue("ShouldSerializeTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }
    }

// ReSharper restore RedundantNameQualifier
}

// ReSharper disable CheckNamespace
namespace OpcLabs.BaseLibTest.Forms.Common
// ReSharper restore CheckNamespace
// ReSharper disable RedundantNameQualifier
{

    [TestClass]
    // ReSharper disable InconsistentNaming
    // ReSharper disable PartialTypeWithSinglePart
    public partial class PropertyDescriptorCustomOrderComparerTest
    // ReSharper restore PartialTypeWithSinglePart
    // ReSharper restore InconsistentNaming
    {
        public PropertyDescriptorCustomOrderComparerTest()
        {
            Testers = TestSuite.GetTypeTesters(typeof(global::OpcLabs.BaseLib.Forms.Common.PropertyDescriptorCustomOrderComparer));
        }

        [TestInitialize]
        public void InitializeTest()
        {
            AssertUtilities.WriteLine("Initializing test for OpcLabs.BaseLib.Forms.Common.PropertyDescriptorCustomOrderComparer...");
        }

        [NotNull]
        public TesterCollection Testers { get; }

        [TestCategory("GeneratedTest")]
        [TestCategory("Forms")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultCtorTester()
        {
            if (!Testers.TryGetValue("DefaultCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }
    }

// ReSharper restore RedundantNameQualifier
}

// ReSharper disable CheckNamespace
namespace OpcLabs.BaseLibTest.Forms.Common
// ReSharper restore CheckNamespace
// ReSharper disable RedundantNameQualifier
{

    [TestClass]
    // ReSharper disable InconsistentNaming
    // ReSharper disable PartialTypeWithSinglePart
    public partial class PropertyGridControlTest
    // ReSharper restore PartialTypeWithSinglePart
    // ReSharper restore InconsistentNaming
    {
        public PropertyGridControlTest()
        {
            Testers = TestSuite.GetTypeTesters(typeof(global::OpcLabs.BaseLib.Forms.Common.PropertyGridControl));
        }

        [TestInitialize]
        public void InitializeTest()
        {
            AssertUtilities.WriteLine("Initializing test for OpcLabs.BaseLib.Forms.Common.PropertyGridControl...");
        }

        [NotNull]
        public TesterCollection Testers { get; }

        [TestCategory("GeneratedTest")]
        [TestCategory("Forms")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultCtorTester()
        {
            if (!Testers.TryGetValue("DefaultCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("Forms")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultValueDataMemberTester()
        {
            if (!Testers.TryGetValue("DefaultValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }
    }

// ReSharper restore RedundantNameQualifier
}

// ReSharper disable CheckNamespace
namespace OpcLabs.BaseLibTest.Forms.Common
// ReSharper restore CheckNamespace
// ReSharper disable RedundantNameQualifier
{

    [TestClass]
    // ReSharper disable InconsistentNaming
    // ReSharper disable PartialTypeWithSinglePart
    public partial class PropertyGridFormTest
    // ReSharper restore PartialTypeWithSinglePart
    // ReSharper restore InconsistentNaming
    {
        public PropertyGridFormTest()
        {
            Testers = TestSuite.GetTypeTesters(typeof(global::OpcLabs.BaseLib.Forms.Common.PropertyGridForm));
        }

        [TestInitialize]
        public void InitializeTest()
        {
            AssertUtilities.WriteLine("Initializing test for OpcLabs.BaseLib.Forms.Common.PropertyGridForm...");
        }

        [NotNull]
        public TesterCollection Testers { get; }

        [TestCategory("GeneratedTest")]
        [TestCategory("Forms")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultCtorTester()
        {
            if (!Testers.TryGetValue("DefaultCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("Forms")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultValueDataMemberTester()
        {
            if (!Testers.TryGetValue("DefaultValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("Forms")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ShouldSerializeTester()
        {
            if (!Testers.TryGetValue("ShouldSerializeTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }
    }

// ReSharper restore RedundantNameQualifier
}

// ReSharper disable CheckNamespace
namespace OpcLabs.BaseLibTest.Forms.Common
// ReSharper restore CheckNamespace
// ReSharper disable RedundantNameQualifier
{

    [TestClass]
    // ReSharper disable InconsistentNaming
    // ReSharper disable PartialTypeWithSinglePart
    public partial class PropertyGridToStringOptionsTest
    // ReSharper restore PartialTypeWithSinglePart
    // ReSharper restore InconsistentNaming
    {
        public PropertyGridToStringOptionsTest()
        {
            Testers = TestSuite.GetTypeTesters(typeof(global::OpcLabs.BaseLib.Forms.Common.PropertyGridToStringOptions));
        }

        [TestInitialize]
        public void InitializeTest()
        {
            AssertUtilities.WriteLine("Initializing test for OpcLabs.BaseLib.Forms.Common.PropertyGridToStringOptions...");
        }

        [NotNull]
        public TesterCollection Testers { get; }

        [TestCategory("GeneratedTest")]
        [TestCategory("Forms")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultCtorTester()
        {
            if (!Testers.TryGetValue("DefaultCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("Forms")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void InvalidValueDataMemberTester()
        {
            if (!Testers.TryGetValue("InvalidValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }
    }

// ReSharper restore RedundantNameQualifier
}

// ReSharper disable CheckNamespace
namespace OpcLabs.BaseLibTest.Forms.Common
// ReSharper restore CheckNamespace
// ReSharper disable RedundantNameQualifier
{

    [TestClass]
    // ReSharper disable InconsistentNaming
    // ReSharper disable PartialTypeWithSinglePart
    public partial class PropertyGuidAttributeTest
    // ReSharper restore PartialTypeWithSinglePart
    // ReSharper restore InconsistentNaming
    {
        public PropertyGuidAttributeTest()
        {
            Testers = TestSuite.GetTypeTesters(typeof(global::OpcLabs.BaseLib.Forms.Common.PropertyGuidAttribute));
        }

        [TestInitialize]
        public void InitializeTest()
        {
            AssertUtilities.WriteLine("Initializing test for OpcLabs.BaseLib.Forms.Common.PropertyGuidAttribute...");
        }

        [NotNull]
        public TesterCollection Testers { get; }

        [TestCategory("GeneratedTest")]
        [TestCategory("Forms")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultCtorTester()
        {
            if (!Testers.TryGetValue("DefaultCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }
    }

// ReSharper restore RedundantNameQualifier
}

// ReSharper disable CheckNamespace
namespace OpcLabs.BaseLibTest.Forms.Common
// ReSharper restore CheckNamespace
// ReSharper disable RedundantNameQualifier
{

    [TestClass]
    // ReSharper disable InconsistentNaming
    // ReSharper disable PartialTypeWithSinglePart
    public partial class ResourceDescriptorControlTest
    // ReSharper restore PartialTypeWithSinglePart
    // ReSharper restore InconsistentNaming
    {
        public ResourceDescriptorControlTest()
        {
            Testers = TestSuite.GetTypeTesters(typeof(global::OpcLabs.BaseLib.Forms.Common.ResourceDescriptorControl));
        }

        [TestInitialize]
        public void InitializeTest()
        {
            AssertUtilities.WriteLine("Initializing test for OpcLabs.BaseLib.Forms.Common.ResourceDescriptorControl...");
        }

        [NotNull]
        public TesterCollection Testers { get; }

        [TestCategory("GeneratedTest")]
        [TestCategory("Forms")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultCtorTester()
        {
            if (!Testers.TryGetValue("DefaultCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("Forms")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultValueDataMemberTester()
        {
            if (!Testers.TryGetValue("DefaultValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }
    }

// ReSharper restore RedundantNameQualifier
}

// ReSharper disable CheckNamespace
namespace OpcLabs.BaseLibTest.Forms.Common
// ReSharper restore CheckNamespace
// ReSharper disable RedundantNameQualifier
{

    [TestClass]
    // ReSharper disable InconsistentNaming
    // ReSharper disable PartialTypeWithSinglePart
    public partial class RichTextBoxContextMenuStripTest
    // ReSharper restore PartialTypeWithSinglePart
    // ReSharper restore InconsistentNaming
    {
        public RichTextBoxContextMenuStripTest()
        {
            Testers = TestSuite.GetTypeTesters(typeof(global::OpcLabs.BaseLib.Forms.Common.RichTextBoxContextMenuStrip));
        }

        [TestInitialize]
        public void InitializeTest()
        {
            AssertUtilities.WriteLine("Initializing test for OpcLabs.BaseLib.Forms.Common.RichTextBoxContextMenuStrip...");
        }

        [NotNull]
        public TesterCollection Testers { get; }

        [TestCategory("GeneratedTest")]
        [TestCategory("Forms")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultCtorTester()
        {
            if (!Testers.TryGetValue("DefaultCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("Forms")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultValueDataMemberTester()
        {
            if (!Testers.TryGetValue("DefaultValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }
    }

// ReSharper restore RedundantNameQualifier
}

// ReSharper disable CheckNamespace
namespace OpcLabs.BaseLibTest.Forms.Common
// ReSharper restore CheckNamespace
// ReSharper disable RedundantNameQualifier
{

    [TestClass]
    // ReSharper disable InconsistentNaming
    // ReSharper disable PartialTypeWithSinglePart
    public partial class RichTextBuilderTest
    // ReSharper restore PartialTypeWithSinglePart
    // ReSharper restore InconsistentNaming
    {
        public RichTextBuilderTest()
        {
            Testers = TestSuite.GetTypeTesters(typeof(global::OpcLabs.BaseLib.Forms.Common.RichTextBuilder));
        }

        [TestInitialize]
        public void InitializeTest()
        {
            AssertUtilities.WriteLine("Initializing test for OpcLabs.BaseLib.Forms.Common.RichTextBuilder...");
        }

        [NotNull]
        public TesterCollection Testers { get; }

        [TestCategory("GeneratedTest")]
        [TestCategory("Forms")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultCtorTester()
        {
            if (!Testers.TryGetValue("DefaultCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("Forms")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void InvalidValueDataMemberTester()
        {
            if (!Testers.TryGetValue("InvalidValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }
    }

// ReSharper restore RedundantNameQualifier
}

// ReSharper disable CheckNamespace
namespace OpcLabs.BaseLibTest.Forms.Common
// ReSharper restore CheckNamespace
// ReSharper disable RedundantNameQualifier
{

    [TestClass]
    // ReSharper disable InconsistentNaming
    // ReSharper disable PartialTypeWithSinglePart
    public partial class RichTextStyleTest
    // ReSharper restore PartialTypeWithSinglePart
    // ReSharper restore InconsistentNaming
    {
        public RichTextStyleTest()
        {
            Testers = TestSuite.GetTypeTesters(typeof(global::OpcLabs.BaseLib.Forms.Common.RichTextStyle));
        }

        [TestInitialize]
        public void InitializeTest()
        {
            AssertUtilities.WriteLine("Initializing test for OpcLabs.BaseLib.Forms.Common.RichTextStyle...");
        }

        [NotNull]
        public TesterCollection Testers { get; }

        [TestCategory("GeneratedTest")]
        [TestCategory("Forms")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultCtorTester()
        {
            if (!Testers.TryGetValue("DefaultCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("Forms")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void InvalidValueDataMemberTester()
        {
            if (!Testers.TryGetValue("InvalidValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }
    }

// ReSharper restore RedundantNameQualifier
}

// ReSharper disable CheckNamespace
namespace OpcLabs.BaseLibTest.Forms.Common
// ReSharper restore CheckNamespace
// ReSharper disable RedundantNameQualifier
{

    [TestClass]
    // ReSharper disable InconsistentNaming
    // ReSharper disable PartialTypeWithSinglePart
    public partial class SearchBoxOptionsTest
    // ReSharper restore PartialTypeWithSinglePart
    // ReSharper restore InconsistentNaming
    {
        public SearchBoxOptionsTest()
        {
            Testers = TestSuite.GetTypeTesters(typeof(global::OpcLabs.BaseLib.Forms.Common.SearchBoxOptions));
        }

        [TestInitialize]
        public void InitializeTest()
        {
            AssertUtilities.WriteLine("Initializing test for OpcLabs.BaseLib.Forms.Common.SearchBoxOptions...");
        }

        [NotNull]
        public TesterCollection Testers { get; }

        [TestCategory("GeneratedTest")]
        [TestCategory("Forms")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultCtorTester()
        {
            if (!Testers.TryGetValue("DefaultCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("Forms")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultValueDataMemberTester()
        {
            if (!Testers.TryGetValue("DefaultValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }
    }

// ReSharper restore RedundantNameQualifier
}

// ReSharper disable CheckNamespace
namespace OpcLabs.BaseLibTest.Forms.Common
// ReSharper restore CheckNamespace
// ReSharper disable RedundantNameQualifier
{

    [TestClass]
    // ReSharper disable InconsistentNaming
    // ReSharper disable PartialTypeWithSinglePart
    public partial class ServiceScopeControlTest
    // ReSharper restore PartialTypeWithSinglePart
    // ReSharper restore InconsistentNaming
    {
        public ServiceScopeControlTest()
        {
            Testers = TestSuite.GetTypeTesters(typeof(global::OpcLabs.BaseLib.Forms.Common.ServiceScopeControl));
        }

        [TestInitialize]
        public void InitializeTest()
        {
            AssertUtilities.WriteLine("Initializing test for OpcLabs.BaseLib.Forms.Common.ServiceScopeControl...");
        }

        [NotNull]
        public TesterCollection Testers { get; }

        [TestCategory("GeneratedTest")]
        [TestCategory("Forms")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultCtorTester()
        {
            if (!Testers.TryGetValue("DefaultCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("Forms")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultValueDataMemberTester()
        {
            if (!Testers.TryGetValue("DefaultValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }
    }

// ReSharper restore RedundantNameQualifier
}

// ReSharper disable CheckNamespace
namespace OpcLabs.BaseLibTest.Forms.Common
// ReSharper restore CheckNamespace
// ReSharper disable RedundantNameQualifier
{

    [TestClass]
    // ReSharper disable InconsistentNaming
    // ReSharper disable PartialTypeWithSinglePart
    public partial class ShortcutKeyProviderTest
    // ReSharper restore PartialTypeWithSinglePart
    // ReSharper restore InconsistentNaming
    {
        public ShortcutKeyProviderTest()
        {
            Testers = TestSuite.GetTypeTesters(typeof(global::OpcLabs.BaseLib.Forms.Common.ShortcutKeyProvider));
        }

        [TestInitialize]
        public void InitializeTest()
        {
            AssertUtilities.WriteLine("Initializing test for OpcLabs.BaseLib.Forms.Common.ShortcutKeyProvider...");
        }

        [NotNull]
        public TesterCollection Testers { get; }

        [TestCategory("GeneratedTest")]
        [TestCategory("Forms")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultCtorTester()
        {
            if (!Testers.TryGetValue("DefaultCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }
    }

// ReSharper restore RedundantNameQualifier
}

// ReSharper disable CheckNamespace
namespace OpcLabs.BaseLibTest.Forms.Common
// ReSharper restore CheckNamespace
// ReSharper disable RedundantNameQualifier
{

    [TestClass]
    // ReSharper disable InconsistentNaming
    // ReSharper disable PartialTypeWithSinglePart
    public partial class SimpleNotifierTest
    // ReSharper restore PartialTypeWithSinglePart
    // ReSharper restore InconsistentNaming
    {
        public SimpleNotifierTest()
        {
            Testers = TestSuite.GetTypeTesters(typeof(global::OpcLabs.BaseLib.Forms.Common.SimpleNotifier));
        }

        [TestInitialize]
        public void InitializeTest()
        {
            AssertUtilities.WriteLine("Initializing test for OpcLabs.BaseLib.Forms.Common.SimpleNotifier...");
        }

        [NotNull]
        public TesterCollection Testers { get; }

        [TestCategory("GeneratedTest")]
        [TestCategory("Forms")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultCtorTester()
        {
            if (!Testers.TryGetValue("DefaultCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }
    }

// ReSharper restore RedundantNameQualifier
}

// ReSharper disable CheckNamespace
namespace OpcLabs.BaseLibTest.Forms.Common
// ReSharper restore CheckNamespace
// ReSharper disable RedundantNameQualifier
{

    [TestClass]
    // ReSharper disable InconsistentNaming
    // ReSharper disable PartialTypeWithSinglePart
    public partial class SimpleNotifierFormTest
    // ReSharper restore PartialTypeWithSinglePart
    // ReSharper restore InconsistentNaming
    {
        public SimpleNotifierFormTest()
        {
            Testers = TestSuite.GetTypeTesters(typeof(global::OpcLabs.BaseLib.Forms.Common.SimpleNotifierForm));
        }

        [TestInitialize]
        public void InitializeTest()
        {
            AssertUtilities.WriteLine("Initializing test for OpcLabs.BaseLib.Forms.Common.SimpleNotifierForm...");
        }

        [NotNull]
        public TesterCollection Testers { get; }

        [TestCategory("GeneratedTest")]
        [TestCategory("Forms")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultCtorTester()
        {
            if (!Testers.TryGetValue("DefaultCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("Forms")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultValueDataMemberTester()
        {
            if (!Testers.TryGetValue("DefaultValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("Forms")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ShouldSerializeTester()
        {
            if (!Testers.TryGetValue("ShouldSerializeTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }
    }

// ReSharper restore RedundantNameQualifier
}

// ReSharper disable CheckNamespace
namespace OpcLabs.BaseLibTest.Forms.Common
// ReSharper restore CheckNamespace
// ReSharper disable RedundantNameQualifier
{

    [TestClass]
    // ReSharper disable InconsistentNaming
    // ReSharper disable PartialTypeWithSinglePart
    public partial class StringInputFormTest
    // ReSharper restore PartialTypeWithSinglePart
    // ReSharper restore InconsistentNaming
    {
        public StringInputFormTest()
        {
            Testers = TestSuite.GetTypeTesters(typeof(global::OpcLabs.BaseLib.Forms.Common.StringInputForm));
        }

        [TestInitialize]
        public void InitializeTest()
        {
            AssertUtilities.WriteLine("Initializing test for OpcLabs.BaseLib.Forms.Common.StringInputForm...");
        }

        [NotNull]
        public TesterCollection Testers { get; }

        [TestCategory("GeneratedTest")]
        [TestCategory("Forms")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultCtorTester()
        {
            if (!Testers.TryGetValue("DefaultCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("Forms")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultValueDataMemberTester()
        {
            if (!Testers.TryGetValue("DefaultValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("Forms")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ShouldSerializeTester()
        {
            if (!Testers.TryGetValue("ShouldSerializeTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }
    }

// ReSharper restore RedundantNameQualifier
}

// ReSharper disable CheckNamespace
namespace OpcLabs.BaseLibTest.Forms.Common
// ReSharper restore CheckNamespace
// ReSharper disable RedundantNameQualifier
{

    [TestClass]
    // ReSharper disable InconsistentNaming
    // ReSharper disable PartialTypeWithSinglePart
    public partial class StringObjectDictionaryViewTest
    // ReSharper restore PartialTypeWithSinglePart
    // ReSharper restore InconsistentNaming
    {
        public StringObjectDictionaryViewTest()
        {
            Testers = TestSuite.GetTypeTesters(typeof(global::OpcLabs.BaseLib.Forms.Common.StringObjectDictionaryView));
        }

        [TestInitialize]
        public void InitializeTest()
        {
            AssertUtilities.WriteLine("Initializing test for OpcLabs.BaseLib.Forms.Common.StringObjectDictionaryView...");
        }

        [NotNull]
        public TesterCollection Testers { get; }

        [TestCategory("GeneratedTest")]
        [TestCategory("Forms")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultCtorTester()
        {
            if (!Testers.TryGetValue("DefaultCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("Forms")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultValueDataMemberTester()
        {
            if (!Testers.TryGetValue("DefaultValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }
    }

// ReSharper restore RedundantNameQualifier
}

// ReSharper disable CheckNamespace
namespace OpcLabs.BaseLibTest.Forms.Common
// ReSharper restore CheckNamespace
// ReSharper disable RedundantNameQualifier
{

    [TestClass]
    // ReSharper disable InconsistentNaming
    // ReSharper disable PartialTypeWithSinglePart
    public partial class TabControl2Test
    // ReSharper restore PartialTypeWithSinglePart
    // ReSharper restore InconsistentNaming
    {
        public TabControl2Test()
        {
            Testers = TestSuite.GetTypeTesters(typeof(global::OpcLabs.BaseLib.Forms.Common.TabControl2));
        }

        [TestInitialize]
        public void InitializeTest()
        {
            AssertUtilities.WriteLine("Initializing test for OpcLabs.BaseLib.Forms.Common.TabControl2...");
        }

        [NotNull]
        public TesterCollection Testers { get; }

        [TestCategory("GeneratedTest")]
        [TestCategory("Forms")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultCtorTester()
        {
            if (!Testers.TryGetValue("DefaultCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }
    }

// ReSharper restore RedundantNameQualifier
}

// ReSharper disable CheckNamespace
namespace OpcLabs.BaseLibTest.Forms.Common
// ReSharper restore CheckNamespace
// ReSharper disable RedundantNameQualifier
{

    [TestClass]
    // ReSharper disable InconsistentNaming
    // ReSharper disable PartialTypeWithSinglePart
    public partial class TextStyleTest
    // ReSharper restore PartialTypeWithSinglePart
    // ReSharper restore InconsistentNaming
    {
        public TextStyleTest()
        {
            Testers = TestSuite.GetTypeTesters(typeof(global::OpcLabs.BaseLib.Forms.Common.TextStyle));
        }

        [TestInitialize]
        public void InitializeTest()
        {
            AssertUtilities.WriteLine("Initializing test for OpcLabs.BaseLib.Forms.Common.TextStyle...");
        }

        [NotNull]
        public TesterCollection Testers { get; }

        [TestCategory("GeneratedTest")]
        [TestCategory("Forms")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultCtorTester()
        {
            if (!Testers.TryGetValue("DefaultCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("Forms")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void InvalidValueDataMemberTester()
        {
            if (!Testers.TryGetValue("InvalidValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }
    }

// ReSharper restore RedundantNameQualifier
}

// ReSharper disable CheckNamespace
namespace OpcLabs.BaseLibTest.Forms.Common
// ReSharper restore CheckNamespace
// ReSharper disable RedundantNameQualifier
{

    [TestClass]
    // ReSharper disable InconsistentNaming
    // ReSharper disable PartialTypeWithSinglePart
    public partial class TimeSpanInputTest
    // ReSharper restore PartialTypeWithSinglePart
    // ReSharper restore InconsistentNaming
    {
        public TimeSpanInputTest()
        {
            Testers = TestSuite.GetTypeTesters(typeof(global::OpcLabs.BaseLib.Forms.Common.TimeSpanInput));
        }

        [TestInitialize]
        public void InitializeTest()
        {
            AssertUtilities.WriteLine("Initializing test for OpcLabs.BaseLib.Forms.Common.TimeSpanInput...");
        }

        [NotNull]
        public TesterCollection Testers { get; }

        [TestCategory("GeneratedTest")]
        [TestCategory("Forms")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultCtorTester()
        {
            if (!Testers.TryGetValue("DefaultCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("Forms")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultValueDataMemberTester()
        {
            if (!Testers.TryGetValue("DefaultValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("Forms")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ShouldSerializeTester()
        {
            if (!Testers.TryGetValue("ShouldSerializeTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }
    }

// ReSharper restore RedundantNameQualifier
}

// ReSharper disable CheckNamespace
namespace OpcLabs.BaseLibTest.Forms.Common
// ReSharper restore CheckNamespace
// ReSharper disable RedundantNameQualifier
{

    [TestClass]
    // ReSharper disable InconsistentNaming
    // ReSharper disable PartialTypeWithSinglePart
    public partial class TimeSpanPickerTest
    // ReSharper restore PartialTypeWithSinglePart
    // ReSharper restore InconsistentNaming
    {
        public TimeSpanPickerTest()
        {
            Testers = TestSuite.GetTypeTesters(typeof(global::OpcLabs.BaseLib.Forms.Common.TimeSpanPicker));
        }

        [TestInitialize]
        public void InitializeTest()
        {
            AssertUtilities.WriteLine("Initializing test for OpcLabs.BaseLib.Forms.Common.TimeSpanPicker...");
        }

        [NotNull]
        public TesterCollection Testers { get; }

        [TestCategory("GeneratedTest")]
        [TestCategory("Forms")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultCtorTester()
        {
            if (!Testers.TryGetValue("DefaultCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("Forms")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultValueDataMemberTester()
        {
            if (!Testers.TryGetValue("DefaultValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }
    }

// ReSharper restore RedundantNameQualifier
}

// ReSharper disable CheckNamespace
namespace OpcLabs.BaseLibTest.Forms.Common
// ReSharper restore CheckNamespace
// ReSharper disable RedundantNameQualifier
{

    [TestClass]
    // ReSharper disable InconsistentNaming
    // ReSharper disable PartialTypeWithSinglePart
    public partial class ToolStripProfessionalRenderer2Test
    // ReSharper restore PartialTypeWithSinglePart
    // ReSharper restore InconsistentNaming
    {
        public ToolStripProfessionalRenderer2Test()
        {
            Testers = TestSuite.GetTypeTesters(typeof(global::OpcLabs.BaseLib.Forms.Common.ToolStripProfessionalRenderer2));
        }

        [TestInitialize]
        public void InitializeTest()
        {
            AssertUtilities.WriteLine("Initializing test for OpcLabs.BaseLib.Forms.Common.ToolStripProfessionalRenderer2...");
        }

        [NotNull]
        public TesterCollection Testers { get; }

        [TestCategory("GeneratedTest")]
        [TestCategory("Forms")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultCtorTester()
        {
            if (!Testers.TryGetValue("DefaultCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }
    }

// ReSharper restore RedundantNameQualifier
}

// ReSharper disable CheckNamespace
namespace OpcLabs.BaseLibTest.Forms.Common
// ReSharper restore CheckNamespace
// ReSharper disable RedundantNameQualifier
{

    [TestClass]
    // ReSharper disable InconsistentNaming
    // ReSharper disable PartialTypeWithSinglePart
    public partial class ToolStripSplitButton2Test
    // ReSharper restore PartialTypeWithSinglePart
    // ReSharper restore InconsistentNaming
    {
        public ToolStripSplitButton2Test()
        {
            Testers = TestSuite.GetTypeTesters(typeof(global::OpcLabs.BaseLib.Forms.Common.ToolStripSplitButton2));
        }

        [TestInitialize]
        public void InitializeTest()
        {
            AssertUtilities.WriteLine("Initializing test for OpcLabs.BaseLib.Forms.Common.ToolStripSplitButton2...");
        }

        [NotNull]
        public TesterCollection Testers { get; }

        [TestCategory("GeneratedTest")]
        [TestCategory("Forms")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultCtorTester()
        {
            if (!Testers.TryGetValue("DefaultCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }
    }

// ReSharper restore RedundantNameQualifier
}

// ReSharper disable CheckNamespace
namespace OpcLabs.BaseLibTest.Forms.Common
// ReSharper restore CheckNamespace
// ReSharper disable RedundantNameQualifier
{

    [TestClass]
    // ReSharper disable InconsistentNaming
    // ReSharper disable PartialTypeWithSinglePart
    public partial class ToolTip2Test
    // ReSharper restore PartialTypeWithSinglePart
    // ReSharper restore InconsistentNaming
    {
        public ToolTip2Test()
        {
            Testers = TestSuite.GetTypeTesters(typeof(global::OpcLabs.BaseLib.Forms.Common.ToolTip2));
        }

        [TestInitialize]
        public void InitializeTest()
        {
            AssertUtilities.WriteLine("Initializing test for OpcLabs.BaseLib.Forms.Common.ToolTip2...");
        }

        [NotNull]
        public TesterCollection Testers { get; }

        [TestCategory("GeneratedTest")]
        [TestCategory("Forms")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultCtorTester()
        {
            if (!Testers.TryGetValue("DefaultCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }
    }

// ReSharper restore RedundantNameQualifier
}

// ReSharper disable CheckNamespace
namespace OpcLabs.BaseLibTest.Forms.Common
// ReSharper restore CheckNamespace
// ReSharper disable RedundantNameQualifier
{

    [TestClass]
    // ReSharper disable InconsistentNaming
    // ReSharper disable PartialTypeWithSinglePart
    public partial class TreeNodeWithPropertiesTest
    // ReSharper restore PartialTypeWithSinglePart
    // ReSharper restore InconsistentNaming
    {
        public TreeNodeWithPropertiesTest()
        {
            Testers = TestSuite.GetTypeTesters(typeof(global::OpcLabs.BaseLib.Forms.Common.TreeNodeWithProperties));
        }

        [TestInitialize]
        public void InitializeTest()
        {
            AssertUtilities.WriteLine("Initializing test for OpcLabs.BaseLib.Forms.Common.TreeNodeWithProperties...");
        }

        [NotNull]
        public TesterCollection Testers { get; }

        [TestCategory("GeneratedTest")]
        [TestCategory("Forms")]
        [TestCategory("Cloning")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ICloneableTester()
        {
            if (!Testers.TryGetValue("ICloneableTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }
    }

// ReSharper restore RedundantNameQualifier
}

// ReSharper disable CheckNamespace
namespace OpcLabs.BaseLibTest.Forms.Common
// ReSharper restore CheckNamespace
// ReSharper disable RedundantNameQualifier
{

    [TestClass]
    // ReSharper disable InconsistentNaming
    // ReSharper disable PartialTypeWithSinglePart
    public partial class TypedValueControlTest
    // ReSharper restore PartialTypeWithSinglePart
    // ReSharper restore InconsistentNaming
    {
        public TypedValueControlTest()
        {
            Testers = TestSuite.GetTypeTesters(typeof(global::OpcLabs.BaseLib.Forms.Common.TypedValueControl));
        }

        [TestInitialize]
        public void InitializeTest()
        {
            AssertUtilities.WriteLine("Initializing test for OpcLabs.BaseLib.Forms.Common.TypedValueControl...");
        }

        [NotNull]
        public TesterCollection Testers { get; }

        [TestCategory("GeneratedTest")]
        [TestCategory("Forms")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultCtorTester()
        {
            if (!Testers.TryGetValue("DefaultCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }
    }

// ReSharper restore RedundantNameQualifier
}

// ReSharper disable CheckNamespace
namespace OpcLabs.BaseLibTest.Forms.Common
// ReSharper restore CheckNamespace
// ReSharper disable RedundantNameQualifier
{

    [TestClass]
    // ReSharper disable InconsistentNaming
    // ReSharper disable PartialTypeWithSinglePart
    public partial class UniversalValueControlTest
    // ReSharper restore PartialTypeWithSinglePart
    // ReSharper restore InconsistentNaming
    {
        public UniversalValueControlTest()
        {
            Testers = TestSuite.GetTypeTesters(typeof(global::OpcLabs.BaseLib.Forms.Common.UniversalValueControl));
        }

        [TestInitialize]
        public void InitializeTest()
        {
            AssertUtilities.WriteLine("Initializing test for OpcLabs.BaseLib.Forms.Common.UniversalValueControl...");
        }

        [NotNull]
        public TesterCollection Testers { get; }

        [TestCategory("GeneratedTest")]
        [TestCategory("Forms")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultCtorTester()
        {
            if (!Testers.TryGetValue("DefaultCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("Forms")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultValueDataMemberTester()
        {
            if (!Testers.TryGetValue("DefaultValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }
    }

// ReSharper restore RedundantNameQualifier
}

// ReSharper disable CheckNamespace
namespace OpcLabs.BaseLibTest.Forms.Common
// ReSharper restore CheckNamespace
// ReSharper disable RedundantNameQualifier
{

    [TestClass]
    // ReSharper disable InconsistentNaming
    // ReSharper disable PartialTypeWithSinglePart
    public partial class UriStringInputTest
    // ReSharper restore PartialTypeWithSinglePart
    // ReSharper restore InconsistentNaming
    {
        public UriStringInputTest()
        {
            Testers = TestSuite.GetTypeTesters(typeof(global::OpcLabs.BaseLib.Forms.Common.UriStringInput));
        }

        [TestInitialize]
        public void InitializeTest()
        {
            AssertUtilities.WriteLine("Initializing test for OpcLabs.BaseLib.Forms.Common.UriStringInput...");
        }

        [NotNull]
        public TesterCollection Testers { get; }

        [TestCategory("GeneratedTest")]
        [TestCategory("Forms")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultCtorTester()
        {
            if (!Testers.TryGetValue("DefaultCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }
    }

// ReSharper restore RedundantNameQualifier
}

// ReSharper disable CheckNamespace
namespace OpcLabs.BaseLibTest.Forms.Common
// ReSharper restore CheckNamespace
// ReSharper disable RedundantNameQualifier
{

    [TestClass]
    // ReSharper disable InconsistentNaming
    // ReSharper disable PartialTypeWithSinglePart
    public partial class XmlColorTest
    // ReSharper restore PartialTypeWithSinglePart
    // ReSharper restore InconsistentNaming
    {
        public XmlColorTest()
        {
            Testers = TestSuite.GetTypeTesters(typeof(global::OpcLabs.BaseLib.Forms.Common.XmlColor));
        }

        [TestInitialize]
        public void InitializeTest()
        {
            AssertUtilities.WriteLine("Initializing test for OpcLabs.BaseLib.Forms.Common.XmlColor...");
        }

        [NotNull]
        public TesterCollection Testers { get; }

        [TestCategory("GeneratedTest")]
        [TestCategory("Forms")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultCtorTester()
        {
            if (!Testers.TryGetValue("DefaultCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }
    }

// ReSharper restore RedundantNameQualifier
}

// ReSharper disable CheckNamespace
namespace OpcLabs.BaseLibTest.Forms.Common
// ReSharper restore CheckNamespace
// ReSharper disable RedundantNameQualifier
{

    [TestClass]
    // ReSharper disable InconsistentNaming
    // ReSharper disable PartialTypeWithSinglePart
    public partial class XmlPenTest
    // ReSharper restore PartialTypeWithSinglePart
    // ReSharper restore InconsistentNaming
    {
        public XmlPenTest()
        {
            Testers = TestSuite.GetTypeTesters(typeof(global::OpcLabs.BaseLib.Forms.Common.XmlPen));
        }

        [TestInitialize]
        public void InitializeTest()
        {
            AssertUtilities.WriteLine("Initializing test for OpcLabs.BaseLib.Forms.Common.XmlPen...");
        }

        [NotNull]
        public TesterCollection Testers { get; }

        [TestCategory("GeneratedTest")]
        [TestCategory("Forms")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultCtorTester()
        {
            if (!Testers.TryGetValue("DefaultCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }
    }

// ReSharper restore RedundantNameQualifier
}

// ReSharper disable CheckNamespace
namespace OpcLabs.BaseLibTest.Forms
// ReSharper restore CheckNamespace
// ReSharper disable RedundantNameQualifier
{

    [TestClass]
    // ReSharper disable InconsistentNaming
    // ReSharper disable PartialTypeWithSinglePart
    public partial class ConcreteCommonDialogTest
    // ReSharper restore PartialTypeWithSinglePart
    // ReSharper restore InconsistentNaming
    {
        public ConcreteCommonDialogTest()
        {
            Testers = TestSuite.GetTypeTesters(typeof(global::OpcLabs.BaseLib.Forms.ConcreteCommonDialog));
        }

        [TestInitialize]
        public void InitializeTest()
        {
            AssertUtilities.WriteLine("Initializing test for OpcLabs.BaseLib.Forms.ConcreteCommonDialog...");
        }

        [NotNull]
        public TesterCollection Testers { get; }

        [TestCategory("GeneratedTest")]
        [TestCategory("Forms")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultCtorTester()
        {
            if (!Testers.TryGetValue("DefaultCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }
    }

// ReSharper restore RedundantNameQualifier
}

// ReSharper disable CheckNamespace
namespace OpcLabs.BaseLibTest.Forms.Connectivity.Browsing
// ReSharper restore CheckNamespace
// ReSharper disable RedundantNameQualifier
{

    [TestClass]
    // ReSharper disable InconsistentNaming
    // ReSharper disable PartialTypeWithSinglePart
    public partial class PointBrowseControlTest
    // ReSharper restore PartialTypeWithSinglePart
    // ReSharper restore InconsistentNaming
    {
        public PointBrowseControlTest()
        {
            Testers = TestSuite.GetTypeTesters(typeof(global::OpcLabs.BaseLib.Forms.Connectivity.Browsing.PointBrowseControl));
        }

        [TestInitialize]
        public void InitializeTest()
        {
            AssertUtilities.WriteLine("Initializing test for OpcLabs.BaseLib.Forms.Connectivity.Browsing.PointBrowseControl...");
        }

        [NotNull]
        public TesterCollection Testers { get; }

        [TestCategory("GeneratedTest")]
        [TestCategory("Forms")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultCtorTester()
        {
            if (!Testers.TryGetValue("DefaultCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("Forms")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultValueDataMemberTester()
        {
            if (!Testers.TryGetValue("DefaultValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("Forms")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void InvalidValueDataMemberTester()
        {
            if (!Testers.TryGetValue("InvalidValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("Forms")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ShouldSerializeTester()
        {
            if (!Testers.TryGetValue("ShouldSerializeTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }
    }

// ReSharper restore RedundantNameQualifier
}

// ReSharper disable CheckNamespace
namespace OpcLabs.BaseLibTest.Forms.Connectivity.Browsing
// ReSharper restore CheckNamespace
// ReSharper disable RedundantNameQualifier
{

    [TestClass]
    // ReSharper disable InconsistentNaming
    // ReSharper disable PartialTypeWithSinglePart
    public partial class PointBrowseDialogTest
    // ReSharper restore PartialTypeWithSinglePart
    // ReSharper restore InconsistentNaming
    {
        public PointBrowseDialogTest()
        {
            Testers = TestSuite.GetTypeTesters(typeof(global::OpcLabs.BaseLib.Forms.Connectivity.Browsing.PointBrowseDialog));
        }

        [TestInitialize]
        public void InitializeTest()
        {
            AssertUtilities.WriteLine("Initializing test for OpcLabs.BaseLib.Forms.Connectivity.Browsing.PointBrowseDialog...");
        }

        [NotNull]
        public TesterCollection Testers { get; }

        [TestCategory("GeneratedTest")]
        [TestCategory("Forms")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultCtorTester()
        {
            if (!Testers.TryGetValue("DefaultCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("Forms")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultValueDataMemberTester()
        {
            if (!Testers.TryGetValue("DefaultValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("Forms")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ShouldSerializeTester()
        {
            if (!Testers.TryGetValue("ShouldSerializeTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }
    }

// ReSharper restore RedundantNameQualifier
}

// ReSharper disable CheckNamespace
namespace OpcLabs.BaseLibTest.Forms.Connectivity.Data
// ReSharper restore CheckNamespace
// ReSharper disable RedundantNameQualifier
{

    [TestClass]
    // ReSharper disable InconsistentNaming
    // ReSharper disable PartialTypeWithSinglePart
    public partial class LivePointDataCellTest
    // ReSharper restore PartialTypeWithSinglePart
    // ReSharper restore InconsistentNaming
    {
        public LivePointDataCellTest()
        {
            Testers = TestSuite.GetTypeTesters(typeof(global::OpcLabs.BaseLib.Forms.Connectivity.Data.LivePointDataCell));
        }

        [TestInitialize]
        public void InitializeTest()
        {
            AssertUtilities.WriteLine("Initializing test for OpcLabs.BaseLib.Forms.Connectivity.Data.LivePointDataCell...");
        }

        [NotNull]
        public TesterCollection Testers { get; }

        [TestCategory("GeneratedTest")]
        [TestCategory("Forms")]
        [TestCategory("Cloning")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ICloneableTester()
        {
            if (!Testers.TryGetValue("ICloneableTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }
    }

// ReSharper restore RedundantNameQualifier
}

// ReSharper disable CheckNamespace
namespace OpcLabs.BaseLibTest.Forms.Connectivity.Data
// ReSharper restore CheckNamespace
// ReSharper disable RedundantNameQualifier
{

    [TestClass]
    // ReSharper disable InconsistentNaming
    // ReSharper disable PartialTypeWithSinglePart
    public partial class LivePointDataViewTest
    // ReSharper restore PartialTypeWithSinglePart
    // ReSharper restore InconsistentNaming
    {
        public LivePointDataViewTest()
        {
            Testers = TestSuite.GetTypeTesters(typeof(global::OpcLabs.BaseLib.Forms.Connectivity.Data.LivePointDataView));
        }

        [TestInitialize]
        public void InitializeTest()
        {
            AssertUtilities.WriteLine("Initializing test for OpcLabs.BaseLib.Forms.Connectivity.Data.LivePointDataView...");
        }

        [NotNull]
        public TesterCollection Testers { get; }

        [TestCategory("GeneratedTest")]
        [TestCategory("Forms")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultCtorTester()
        {
            if (!Testers.TryGetValue("DefaultCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("Forms")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultValueDataMemberTester()
        {
            if (!Testers.TryGetValue("DefaultValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("Forms")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ShouldSerializeTester()
        {
            if (!Testers.TryGetValue("ShouldSerializeTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }
    }

// ReSharper restore RedundantNameQualifier
}

// ReSharper disable CheckNamespace
namespace OpcLabs.BaseLibTest.Forms.Connectivity.Data
// ReSharper restore CheckNamespace
// ReSharper disable RedundantNameQualifier
{

    [TestClass]
    // ReSharper disable InconsistentNaming
    // ReSharper disable PartialTypeWithSinglePart
    public partial class PointDataColumnDefinitionTest
    // ReSharper restore PartialTypeWithSinglePart
    // ReSharper restore InconsistentNaming
    {
        public PointDataColumnDefinitionTest()
        {
            Testers = TestSuite.GetTypeTesters(typeof(global::OpcLabs.BaseLib.Forms.Connectivity.Data.PointDataColumnDefinition));
        }

        [TestInitialize]
        public void InitializeTest()
        {
            AssertUtilities.WriteLine("Initializing test for OpcLabs.BaseLib.Forms.Connectivity.Data.PointDataColumnDefinition...");
        }

        [NotNull]
        public TesterCollection Testers { get; }

        [TestCategory("GeneratedTest")]
        [TestCategory("Forms")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultCtorTester()
        {
            if (!Testers.TryGetValue("DefaultCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }
    }

// ReSharper restore RedundantNameQualifier
}

// ReSharper disable CheckNamespace
namespace OpcLabs.BaseLibTest.Forms.Connectivity.Data
// ReSharper restore CheckNamespace
// ReSharper disable RedundantNameQualifier
{

    [TestClass]
    // ReSharper disable InconsistentNaming
    // ReSharper disable PartialTypeWithSinglePart
    public partial class PointDataColumnDefinitionCollectionTest
    // ReSharper restore PartialTypeWithSinglePart
    // ReSharper restore InconsistentNaming
    {
        public PointDataColumnDefinitionCollectionTest()
        {
            Testers = TestSuite.GetTypeTesters(typeof(global::OpcLabs.BaseLib.Forms.Connectivity.Data.PointDataColumnDefinitionCollection));
        }

        [TestInitialize]
        public void InitializeTest()
        {
            AssertUtilities.WriteLine("Initializing test for OpcLabs.BaseLib.Forms.Connectivity.Data.PointDataColumnDefinitionCollection...");
        }

        [NotNull]
        public TesterCollection Testers { get; }

        [TestCategory("GeneratedTest")]
        [TestCategory("Forms")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultCtorTester()
        {
            if (!Testers.TryGetValue("DefaultCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }
    }

// ReSharper restore RedundantNameQualifier
}

// ReSharper disable CheckNamespace
namespace OpcLabs.BaseLibTest.Forms.Connectivity.Data
// ReSharper restore CheckNamespace
// ReSharper disable RedundantNameQualifier
{

    [TestClass]
    // ReSharper disable InconsistentNaming
    // ReSharper disable PartialTypeWithSinglePart
    public partial class PointDataRowDefinitionTest
    // ReSharper restore PartialTypeWithSinglePart
    // ReSharper restore InconsistentNaming
    {
        public PointDataRowDefinitionTest()
        {
            Testers = TestSuite.GetTypeTesters(typeof(global::OpcLabs.BaseLib.Forms.Connectivity.Data.PointDataRowDefinition));
        }

        [TestInitialize]
        public void InitializeTest()
        {
            AssertUtilities.WriteLine("Initializing test for OpcLabs.BaseLib.Forms.Connectivity.Data.PointDataRowDefinition...");
        }

        [NotNull]
        public TesterCollection Testers { get; }

        [TestCategory("GeneratedTest")]
        [TestCategory("Forms")]
        [TestCategory("BinarySerialization")]
        [TestCategory("Serialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void BinarySerializationTester()
        {
            if (!Testers.TryGetValue("BinarySerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("Forms")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void CopyCtorTester()
        {
            if (!Testers.TryGetValue("CopyCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("Forms")]
        [TestCategory("DataContractSerialization")]
        [TestCategory("Serialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DataContractSerializationTester()
        {
            if (!Testers.TryGetValue("DataContractSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("Forms")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultCtorTester()
        {
            if (!Testers.TryGetValue("DefaultCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("Forms")]
        [TestCategory("Equality")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void EqualityOperatorsTester()
        {
            if (!Testers.TryGetValue("EqualityOperatorsTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("Forms")]
        [TestCategory("Equality")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void EquivalenceTester()
        {
            if (!Testers.TryGetValue("EquivalenceTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("Forms")]
        [TestCategory("Cloning")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ICloneableTester()
        {
            if (!Testers.TryGetValue("ICloneableTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("Forms")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void InvalidValueDataMemberTester()
        {
            if (!Testers.TryGetValue("InvalidValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("Forms")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void PropertyBehaviorTester()
        {
            if (!Testers.TryGetValue("PropertyBehaviorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("Forms")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ValidValueDataMemberTester()
        {
            if (!Testers.TryGetValue("ValidValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("Forms")]
        [TestCategory("Serialization")]
        [TestCategory("XamlSerialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void XamlSerializationTester()
        {
            if (!Testers.TryGetValue("XamlSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("Forms")]
        [TestCategory("Serialization")]
        [TestCategory("XmlSerialization")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void XmlSerializationTester()
        {
            if (!Testers.TryGetValue("XmlSerializationTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }
    }

// ReSharper restore RedundantNameQualifier
}

// ReSharper disable CheckNamespace
namespace OpcLabs.BaseLibTest.Forms.Connectivity.Data
// ReSharper restore CheckNamespace
// ReSharper disable RedundantNameQualifier
{

    [TestClass]
    // ReSharper disable InconsistentNaming
    // ReSharper disable PartialTypeWithSinglePart
    public partial class PointDataRowDefinitionCollectionTest
    // ReSharper restore PartialTypeWithSinglePart
    // ReSharper restore InconsistentNaming
    {
        public PointDataRowDefinitionCollectionTest()
        {
            Testers = TestSuite.GetTypeTesters(typeof(global::OpcLabs.BaseLib.Forms.Connectivity.Data.PointDataRowDefinitionCollection));
        }

        [TestInitialize]
        public void InitializeTest()
        {
            AssertUtilities.WriteLine("Initializing test for OpcLabs.BaseLib.Forms.Connectivity.Data.PointDataRowDefinitionCollection...");
        }

        [NotNull]
        public TesterCollection Testers { get; }

        [TestCategory("GeneratedTest")]
        [TestCategory("Forms")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultCtorTester()
        {
            if (!Testers.TryGetValue("DefaultCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }
    }

// ReSharper restore RedundantNameQualifier
}

// ReSharper disable CheckNamespace
namespace OpcLabs.BaseLibTest.Forms.Connectivity
// ReSharper restore CheckNamespace
// ReSharper disable RedundantNameQualifier
{

    [TestClass]
    // ReSharper disable InconsistentNaming
    // ReSharper disable PartialTypeWithSinglePart
    public partial class PointEditorControlTest
    // ReSharper restore PartialTypeWithSinglePart
    // ReSharper restore InconsistentNaming
    {
        public PointEditorControlTest()
        {
            Testers = TestSuite.GetTypeTesters(typeof(global::OpcLabs.BaseLib.Forms.Connectivity.PointEditorControl));
        }

        [TestInitialize]
        public void InitializeTest()
        {
            AssertUtilities.WriteLine("Initializing test for OpcLabs.BaseLib.Forms.Connectivity.PointEditorControl...");
        }

        [NotNull]
        public TesterCollection Testers { get; }

        [TestCategory("GeneratedTest")]
        [TestCategory("Forms")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultCtorTester()
        {
            if (!Testers.TryGetValue("DefaultCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("Forms")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultValueDataMemberTester()
        {
            if (!Testers.TryGetValue("DefaultValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("Forms")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ShouldSerializeTester()
        {
            if (!Testers.TryGetValue("ShouldSerializeTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }
    }

// ReSharper restore RedundantNameQualifier
}

// ReSharper disable CheckNamespace
namespace OpcLabs.BaseLibTest.Forms.Connectivity
// ReSharper restore CheckNamespace
// ReSharper disable RedundantNameQualifier
{

    [TestClass]
    // ReSharper disable InconsistentNaming
    // ReSharper disable PartialTypeWithSinglePart
    public partial class PointEditorDialogTest
    // ReSharper restore PartialTypeWithSinglePart
    // ReSharper restore InconsistentNaming
    {
        public PointEditorDialogTest()
        {
            Testers = TestSuite.GetTypeTesters(typeof(global::OpcLabs.BaseLib.Forms.Connectivity.PointEditorDialog));
        }

        [TestInitialize]
        public void InitializeTest()
        {
            AssertUtilities.WriteLine("Initializing test for OpcLabs.BaseLib.Forms.Connectivity.PointEditorDialog...");
        }

        [NotNull]
        public TesterCollection Testers { get; }

        [TestCategory("GeneratedTest")]
        [TestCategory("Forms")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultCtorTester()
        {
            if (!Testers.TryGetValue("DefaultCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("Forms")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultValueDataMemberTester()
        {
            if (!Testers.TryGetValue("DefaultValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("Forms")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ShouldSerializeTester()
        {
            if (!Testers.TryGetValue("ShouldSerializeTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }
    }

// ReSharper restore RedundantNameQualifier
}

// ReSharper disable CheckNamespace
namespace OpcLabs.BaseLibTest.Forms.Design
// ReSharper restore CheckNamespace
// ReSharper disable RedundantNameQualifier
{

    [TestClass]
    // ReSharper disable InconsistentNaming
    // ReSharper disable PartialTypeWithSinglePart
    public partial class AbstractBinderDesignerTest
    // ReSharper restore PartialTypeWithSinglePart
    // ReSharper restore InconsistentNaming
    {
        public AbstractBinderDesignerTest()
        {
            Testers = TestSuite.GetTypeTesters(typeof(global::OpcLabs.BaseLib.Forms.Design.AbstractBinderDesigner));
        }

        [TestInitialize]
        public void InitializeTest()
        {
            AssertUtilities.WriteLine("Initializing test for OpcLabs.BaseLib.Forms.Design.AbstractBinderDesigner...");
        }

        [NotNull]
        public TesterCollection Testers { get; }

        [TestCategory("GeneratedTest")]
        [TestCategory("Forms")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultCtorTester()
        {
            if (!Testers.TryGetValue("DefaultCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }
    }

// ReSharper restore RedundantNameQualifier
}

// ReSharper disable CheckNamespace
namespace OpcLabs.BaseLibTest.Forms.Design
// ReSharper restore CheckNamespace
// ReSharper disable RedundantNameQualifier
{

    [TestClass]
    // ReSharper disable InconsistentNaming
    // ReSharper disable PartialTypeWithSinglePart
    public partial class ArgumentsMemberPathEditorTest
    // ReSharper restore PartialTypeWithSinglePart
    // ReSharper restore InconsistentNaming
    {
        public ArgumentsMemberPathEditorTest()
        {
            Testers = TestSuite.GetTypeTesters(typeof(global::OpcLabs.BaseLib.Forms.Design.ArgumentsMemberPathEditor));
        }

        [TestInitialize]
        public void InitializeTest()
        {
            AssertUtilities.WriteLine("Initializing test for OpcLabs.BaseLib.Forms.Design.ArgumentsMemberPathEditor...");
        }

        [NotNull]
        public TesterCollection Testers { get; }

        [TestCategory("GeneratedTest")]
        [TestCategory("Forms")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultCtorTester()
        {
            if (!Testers.TryGetValue("DefaultCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }
    }

// ReSharper restore RedundantNameQualifier
}

// ReSharper disable CheckNamespace
namespace OpcLabs.BaseLibTest.Forms.Design
// ReSharper restore CheckNamespace
// ReSharper disable RedundantNameQualifier
{

    [TestClass]
    // ReSharper disable InconsistentNaming
    // ReSharper disable PartialTypeWithSinglePart
    public partial class ArgumentsMemberPathEditor2Test
    // ReSharper restore PartialTypeWithSinglePart
    // ReSharper restore InconsistentNaming
    {
        public ArgumentsMemberPathEditor2Test()
        {
            Testers = TestSuite.GetTypeTesters(typeof(global::OpcLabs.BaseLib.Forms.Design.ArgumentsMemberPathEditor2));
        }

        [TestInitialize]
        public void InitializeTest()
        {
            AssertUtilities.WriteLine("Initializing test for OpcLabs.BaseLib.Forms.Design.ArgumentsMemberPathEditor2...");
        }

        [NotNull]
        public TesterCollection Testers { get; }

        [TestCategory("GeneratedTest")]
        [TestCategory("Forms")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultCtorTester()
        {
            if (!Testers.TryGetValue("DefaultCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }
    }

// ReSharper restore RedundantNameQualifier
}

// ReSharper disable CheckNamespace
namespace OpcLabs.BaseLibTest.Forms.Design
// ReSharper restore CheckNamespace
// ReSharper disable RedundantNameQualifier
{

    [TestClass]
    // ReSharper disable InconsistentNaming
    // ReSharper disable PartialTypeWithSinglePart
    public partial class BindingBagEditorTest
    // ReSharper restore PartialTypeWithSinglePart
    // ReSharper restore InconsistentNaming
    {
        public BindingBagEditorTest()
        {
            Testers = TestSuite.GetTypeTesters(typeof(global::OpcLabs.BaseLib.Forms.Design.BindingBagEditor));
        }

        [TestInitialize]
        public void InitializeTest()
        {
            AssertUtilities.WriteLine("Initializing test for OpcLabs.BaseLib.Forms.Design.BindingBagEditor...");
        }

        [NotNull]
        public TesterCollection Testers { get; }

        [TestCategory("GeneratedTest")]
        [TestCategory("Forms")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultCtorTester()
        {
            if (!Testers.TryGetValue("DefaultCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }
    }

// ReSharper restore RedundantNameQualifier
}

// ReSharper disable CheckNamespace
namespace OpcLabs.BaseLibTest.Forms.Design
// ReSharper restore CheckNamespace
// ReSharper disable RedundantNameQualifier
{

    [TestClass]
    // ReSharper disable InconsistentNaming
    // ReSharper disable PartialTypeWithSinglePart
    public partial class BindingBagEditorFormTest
    // ReSharper restore PartialTypeWithSinglePart
    // ReSharper restore InconsistentNaming
    {
        public BindingBagEditorFormTest()
        {
            Testers = TestSuite.GetTypeTesters(typeof(global::OpcLabs.BaseLib.Forms.Design.BindingBagEditorForm));
        }

        [TestInitialize]
        public void InitializeTest()
        {
            AssertUtilities.WriteLine("Initializing test for OpcLabs.BaseLib.Forms.Design.BindingBagEditorForm...");
        }

        [NotNull]
        public TesterCollection Testers { get; }

        [TestCategory("GeneratedTest")]
        [TestCategory("Forms")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultCtorTester()
        {
            if (!Testers.TryGetValue("DefaultCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }
    }

// ReSharper restore RedundantNameQualifier
}

// ReSharper disable CheckNamespace
namespace OpcLabs.BaseLibTest.Forms.Design
// ReSharper restore CheckNamespace
// ReSharper disable RedundantNameQualifier
{

    [TestClass]
    // ReSharper disable InconsistentNaming
    // ReSharper disable PartialTypeWithSinglePart
    public partial class BindingExtenderDesignerTest
    // ReSharper restore PartialTypeWithSinglePart
    // ReSharper restore InconsistentNaming
    {
        public BindingExtenderDesignerTest()
        {
            Testers = TestSuite.GetTypeTesters(typeof(global::OpcLabs.BaseLib.Forms.Design.BindingExtenderDesigner));
        }

        [TestInitialize]
        public void InitializeTest()
        {
            AssertUtilities.WriteLine("Initializing test for OpcLabs.BaseLib.Forms.Design.BindingExtenderDesigner...");
        }

        [NotNull]
        public TesterCollection Testers { get; }

        [TestCategory("GeneratedTest")]
        [TestCategory("Forms")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultCtorTester()
        {
            if (!Testers.TryGetValue("DefaultCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }
    }

// ReSharper restore RedundantNameQualifier
}

// ReSharper disable CheckNamespace
namespace OpcLabs.BaseLibTest.Forms.Design
// ReSharper restore CheckNamespace
// ReSharper disable RedundantNameQualifier
{

    [TestClass]
    // ReSharper disable InconsistentNaming
    // ReSharper disable PartialTypeWithSinglePart
    public partial class ComClassRegistrationEditorTest
    // ReSharper restore PartialTypeWithSinglePart
    // ReSharper restore InconsistentNaming
    {
        public ComClassRegistrationEditorTest()
        {
            Testers = TestSuite.GetTypeTesters(typeof(global::OpcLabs.BaseLib.Forms.Design.ComClassRegistrationEditor));
        }

        [TestInitialize]
        public void InitializeTest()
        {
            AssertUtilities.WriteLine("Initializing test for OpcLabs.BaseLib.Forms.Design.ComClassRegistrationEditor...");
        }

        [NotNull]
        public TesterCollection Testers { get; }

        [TestCategory("GeneratedTest")]
        [TestCategory("Forms")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultCtorTester()
        {
            if (!Testers.TryGetValue("DefaultCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }
    }

// ReSharper restore RedundantNameQualifier
}

// ReSharper disable CheckNamespace
namespace OpcLabs.BaseLibTest.Forms.Design
// ReSharper restore CheckNamespace
// ReSharper disable RedundantNameQualifier
{

    [TestClass]
    // ReSharper disable InconsistentNaming
    // ReSharper disable PartialTypeWithSinglePart
    public partial class ComputerBrowserDialogDesignerTest
    // ReSharper restore PartialTypeWithSinglePart
    // ReSharper restore InconsistentNaming
    {
        public ComputerBrowserDialogDesignerTest()
        {
            Testers = TestSuite.GetTypeTesters(typeof(global::OpcLabs.BaseLib.Forms.Design.ComputerBrowserDialogDesigner));
        }

        [TestInitialize]
        public void InitializeTest()
        {
            AssertUtilities.WriteLine("Initializing test for OpcLabs.BaseLib.Forms.Design.ComputerBrowserDialogDesigner...");
        }

        [NotNull]
        public TesterCollection Testers { get; }

        [TestCategory("GeneratedTest")]
        [TestCategory("Forms")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultCtorTester()
        {
            if (!Testers.TryGetValue("DefaultCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }
    }

// ReSharper restore RedundantNameQualifier
}

// ReSharper disable CheckNamespace
namespace OpcLabs.BaseLibTest.Forms.Design
// ReSharper restore CheckNamespace
// ReSharper disable RedundantNameQualifier
{

    [TestClass]
    // ReSharper disable InconsistentNaming
    // ReSharper disable PartialTypeWithSinglePart
    public partial class ComputerNameEditorTest
    // ReSharper restore PartialTypeWithSinglePart
    // ReSharper restore InconsistentNaming
    {
        public ComputerNameEditorTest()
        {
            Testers = TestSuite.GetTypeTesters(typeof(global::OpcLabs.BaseLib.Forms.Design.ComputerNameEditor));
        }

        [TestInitialize]
        public void InitializeTest()
        {
            AssertUtilities.WriteLine("Initializing test for OpcLabs.BaseLib.Forms.Design.ComputerNameEditor...");
        }

        [NotNull]
        public TesterCollection Testers { get; }

        [TestCategory("GeneratedTest")]
        [TestCategory("Forms")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultCtorTester()
        {
            if (!Testers.TryGetValue("DefaultCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }
    }

// ReSharper restore RedundantNameQualifier
}

// ReSharper disable CheckNamespace
namespace OpcLabs.BaseLibTest.Forms.Design
// ReSharper restore CheckNamespace
// ReSharper disable RedundantNameQualifier
{

    [TestClass]
    // ReSharper disable InconsistentNaming
    // ReSharper disable PartialTypeWithSinglePart
    public partial class ConcreteCommonDialogDesignerTest
    // ReSharper restore PartialTypeWithSinglePart
    // ReSharper restore InconsistentNaming
    {
        public ConcreteCommonDialogDesignerTest()
        {
            Testers = TestSuite.GetTypeTesters(typeof(global::OpcLabs.BaseLib.Forms.Design.ConcreteCommonDialogDesigner));
        }

        [TestInitialize]
        public void InitializeTest()
        {
            AssertUtilities.WriteLine("Initializing test for OpcLabs.BaseLib.Forms.Design.ConcreteCommonDialogDesigner...");
        }

        [NotNull]
        public TesterCollection Testers { get; }

        [TestCategory("GeneratedTest")]
        [TestCategory("Forms")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultCtorTester()
        {
            if (!Testers.TryGetValue("DefaultCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }
    }

// ReSharper restore RedundantNameQualifier
}

// ReSharper disable CheckNamespace
namespace OpcLabs.BaseLibTest.Forms.Design
// ReSharper restore CheckNamespace
// ReSharper disable RedundantNameQualifier
{

    [TestClass]
    // ReSharper disable InconsistentNaming
    // ReSharper disable PartialTypeWithSinglePart
    public partial class ControlPageIdEditorTest
    // ReSharper restore PartialTypeWithSinglePart
    // ReSharper restore InconsistentNaming
    {
        public ControlPageIdEditorTest()
        {
            Testers = TestSuite.GetTypeTesters(typeof(global::OpcLabs.BaseLib.Forms.Design.ControlPageIdEditor));
        }

        [TestInitialize]
        public void InitializeTest()
        {
            AssertUtilities.WriteLine("Initializing test for OpcLabs.BaseLib.Forms.Design.ControlPageIdEditor...");
        }

        [NotNull]
        public TesterCollection Testers { get; }

        [TestCategory("GeneratedTest")]
        [TestCategory("Forms")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultCtorTester()
        {
            if (!Testers.TryGetValue("DefaultCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }
    }

// ReSharper restore RedundantNameQualifier
}

// ReSharper disable CheckNamespace
namespace OpcLabs.BaseLibTest.Forms.Design
// ReSharper restore CheckNamespace
// ReSharper disable RedundantNameQualifier
{

    [TestClass]
    // ReSharper disable InconsistentNaming
    // ReSharper disable PartialTypeWithSinglePart
    public partial class CreateNewFormTest
    // ReSharper restore PartialTypeWithSinglePart
    // ReSharper restore InconsistentNaming
    {
        public CreateNewFormTest()
        {
            Testers = TestSuite.GetTypeTesters(typeof(global::OpcLabs.BaseLib.Forms.Design.CreateNewForm));
        }

        [TestInitialize]
        public void InitializeTest()
        {
            AssertUtilities.WriteLine("Initializing test for OpcLabs.BaseLib.Forms.Design.CreateNewForm...");
        }

        [NotNull]
        public TesterCollection Testers { get; }

        [TestCategory("GeneratedTest")]
        [TestCategory("Forms")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultCtorTester()
        {
            if (!Testers.TryGetValue("DefaultCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }
    }

// ReSharper restore RedundantNameQualifier
}

// ReSharper disable CheckNamespace
namespace OpcLabs.BaseLibTest.Forms.Design
// ReSharper restore CheckNamespace
// ReSharper disable RedundantNameQualifier
{

    [TestClass]
    // ReSharper disable InconsistentNaming
    // ReSharper disable PartialTypeWithSinglePart
    public partial class CreateNewObjectEditorTest
    // ReSharper restore PartialTypeWithSinglePart
    // ReSharper restore InconsistentNaming
    {
        public CreateNewObjectEditorTest()
        {
            Testers = TestSuite.GetTypeTesters(typeof(global::OpcLabs.BaseLib.Forms.Design.CreateNewObjectEditor));
        }

        [TestInitialize]
        public void InitializeTest()
        {
            AssertUtilities.WriteLine("Initializing test for OpcLabs.BaseLib.Forms.Design.CreateNewObjectEditor...");
        }

        [NotNull]
        public TesterCollection Testers { get; }

        [TestCategory("GeneratedTest")]
        [TestCategory("Forms")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultCtorTester()
        {
            if (!Testers.TryGetValue("DefaultCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }
    }

// ReSharper restore RedundantNameQualifier
}

// ReSharper disable CheckNamespace
namespace OpcLabs.BaseLibTest.Forms.Design
// ReSharper restore CheckNamespace
// ReSharper disable RedundantNameQualifier
{

    [TestClass]
    // ReSharper disable InconsistentNaming
    // ReSharper disable PartialTypeWithSinglePart
    public partial class CreateOrRemoveFormTest
    // ReSharper restore PartialTypeWithSinglePart
    // ReSharper restore InconsistentNaming
    {
        public CreateOrRemoveFormTest()
        {
            Testers = TestSuite.GetTypeTesters(typeof(global::OpcLabs.BaseLib.Forms.Design.CreateOrRemoveForm));
        }

        [TestInitialize]
        public void InitializeTest()
        {
            AssertUtilities.WriteLine("Initializing test for OpcLabs.BaseLib.Forms.Design.CreateOrRemoveForm...");
        }

        [NotNull]
        public TesterCollection Testers { get; }

        [TestCategory("GeneratedTest")]
        [TestCategory("Forms")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultCtorTester()
        {
            if (!Testers.TryGetValue("DefaultCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }
    }

// ReSharper restore RedundantNameQualifier
}

// ReSharper disable CheckNamespace
namespace OpcLabs.BaseLibTest.Forms.Design
// ReSharper restore CheckNamespace
// ReSharper disable RedundantNameQualifier
{

    [TestClass]
    // ReSharper disable InconsistentNaming
    // ReSharper disable PartialTypeWithSinglePart
    public partial class CreateOrRemoveObjectEditorTest
    // ReSharper restore PartialTypeWithSinglePart
    // ReSharper restore InconsistentNaming
    {
        public CreateOrRemoveObjectEditorTest()
        {
            Testers = TestSuite.GetTypeTesters(typeof(global::OpcLabs.BaseLib.Forms.Design.CreateOrRemoveObjectEditor));
        }

        [TestInitialize]
        public void InitializeTest()
        {
            AssertUtilities.WriteLine("Initializing test for OpcLabs.BaseLib.Forms.Design.CreateOrRemoveObjectEditor...");
        }

        [NotNull]
        public TesterCollection Testers { get; }

        [TestCategory("GeneratedTest")]
        [TestCategory("Forms")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultCtorTester()
        {
            if (!Testers.TryGetValue("DefaultCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }
    }

// ReSharper restore RedundantNameQualifier
}

// ReSharper disable CheckNamespace
namespace OpcLabs.BaseLibTest.Forms.Design
// ReSharper restore CheckNamespace
// ReSharper disable RedundantNameQualifier
{

    [TestClass]
    // ReSharper disable InconsistentNaming
    // ReSharper disable PartialTypeWithSinglePart
    public partial class DateTimeWithTimeEditorTest
    // ReSharper restore PartialTypeWithSinglePart
    // ReSharper restore InconsistentNaming
    {
        public DateTimeWithTimeEditorTest()
        {
            Testers = TestSuite.GetTypeTesters(typeof(global::OpcLabs.BaseLib.Forms.Design.DateTimeWithTimeEditor));
        }

        [TestInitialize]
        public void InitializeTest()
        {
            AssertUtilities.WriteLine("Initializing test for OpcLabs.BaseLib.Forms.Design.DateTimeWithTimeEditor...");
        }

        [NotNull]
        public TesterCollection Testers { get; }

        [TestCategory("GeneratedTest")]
        [TestCategory("Forms")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultCtorTester()
        {
            if (!Testers.TryGetValue("DefaultCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }
    }

// ReSharper restore RedundantNameQualifier
}

// ReSharper disable CheckNamespace
namespace OpcLabs.BaseLibTest.Forms.Design
// ReSharper restore CheckNamespace
// ReSharper disable RedundantNameQualifier
{

    [TestClass]
    // ReSharper disable InconsistentNaming
    // ReSharper disable PartialTypeWithSinglePart
    public partial class DictionaryPropertyGridFormEditorTest
    // ReSharper restore PartialTypeWithSinglePart
    // ReSharper restore InconsistentNaming
    {
        public DictionaryPropertyGridFormEditorTest()
        {
            Testers = TestSuite.GetTypeTesters(typeof(global::OpcLabs.BaseLib.Forms.Design.DictionaryPropertyGridFormEditor));
        }

        [TestInitialize]
        public void InitializeTest()
        {
            AssertUtilities.WriteLine("Initializing test for OpcLabs.BaseLib.Forms.Design.DictionaryPropertyGridFormEditor...");
        }

        [NotNull]
        public TesterCollection Testers { get; }

        [TestCategory("GeneratedTest")]
        [TestCategory("Forms")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultCtorTester()
        {
            if (!Testers.TryGetValue("DefaultCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }
    }

// ReSharper restore RedundantNameQualifier
}

// ReSharper disable CheckNamespace
namespace OpcLabs.BaseLibTest.Forms.Design
// ReSharper restore CheckNamespace
// ReSharper disable RedundantNameQualifier
{

    [TestClass]
    // ReSharper disable InconsistentNaming
    // ReSharper disable PartialTypeWithSinglePart
    public partial class EndpointDescriptorDesignerTest
    // ReSharper restore PartialTypeWithSinglePart
    // ReSharper restore InconsistentNaming
    {
        public EndpointDescriptorDesignerTest()
        {
            Testers = TestSuite.GetTypeTesters(typeof(global::OpcLabs.BaseLib.Forms.Design.EndpointDescriptorDesigner));
        }

        [TestInitialize]
        public void InitializeTest()
        {
            AssertUtilities.WriteLine("Initializing test for OpcLabs.BaseLib.Forms.Design.EndpointDescriptorDesigner...");
        }

        [NotNull]
        public TesterCollection Testers { get; }

        [TestCategory("GeneratedTest")]
        [TestCategory("Forms")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultCtorTester()
        {
            if (!Testers.TryGetValue("DefaultCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }
    }

// ReSharper restore RedundantNameQualifier
}

// ReSharper disable CheckNamespace
namespace OpcLabs.BaseLibTest.Forms.Design
// ReSharper restore CheckNamespace
// ReSharper disable RedundantNameQualifier
{

    [TestClass]
    // ReSharper disable InconsistentNaming
    // ReSharper disable PartialTypeWithSinglePart
    public partial class ExtenderProviderDesignerTest
    // ReSharper restore PartialTypeWithSinglePart
    // ReSharper restore InconsistentNaming
    {
        public ExtenderProviderDesignerTest()
        {
            Testers = TestSuite.GetTypeTesters(typeof(global::OpcLabs.BaseLib.Forms.Design.ExtenderProviderDesigner));
        }

        [TestInitialize]
        public void InitializeTest()
        {
            AssertUtilities.WriteLine("Initializing test for OpcLabs.BaseLib.Forms.Design.ExtenderProviderDesigner...");
        }

        [NotNull]
        public TesterCollection Testers { get; }

        [TestCategory("GeneratedTest")]
        [TestCategory("Forms")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultCtorTester()
        {
            if (!Testers.TryGetValue("DefaultCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }
    }

// ReSharper restore RedundantNameQualifier
}

// ReSharper disable CheckNamespace
namespace OpcLabs.BaseLibTest.Forms.Design
// ReSharper restore CheckNamespace
// ReSharper disable RedundantNameQualifier
{

    [TestClass]
    // ReSharper disable InconsistentNaming
    // ReSharper disable PartialTypeWithSinglePart
    public partial class FlagsEnumEditorTest
    // ReSharper restore PartialTypeWithSinglePart
    // ReSharper restore InconsistentNaming
    {
        public FlagsEnumEditorTest()
        {
            Testers = TestSuite.GetTypeTesters(typeof(global::OpcLabs.BaseLib.Forms.Design.FlagsEnumEditor));
        }

        [TestInitialize]
        public void InitializeTest()
        {
            AssertUtilities.WriteLine("Initializing test for OpcLabs.BaseLib.Forms.Design.FlagsEnumEditor...");
        }

        [NotNull]
        public TesterCollection Testers { get; }

        [TestCategory("GeneratedTest")]
        [TestCategory("Forms")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultCtorTester()
        {
            if (!Testers.TryGetValue("DefaultCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }
    }

// ReSharper restore RedundantNameQualifier
}

// ReSharper disable CheckNamespace
namespace OpcLabs.BaseLibTest.Forms.Design
// ReSharper restore CheckNamespace
// ReSharper disable RedundantNameQualifier
{

    [TestClass]
    // ReSharper disable InconsistentNaming
    // ReSharper disable PartialTypeWithSinglePart
    public partial class GuidCreateNewEditorTest
    // ReSharper restore PartialTypeWithSinglePart
    // ReSharper restore InconsistentNaming
    {
        public GuidCreateNewEditorTest()
        {
            Testers = TestSuite.GetTypeTesters(typeof(global::OpcLabs.BaseLib.Forms.Design.GuidCreateNewEditor));
        }

        [TestInitialize]
        public void InitializeTest()
        {
            AssertUtilities.WriteLine("Initializing test for OpcLabs.BaseLib.Forms.Design.GuidCreateNewEditor...");
        }

        [NotNull]
        public TesterCollection Testers { get; }

        [TestCategory("GeneratedTest")]
        [TestCategory("Forms")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultCtorTester()
        {
            if (!Testers.TryGetValue("DefaultCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }
    }

// ReSharper restore RedundantNameQualifier
}

// ReSharper disable CheckNamespace
namespace OpcLabs.BaseLibTest.Forms.Design
// ReSharper restore CheckNamespace
// ReSharper disable RedundantNameQualifier
{

    [TestClass]
    // ReSharper disable InconsistentNaming
    // ReSharper disable PartialTypeWithSinglePart
    public partial class GuidSetEditorTest
    // ReSharper restore PartialTypeWithSinglePart
    // ReSharper restore InconsistentNaming
    {
        public GuidSetEditorTest()
        {
            Testers = TestSuite.GetTypeTesters(typeof(global::OpcLabs.BaseLib.Forms.Design.GuidSetEditor));
        }

        [TestInitialize]
        public void InitializeTest()
        {
            AssertUtilities.WriteLine("Initializing test for OpcLabs.BaseLib.Forms.Design.GuidSetEditor...");
        }

        [NotNull]
        public TesterCollection Testers { get; }

        [TestCategory("GeneratedTest")]
        [TestCategory("Forms")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultCtorTester()
        {
            if (!Testers.TryGetValue("DefaultCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }
    }

// ReSharper restore RedundantNameQualifier
}

// ReSharper disable CheckNamespace
namespace OpcLabs.BaseLibTest.Forms.Design
// ReSharper restore CheckNamespace
// ReSharper disable RedundantNameQualifier
{

    [TestClass]
    // ReSharper disable InconsistentNaming
    // ReSharper disable PartialTypeWithSinglePart
    public partial class MemberNameEditorTest
    // ReSharper restore PartialTypeWithSinglePart
    // ReSharper restore InconsistentNaming
    {
        public MemberNameEditorTest()
        {
            Testers = TestSuite.GetTypeTesters(typeof(global::OpcLabs.BaseLib.Forms.Design.MemberNameEditor));
        }

        [TestInitialize]
        public void InitializeTest()
        {
            AssertUtilities.WriteLine("Initializing test for OpcLabs.BaseLib.Forms.Design.MemberNameEditor...");
        }

        [NotNull]
        public TesterCollection Testers { get; }

        [TestCategory("GeneratedTest")]
        [TestCategory("Forms")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultCtorTester()
        {
            if (!Testers.TryGetValue("DefaultCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }
    }

// ReSharper restore RedundantNameQualifier
}

// ReSharper disable CheckNamespace
namespace OpcLabs.BaseLibTest.Forms.Design
// ReSharper restore CheckNamespace
// ReSharper disable RedundantNameQualifier
{

    [TestClass]
    // ReSharper disable InconsistentNaming
    // ReSharper disable PartialTypeWithSinglePart
    public partial class MemberNameEditor2Test
    // ReSharper restore PartialTypeWithSinglePart
    // ReSharper restore InconsistentNaming
    {
        public MemberNameEditor2Test()
        {
            Testers = TestSuite.GetTypeTesters(typeof(global::OpcLabs.BaseLib.Forms.Design.MemberNameEditor2));
        }

        [TestInitialize]
        public void InitializeTest()
        {
            AssertUtilities.WriteLine("Initializing test for OpcLabs.BaseLib.Forms.Design.MemberNameEditor2...");
        }

        [NotNull]
        public TesterCollection Testers { get; }

        [TestCategory("GeneratedTest")]
        [TestCategory("Forms")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultCtorTester()
        {
            if (!Testers.TryGetValue("DefaultCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }
    }

// ReSharper restore RedundantNameQualifier
}

// ReSharper disable CheckNamespace
namespace OpcLabs.BaseLibTest.Forms.Design
// ReSharper restore CheckNamespace
// ReSharper disable RedundantNameQualifier
{

    [TestClass]
    // ReSharper disable InconsistentNaming
    // ReSharper disable PartialTypeWithSinglePart
    public partial class MemberPathEditorTest
    // ReSharper restore PartialTypeWithSinglePart
    // ReSharper restore InconsistentNaming
    {
        public MemberPathEditorTest()
        {
            Testers = TestSuite.GetTypeTesters(typeof(global::OpcLabs.BaseLib.Forms.Design.MemberPathEditor));
        }

        [TestInitialize]
        public void InitializeTest()
        {
            AssertUtilities.WriteLine("Initializing test for OpcLabs.BaseLib.Forms.Design.MemberPathEditor...");
        }

        [NotNull]
        public TesterCollection Testers { get; }

        [TestCategory("GeneratedTest")]
        [TestCategory("Forms")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultCtorTester()
        {
            if (!Testers.TryGetValue("DefaultCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }
    }

// ReSharper restore RedundantNameQualifier
}

// ReSharper disable CheckNamespace
namespace OpcLabs.BaseLibTest.Forms.Design
// ReSharper restore CheckNamespace
// ReSharper disable RedundantNameQualifier
{

    [TestClass]
    // ReSharper disable InconsistentNaming
    // ReSharper disable PartialTypeWithSinglePart
    public partial class MemberPathEditor2Test
    // ReSharper restore PartialTypeWithSinglePart
    // ReSharper restore InconsistentNaming
    {
        public MemberPathEditor2Test()
        {
            Testers = TestSuite.GetTypeTesters(typeof(global::OpcLabs.BaseLib.Forms.Design.MemberPathEditor2));
        }

        [TestInitialize]
        public void InitializeTest()
        {
            AssertUtilities.WriteLine("Initializing test for OpcLabs.BaseLib.Forms.Design.MemberPathEditor2...");
        }

        [NotNull]
        public TesterCollection Testers { get; }

        [TestCategory("GeneratedTest")]
        [TestCategory("Forms")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultCtorTester()
        {
            if (!Testers.TryGetValue("DefaultCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }
    }

// ReSharper restore RedundantNameQualifier
}

// ReSharper disable CheckNamespace
namespace OpcLabs.BaseLibTest.Forms.Design
// ReSharper restore CheckNamespace
// ReSharper disable RedundantNameQualifier
{

    [TestClass]
    // ReSharper disable InconsistentNaming
    // ReSharper disable PartialTypeWithSinglePart
    public partial class MillisecondsDoubleEditorTest
    // ReSharper restore PartialTypeWithSinglePart
    // ReSharper restore InconsistentNaming
    {
        public MillisecondsDoubleEditorTest()
        {
            Testers = TestSuite.GetTypeTesters(typeof(global::OpcLabs.BaseLib.Forms.Design.MillisecondsDoubleEditor));
        }

        [TestInitialize]
        public void InitializeTest()
        {
            AssertUtilities.WriteLine("Initializing test for OpcLabs.BaseLib.Forms.Design.MillisecondsDoubleEditor...");
        }

        [NotNull]
        public TesterCollection Testers { get; }

        [TestCategory("GeneratedTest")]
        [TestCategory("Forms")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultCtorTester()
        {
            if (!Testers.TryGetValue("DefaultCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }
    }

// ReSharper restore RedundantNameQualifier
}

// ReSharper disable CheckNamespace
namespace OpcLabs.BaseLibTest.Forms.Design
// ReSharper restore CheckNamespace
// ReSharper disable RedundantNameQualifier
{

    [TestClass]
    // ReSharper disable InconsistentNaming
    // ReSharper disable PartialTypeWithSinglePart
    public partial class MillisecondsInt32EditorTest
    // ReSharper restore PartialTypeWithSinglePart
    // ReSharper restore InconsistentNaming
    {
        public MillisecondsInt32EditorTest()
        {
            Testers = TestSuite.GetTypeTesters(typeof(global::OpcLabs.BaseLib.Forms.Design.MillisecondsInt32Editor));
        }

        [TestInitialize]
        public void InitializeTest()
        {
            AssertUtilities.WriteLine("Initializing test for OpcLabs.BaseLib.Forms.Design.MillisecondsInt32Editor...");
        }

        [NotNull]
        public TesterCollection Testers { get; }

        [TestCategory("GeneratedTest")]
        [TestCategory("Forms")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultCtorTester()
        {
            if (!Testers.TryGetValue("DefaultCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }
    }

// ReSharper restore RedundantNameQualifier
}

// ReSharper disable CheckNamespace
namespace OpcLabs.BaseLibTest.Forms.Design
// ReSharper restore CheckNamespace
// ReSharper disable RedundantNameQualifier
{

    [TestClass]
    // ReSharper disable InconsistentNaming
    // ReSharper disable PartialTypeWithSinglePart
    public partial class NonZeroMillisecondsDoubleEditorTest
    // ReSharper restore PartialTypeWithSinglePart
    // ReSharper restore InconsistentNaming
    {
        public NonZeroMillisecondsDoubleEditorTest()
        {
            Testers = TestSuite.GetTypeTesters(typeof(global::OpcLabs.BaseLib.Forms.Design.NonZeroMillisecondsDoubleEditor));
        }

        [TestInitialize]
        public void InitializeTest()
        {
            AssertUtilities.WriteLine("Initializing test for OpcLabs.BaseLib.Forms.Design.NonZeroMillisecondsDoubleEditor...");
        }

        [NotNull]
        public TesterCollection Testers { get; }

        [TestCategory("GeneratedTest")]
        [TestCategory("Forms")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultCtorTester()
        {
            if (!Testers.TryGetValue("DefaultCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }
    }

// ReSharper restore RedundantNameQualifier
}

// ReSharper disable CheckNamespace
namespace OpcLabs.BaseLibTest.Forms.Design
// ReSharper restore CheckNamespace
// ReSharper disable RedundantNameQualifier
{

    [TestClass]
    // ReSharper disable InconsistentNaming
    // ReSharper disable PartialTypeWithSinglePart
    public partial class NonZeroMillisecondsInt32EditorTest
    // ReSharper restore PartialTypeWithSinglePart
    // ReSharper restore InconsistentNaming
    {
        public NonZeroMillisecondsInt32EditorTest()
        {
            Testers = TestSuite.GetTypeTesters(typeof(global::OpcLabs.BaseLib.Forms.Design.NonZeroMillisecondsInt32Editor));
        }

        [TestInitialize]
        public void InitializeTest()
        {
            AssertUtilities.WriteLine("Initializing test for OpcLabs.BaseLib.Forms.Design.NonZeroMillisecondsInt32Editor...");
        }

        [NotNull]
        public TesterCollection Testers { get; }

        [TestCategory("GeneratedTest")]
        [TestCategory("Forms")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultCtorTester()
        {
            if (!Testers.TryGetValue("DefaultCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }
    }

// ReSharper restore RedundantNameQualifier
}

// ReSharper disable CheckNamespace
namespace OpcLabs.BaseLibTest.Forms.Design
// ReSharper restore CheckNamespace
// ReSharper disable RedundantNameQualifier
{

    [TestClass]
    // ReSharper disable InconsistentNaming
    // ReSharper disable PartialTypeWithSinglePart
    public partial class ObjectEditorTest
    // ReSharper restore PartialTypeWithSinglePart
    // ReSharper restore InconsistentNaming
    {
        public ObjectEditorTest()
        {
            Testers = TestSuite.GetTypeTesters(typeof(global::OpcLabs.BaseLib.Forms.Design.ObjectEditor));
        }

        [TestInitialize]
        public void InitializeTest()
        {
            AssertUtilities.WriteLine("Initializing test for OpcLabs.BaseLib.Forms.Design.ObjectEditor...");
        }

        [NotNull]
        public TesterCollection Testers { get; }

        [TestCategory("GeneratedTest")]
        [TestCategory("Forms")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultCtorTester()
        {
            if (!Testers.TryGetValue("DefaultCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }
    }

// ReSharper restore RedundantNameQualifier
}

// ReSharper disable CheckNamespace
namespace OpcLabs.BaseLibTest.Forms.Design
// ReSharper restore CheckNamespace
// ReSharper disable RedundantNameQualifier
{

    [TestClass]
    // ReSharper disable InconsistentNaming
    // ReSharper disable PartialTypeWithSinglePart
    public partial class PluginSetupCollectionEditorTest
    // ReSharper restore PartialTypeWithSinglePart
    // ReSharper restore InconsistentNaming
    {
        public PluginSetupCollectionEditorTest()
        {
            Testers = TestSuite.GetTypeTesters(typeof(global::OpcLabs.BaseLib.Forms.Design.PluginSetupCollectionEditor));
        }

        [TestInitialize]
        public void InitializeTest()
        {
            AssertUtilities.WriteLine("Initializing test for OpcLabs.BaseLib.Forms.Design.PluginSetupCollectionEditor...");
        }

        [NotNull]
        public TesterCollection Testers { get; }

        [TestCategory("GeneratedTest")]
        [TestCategory("Forms")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultCtorTester()
        {
            if (!Testers.TryGetValue("DefaultCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }
    }

// ReSharper restore RedundantNameQualifier
}

// ReSharper disable CheckNamespace
namespace OpcLabs.BaseLibTest.Forms.Design
// ReSharper restore CheckNamespace
// ReSharper disable RedundantNameQualifier
{

    [TestClass]
    // ReSharper disable InconsistentNaming
    // ReSharper disable PartialTypeWithSinglePart
    public partial class PointBinderDesignerTest
    // ReSharper restore PartialTypeWithSinglePart
    // ReSharper restore InconsistentNaming
    {
        public PointBinderDesignerTest()
        {
            Testers = TestSuite.GetTypeTesters(typeof(global::OpcLabs.BaseLib.Forms.Design.PointBinderDesigner));
        }

        [TestInitialize]
        public void InitializeTest()
        {
            AssertUtilities.WriteLine("Initializing test for OpcLabs.BaseLib.Forms.Design.PointBinderDesigner...");
        }

        [NotNull]
        public TesterCollection Testers { get; }

        [TestCategory("GeneratedTest")]
        [TestCategory("Forms")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultCtorTester()
        {
            if (!Testers.TryGetValue("DefaultCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }
    }

// ReSharper restore RedundantNameQualifier
}

// ReSharper disable CheckNamespace
namespace OpcLabs.BaseLibTest.Forms.Design
// ReSharper restore CheckNamespace
// ReSharper disable RedundantNameQualifier
{

    [TestClass]
    // ReSharper disable InconsistentNaming
    // ReSharper disable PartialTypeWithSinglePart
    public partial class PointEditorTest
    // ReSharper restore PartialTypeWithSinglePart
    // ReSharper restore InconsistentNaming
    {
        public PointEditorTest()
        {
            Testers = TestSuite.GetTypeTesters(typeof(global::OpcLabs.BaseLib.Forms.Design.PointEditor));
        }

        [TestInitialize]
        public void InitializeTest()
        {
            AssertUtilities.WriteLine("Initializing test for OpcLabs.BaseLib.Forms.Design.PointEditor...");
        }

        [NotNull]
        public TesterCollection Testers { get; }

        [TestCategory("GeneratedTest")]
        [TestCategory("Forms")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultCtorTester()
        {
            if (!Testers.TryGetValue("DefaultCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }
    }

// ReSharper restore RedundantNameQualifier
}

// ReSharper disable CheckNamespace
namespace OpcLabs.BaseLibTest.Forms.Design
// ReSharper restore CheckNamespace
// ReSharper disable RedundantNameQualifier
{

    [TestClass]
    // ReSharper disable InconsistentNaming
    // ReSharper disable PartialTypeWithSinglePart
    public partial class PropertyGridFormEditorTest
    // ReSharper restore PartialTypeWithSinglePart
    // ReSharper restore InconsistentNaming
    {
        public PropertyGridFormEditorTest()
        {
            Testers = TestSuite.GetTypeTesters(typeof(global::OpcLabs.BaseLib.Forms.Design.PropertyGridFormEditor));
        }

        [TestInitialize]
        public void InitializeTest()
        {
            AssertUtilities.WriteLine("Initializing test for OpcLabs.BaseLib.Forms.Design.PropertyGridFormEditor...");
        }

        [NotNull]
        public TesterCollection Testers { get; }

        [TestCategory("GeneratedTest")]
        [TestCategory("Forms")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultCtorTester()
        {
            if (!Testers.TryGetValue("DefaultCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }
    }

// ReSharper restore RedundantNameQualifier
}

// ReSharper disable CheckNamespace
namespace OpcLabs.BaseLibTest.Forms.Design
// ReSharper restore CheckNamespace
// ReSharper disable RedundantNameQualifier
{

    [TestClass]
    // ReSharper disable InconsistentNaming
    // ReSharper disable PartialTypeWithSinglePart
    public partial class ReadOnlyDictionaryPropertyGridFormEditorTest
    // ReSharper restore PartialTypeWithSinglePart
    // ReSharper restore InconsistentNaming
    {
        public ReadOnlyDictionaryPropertyGridFormEditorTest()
        {
            Testers = TestSuite.GetTypeTesters(typeof(global::OpcLabs.BaseLib.Forms.Design.ReadOnlyDictionaryPropertyGridFormEditor));
        }

        [TestInitialize]
        public void InitializeTest()
        {
            AssertUtilities.WriteLine("Initializing test for OpcLabs.BaseLib.Forms.Design.ReadOnlyDictionaryPropertyGridFormEditor...");
        }

        [NotNull]
        public TesterCollection Testers { get; }

        [TestCategory("GeneratedTest")]
        [TestCategory("Forms")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultCtorTester()
        {
            if (!Testers.TryGetValue("DefaultCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }
    }

// ReSharper restore RedundantNameQualifier
}

// ReSharper disable CheckNamespace
namespace OpcLabs.BaseLibTest.Forms.Design
// ReSharper restore CheckNamespace
// ReSharper disable RedundantNameQualifier
{

    [TestClass]
    // ReSharper disable InconsistentNaming
    // ReSharper disable PartialTypeWithSinglePart
    public partial class ResourceDescriptorDesignerTest
    // ReSharper restore PartialTypeWithSinglePart
    // ReSharper restore InconsistentNaming
    {
        public ResourceDescriptorDesignerTest()
        {
            Testers = TestSuite.GetTypeTesters(typeof(global::OpcLabs.BaseLib.Forms.Design.ResourceDescriptorDesigner));
        }

        [TestInitialize]
        public void InitializeTest()
        {
            AssertUtilities.WriteLine("Initializing test for OpcLabs.BaseLib.Forms.Design.ResourceDescriptorDesigner...");
        }

        [NotNull]
        public TesterCollection Testers { get; }

        [TestCategory("GeneratedTest")]
        [TestCategory("Forms")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultCtorTester()
        {
            if (!Testers.TryGetValue("DefaultCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }
    }

// ReSharper restore RedundantNameQualifier
}

// ReSharper disable CheckNamespace
namespace OpcLabs.BaseLibTest.Forms.Design
// ReSharper restore CheckNamespace
// ReSharper disable RedundantNameQualifier
{

    [TestClass]
    // ReSharper disable InconsistentNaming
    // ReSharper disable PartialTypeWithSinglePart
    public partial class RuntimeServiceProviderTest
    // ReSharper restore PartialTypeWithSinglePart
    // ReSharper restore InconsistentNaming
    {
        public RuntimeServiceProviderTest()
        {
            Testers = TestSuite.GetTypeTesters(typeof(global::OpcLabs.BaseLib.Forms.Design.RuntimeServiceProvider));
        }

        [TestInitialize]
        public void InitializeTest()
        {
            AssertUtilities.WriteLine("Initializing test for OpcLabs.BaseLib.Forms.Design.RuntimeServiceProvider...");
        }

        [NotNull]
        public TesterCollection Testers { get; }

        [TestCategory("GeneratedTest")]
        [TestCategory("Forms")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultCtorTester()
        {
            if (!Testers.TryGetValue("DefaultCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }
    }

// ReSharper restore RedundantNameQualifier
}

// ReSharper disable CheckNamespace
namespace OpcLabs.BaseLibTest.Forms.Design
// ReSharper restore CheckNamespace
// ReSharper disable RedundantNameQualifier
{

    [TestClass]
    // ReSharper disable InconsistentNaming
    // ReSharper disable PartialTypeWithSinglePart
    public partial class SizeFactorEditorTest
    // ReSharper restore PartialTypeWithSinglePart
    // ReSharper restore InconsistentNaming
    {
        public SizeFactorEditorTest()
        {
            Testers = TestSuite.GetTypeTesters(typeof(global::OpcLabs.BaseLib.Forms.Design.SizeFactorEditor));
        }

        [TestInitialize]
        public void InitializeTest()
        {
            AssertUtilities.WriteLine("Initializing test for OpcLabs.BaseLib.Forms.Design.SizeFactorEditor...");
        }

        [NotNull]
        public TesterCollection Testers { get; }

        [TestCategory("GeneratedTest")]
        [TestCategory("Forms")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultCtorTester()
        {
            if (!Testers.TryGetValue("DefaultCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }
    }

// ReSharper restore RedundantNameQualifier
}

// ReSharper disable CheckNamespace
namespace OpcLabs.BaseLibTest.Forms.Design
// ReSharper restore CheckNamespace
// ReSharper disable RedundantNameQualifier
{

    [TestClass]
    // ReSharper disable InconsistentNaming
    // ReSharper disable PartialTypeWithSinglePart
    public partial class StringSetEditorTest
    // ReSharper restore PartialTypeWithSinglePart
    // ReSharper restore InconsistentNaming
    {
        public StringSetEditorTest()
        {
            Testers = TestSuite.GetTypeTesters(typeof(global::OpcLabs.BaseLib.Forms.Design.StringSetEditor));
        }

        [TestInitialize]
        public void InitializeTest()
        {
            AssertUtilities.WriteLine("Initializing test for OpcLabs.BaseLib.Forms.Design.StringSetEditor...");
        }

        [NotNull]
        public TesterCollection Testers { get; }

        [TestCategory("GeneratedTest")]
        [TestCategory("Forms")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultCtorTester()
        {
            if (!Testers.TryGetValue("DefaultCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }
    }

// ReSharper restore RedundantNameQualifier
}

// ReSharper disable CheckNamespace
namespace OpcLabs.BaseLibTest.Forms.Design
// ReSharper restore CheckNamespace
// ReSharper disable RedundantNameQualifier
{

    [TestClass]
    // ReSharper disable InconsistentNaming
    // ReSharper disable PartialTypeWithSinglePart
    public partial class ValueComponentDesignerTest
    // ReSharper restore PartialTypeWithSinglePart
    // ReSharper restore InconsistentNaming
    {
        public ValueComponentDesignerTest()
        {
            Testers = TestSuite.GetTypeTesters(typeof(global::OpcLabs.BaseLib.Forms.Design.ValueComponentDesigner));
        }

        [TestInitialize]
        public void InitializeTest()
        {
            AssertUtilities.WriteLine("Initializing test for OpcLabs.BaseLib.Forms.Design.ValueComponentDesigner...");
        }

        [NotNull]
        public TesterCollection Testers { get; }

        [TestCategory("GeneratedTest")]
        [TestCategory("Forms")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultCtorTester()
        {
            if (!Testers.TryGetValue("DefaultCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }
    }

// ReSharper restore RedundantNameQualifier
}

// ReSharper disable CheckNamespace
namespace OpcLabs.BaseLibTest.Forms.Design
// ReSharper restore CheckNamespace
// ReSharper disable RedundantNameQualifier
{

    [TestClass]
    // ReSharper disable InconsistentNaming
    // ReSharper disable PartialTypeWithSinglePart
    public partial class VarTypeEditorTest
    // ReSharper restore PartialTypeWithSinglePart
    // ReSharper restore InconsistentNaming
    {
        public VarTypeEditorTest()
        {
            Testers = TestSuite.GetTypeTesters(typeof(global::OpcLabs.BaseLib.Forms.Design.VarTypeEditor));
        }

        [TestInitialize]
        public void InitializeTest()
        {
            AssertUtilities.WriteLine("Initializing test for OpcLabs.BaseLib.Forms.Design.VarTypeEditor...");
        }

        [NotNull]
        public TesterCollection Testers { get; }

        [TestCategory("GeneratedTest")]
        [TestCategory("Forms")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultCtorTester()
        {
            if (!Testers.TryGetValue("DefaultCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }
    }

// ReSharper restore RedundantNameQualifier
}

// ReSharper disable CheckNamespace
namespace OpcLabs.BaseLibTest.Forms
// ReSharper restore CheckNamespace
// ReSharper disable RedundantNameQualifier
{

    [TestClass]
    // ReSharper disable InconsistentNaming
    // ReSharper disable PartialTypeWithSinglePart
    public partial class FormCommonDialogTest
    // ReSharper restore PartialTypeWithSinglePart
    // ReSharper restore InconsistentNaming
    {
        public FormCommonDialogTest()
        {
            Testers = TestSuite.GetTypeTesters(typeof(global::OpcLabs.BaseLib.Forms.FormCommonDialog));
        }

        [TestInitialize]
        public void InitializeTest()
        {
            AssertUtilities.WriteLine("Initializing test for OpcLabs.BaseLib.Forms.FormCommonDialog...");
        }

        [NotNull]
        public TesterCollection Testers { get; }

        [TestCategory("GeneratedTest")]
        [TestCategory("Forms")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultCtorTester()
        {
            if (!Testers.TryGetValue("DefaultCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("Forms")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultValueDataMemberTester()
        {
            if (!Testers.TryGetValue("DefaultValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }
    }

// ReSharper restore RedundantNameQualifier
}

// ReSharper disable CheckNamespace
namespace OpcLabs.BaseLibTest.Forms.IdentityModel
// ReSharper restore CheckNamespace
// ReSharper disable RedundantNameQualifier
{

    [TestClass]
    // ReSharper disable InconsistentNaming
    // ReSharper disable PartialTypeWithSinglePart
    public partial class KerberosTokenInfoControlTest
    // ReSharper restore PartialTypeWithSinglePart
    // ReSharper restore InconsistentNaming
    {
        public KerberosTokenInfoControlTest()
        {
            Testers = TestSuite.GetTypeTesters(typeof(global::OpcLabs.BaseLib.Forms.IdentityModel.KerberosTokenInfoControl));
        }

        [TestInitialize]
        public void InitializeTest()
        {
            AssertUtilities.WriteLine("Initializing test for OpcLabs.BaseLib.Forms.IdentityModel.KerberosTokenInfoControl...");
        }

        [NotNull]
        public TesterCollection Testers { get; }

        [TestCategory("GeneratedTest")]
        [TestCategory("Forms")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultCtorTester()
        {
            if (!Testers.TryGetValue("DefaultCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("Forms")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultValueDataMemberTester()
        {
            if (!Testers.TryGetValue("DefaultValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("Forms")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void InvalidValueDataMemberTester()
        {
            if (!Testers.TryGetValue("InvalidValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("Forms")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ShouldSerializeTester()
        {
            if (!Testers.TryGetValue("ShouldSerializeTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }
    }

// ReSharper restore RedundantNameQualifier
}

// ReSharper disable CheckNamespace
namespace OpcLabs.BaseLibTest.Forms.IdentityModel
// ReSharper restore CheckNamespace
// ReSharper disable RedundantNameQualifier
{

    [TestClass]
    // ReSharper disable InconsistentNaming
    // ReSharper disable PartialTypeWithSinglePart
    public partial class UserIdentityControlTest
    // ReSharper restore PartialTypeWithSinglePart
    // ReSharper restore InconsistentNaming
    {
        public UserIdentityControlTest()
        {
            Testers = TestSuite.GetTypeTesters(typeof(global::OpcLabs.BaseLib.Forms.IdentityModel.UserIdentityControl));
        }

        [TestInitialize]
        public void InitializeTest()
        {
            AssertUtilities.WriteLine("Initializing test for OpcLabs.BaseLib.Forms.IdentityModel.UserIdentityControl...");
        }

        [NotNull]
        public TesterCollection Testers { get; }

        [TestCategory("GeneratedTest")]
        [TestCategory("Forms")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultCtorTester()
        {
            if (!Testers.TryGetValue("DefaultCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("Forms")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultValueDataMemberTester()
        {
            if (!Testers.TryGetValue("DefaultValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("Forms")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void InvalidValueDataMemberTester()
        {
            if (!Testers.TryGetValue("InvalidValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("Forms")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ShouldSerializeTester()
        {
            if (!Testers.TryGetValue("ShouldSerializeTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }
    }

// ReSharper restore RedundantNameQualifier
}

// ReSharper disable CheckNamespace
namespace OpcLabs.BaseLibTest.Forms.IdentityModel
// ReSharper restore CheckNamespace
// ReSharper disable RedundantNameQualifier
{

    [TestClass]
    // ReSharper disable InconsistentNaming
    // ReSharper disable PartialTypeWithSinglePart
    public partial class UserIdentityDialogTest
    // ReSharper restore PartialTypeWithSinglePart
    // ReSharper restore InconsistentNaming
    {
        public UserIdentityDialogTest()
        {
            Testers = TestSuite.GetTypeTesters(typeof(global::OpcLabs.BaseLib.Forms.IdentityModel.UserIdentityDialog));
        }

        [TestInitialize]
        public void InitializeTest()
        {
            AssertUtilities.WriteLine("Initializing test for OpcLabs.BaseLib.Forms.IdentityModel.UserIdentityDialog...");
        }

        [NotNull]
        public TesterCollection Testers { get; }

        [TestCategory("GeneratedTest")]
        [TestCategory("Forms")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultCtorTester()
        {
            if (!Testers.TryGetValue("DefaultCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("Forms")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void InvalidValueDataMemberTester()
        {
            if (!Testers.TryGetValue("InvalidValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("Forms")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ShouldSerializeTester()
        {
            if (!Testers.TryGetValue("ShouldSerializeTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }
    }

// ReSharper restore RedundantNameQualifier
}

// ReSharper disable CheckNamespace
namespace OpcLabs.BaseLibTest.Forms.IdentityModel
// ReSharper restore CheckNamespace
// ReSharper disable RedundantNameQualifier
{

    [TestClass]
    // ReSharper disable InconsistentNaming
    // ReSharper disable PartialTypeWithSinglePart
    public partial class UserNameTokenInfoControlTest
    // ReSharper restore PartialTypeWithSinglePart
    // ReSharper restore InconsistentNaming
    {
        public UserNameTokenInfoControlTest()
        {
            Testers = TestSuite.GetTypeTesters(typeof(global::OpcLabs.BaseLib.Forms.IdentityModel.UserNameTokenInfoControl));
        }

        [TestInitialize]
        public void InitializeTest()
        {
            AssertUtilities.WriteLine("Initializing test for OpcLabs.BaseLib.Forms.IdentityModel.UserNameTokenInfoControl...");
        }

        [NotNull]
        public TesterCollection Testers { get; }

        [TestCategory("GeneratedTest")]
        [TestCategory("Forms")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultCtorTester()
        {
            if (!Testers.TryGetValue("DefaultCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("Forms")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultValueDataMemberTester()
        {
            if (!Testers.TryGetValue("DefaultValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("Forms")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void InvalidValueDataMemberTester()
        {
            if (!Testers.TryGetValue("InvalidValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("Forms")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ShouldSerializeTester()
        {
            if (!Testers.TryGetValue("ShouldSerializeTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }
    }

// ReSharper restore RedundantNameQualifier
}

// ReSharper disable CheckNamespace
namespace OpcLabs.BaseLibTest.Forms.IdentityModel
// ReSharper restore CheckNamespace
// ReSharper disable RedundantNameQualifier
{

    [TestClass]
    // ReSharper disable InconsistentNaming
    // ReSharper disable PartialTypeWithSinglePart
    public partial class X509CertificateTokenInfoControlTest
    // ReSharper restore PartialTypeWithSinglePart
    // ReSharper restore InconsistentNaming
    {
        public X509CertificateTokenInfoControlTest()
        {
            Testers = TestSuite.GetTypeTesters(typeof(global::OpcLabs.BaseLib.Forms.IdentityModel.X509CertificateTokenInfoControl));
        }

        [TestInitialize]
        public void InitializeTest()
        {
            AssertUtilities.WriteLine("Initializing test for OpcLabs.BaseLib.Forms.IdentityModel.X509CertificateTokenInfoControl...");
        }

        [NotNull]
        public TesterCollection Testers { get; }

        [TestCategory("GeneratedTest")]
        [TestCategory("Forms")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultCtorTester()
        {
            if (!Testers.TryGetValue("DefaultCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("Forms")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultValueDataMemberTester()
        {
            if (!Testers.TryGetValue("DefaultValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("Forms")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void InvalidValueDataMemberTester()
        {
            if (!Testers.TryGetValue("InvalidValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("Forms")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ShouldSerializeTester()
        {
            if (!Testers.TryGetValue("ShouldSerializeTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }
    }

// ReSharper restore RedundantNameQualifier
}

// ReSharper disable CheckNamespace
namespace OpcLabs.BaseLibTest.Forms.Instrumentation
// ReSharper restore CheckNamespace
// ReSharper disable RedundantNameQualifier
{

    [TestClass]
    // ReSharper disable InconsistentNaming
    // ReSharper disable PartialTypeWithSinglePart
    public partial class LogEntryEventArgsControlTest
    // ReSharper restore PartialTypeWithSinglePart
    // ReSharper restore InconsistentNaming
    {
        public LogEntryEventArgsControlTest()
        {
            Testers = TestSuite.GetTypeTesters(typeof(global::OpcLabs.BaseLib.Forms.Instrumentation.LogEntryEventArgsControl));
        }

        [TestInitialize]
        public void InitializeTest()
        {
            AssertUtilities.WriteLine("Initializing test for OpcLabs.BaseLib.Forms.Instrumentation.LogEntryEventArgsControl...");
        }

        [NotNull]
        public TesterCollection Testers { get; }

        [TestCategory("GeneratedTest")]
        [TestCategory("Forms")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultCtorTester()
        {
            if (!Testers.TryGetValue("DefaultCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("Forms")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultValueDataMemberTester()
        {
            if (!Testers.TryGetValue("DefaultValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }
    }

// ReSharper restore RedundantNameQualifier
}

// ReSharper disable CheckNamespace
namespace OpcLabs.BaseLibTest.Forms.Internal
// ReSharper restore CheckNamespace
// ReSharper disable RedundantNameQualifier
{

    [TestClass]
    // ReSharper disable InconsistentNaming
    // ReSharper disable PartialTypeWithSinglePart
    public partial class AcceptCertificateControlTest
    // ReSharper restore PartialTypeWithSinglePart
    // ReSharper restore InconsistentNaming
    {
        public AcceptCertificateControlTest()
        {
            Testers = TestSuite.GetTypeTesters(typeof(global::OpcLabs.BaseLib.Forms.Internal.AcceptCertificateControl));
        }

        [TestInitialize]
        public void InitializeTest()
        {
            AssertUtilities.WriteLine("Initializing test for OpcLabs.BaseLib.Forms.Internal.AcceptCertificateControl...");
        }

        [NotNull]
        public TesterCollection Testers { get; }

        [TestCategory("GeneratedTest")]
        [TestCategory("Forms")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultCtorTester()
        {
            if (!Testers.TryGetValue("DefaultCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }
    }

// ReSharper restore RedundantNameQualifier
}

// ReSharper disable CheckNamespace
namespace OpcLabs.BaseLibTest.Forms.Internal
// ReSharper restore CheckNamespace
// ReSharper disable RedundantNameQualifier
{

    [TestClass]
    // ReSharper disable InconsistentNaming
    // ReSharper disable PartialTypeWithSinglePart
    public partial class ListViewSubItemEqualityComparerTest
    // ReSharper restore PartialTypeWithSinglePart
    // ReSharper restore InconsistentNaming
    {
        public ListViewSubItemEqualityComparerTest()
        {
            Testers = TestSuite.GetTypeTesters(typeof(global::OpcLabs.BaseLib.Forms.Internal.ListViewSubItemEqualityComparer));
        }

        [TestInitialize]
        public void InitializeTest()
        {
            AssertUtilities.WriteLine("Initializing test for OpcLabs.BaseLib.Forms.Internal.ListViewSubItemEqualityComparer...");
        }

        [NotNull]
        public TesterCollection Testers { get; }

        [TestCategory("GeneratedTest")]
        [TestCategory("Forms")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultCtorTester()
        {
            if (!Testers.TryGetValue("DefaultCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }
    }

// ReSharper restore RedundantNameQualifier
}

// ReSharper disable CheckNamespace
namespace OpcLabs.BaseLibTest.Forms.Internal
// ReSharper restore CheckNamespace
// ReSharper disable RedundantNameQualifier
{

    [TestClass]
    // ReSharper disable InconsistentNaming
    // ReSharper disable PartialTypeWithSinglePart
    public partial class SizeFactorConverterTest
    // ReSharper restore PartialTypeWithSinglePart
    // ReSharper restore InconsistentNaming
    {
        public SizeFactorConverterTest()
        {
            Testers = TestSuite.GetTypeTesters(typeof(global::OpcLabs.BaseLib.Forms.Internal.SizeFactorConverter));
        }

        [TestInitialize]
        public void InitializeTest()
        {
            AssertUtilities.WriteLine("Initializing test for OpcLabs.BaseLib.Forms.Internal.SizeFactorConverter...");
        }

        [NotNull]
        public TesterCollection Testers { get; }

        [TestCategory("GeneratedTest")]
        [TestCategory("Forms")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultCtorTester()
        {
            if (!Testers.TryGetValue("DefaultCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }
    }

// ReSharper restore RedundantNameQualifier
}

// ReSharper disable CheckNamespace
namespace OpcLabs.BaseLibTest.Forms.Navigation
// ReSharper restore CheckNamespace
// ReSharper disable RedundantNameQualifier
{

    [TestClass]
    // ReSharper disable InconsistentNaming
    // ReSharper disable PartialTypeWithSinglePart
    public partial class BrowseAddressSpaceControlTest
    // ReSharper restore PartialTypeWithSinglePart
    // ReSharper restore InconsistentNaming
    {
        public BrowseAddressSpaceControlTest()
        {
            Testers = TestSuite.GetTypeTesters(typeof(global::OpcLabs.BaseLib.Forms.Navigation.BrowseAddressSpaceControl));
        }

        [TestInitialize]
        public void InitializeTest()
        {
            AssertUtilities.WriteLine("Initializing test for OpcLabs.BaseLib.Forms.Navigation.BrowseAddressSpaceControl...");
        }

        [NotNull]
        public TesterCollection Testers { get; }

        [TestCategory("GeneratedTest")]
        [TestCategory("Forms")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultCtorTester()
        {
            if (!Testers.TryGetValue("DefaultCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }
    }

// ReSharper restore RedundantNameQualifier
}

// ReSharper disable CheckNamespace
namespace OpcLabs.BaseLibTest.Forms.Navigation
// ReSharper restore CheckNamespace
// ReSharper disable RedundantNameQualifier
{

    [TestClass]
    // ReSharper disable InconsistentNaming
    // ReSharper disable PartialTypeWithSinglePart
    public partial class DefaultNavigablePresentationTest
    // ReSharper restore PartialTypeWithSinglePart
    // ReSharper restore InconsistentNaming
    {
        public DefaultNavigablePresentationTest()
        {
            Testers = TestSuite.GetTypeTesters(typeof(global::OpcLabs.BaseLib.Forms.Navigation.DefaultNavigablePresentation));
        }

        [TestInitialize]
        public void InitializeTest()
        {
            AssertUtilities.WriteLine("Initializing test for OpcLabs.BaseLib.Forms.Navigation.DefaultNavigablePresentation...");
        }

        [NotNull]
        public TesterCollection Testers { get; }

        [TestCategory("GeneratedTest")]
        [TestCategory("Forms")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultCtorTester()
        {
            if (!Testers.TryGetValue("DefaultCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }
    }

// ReSharper restore RedundantNameQualifier
}

// ReSharper disable CheckNamespace
namespace OpcLabs.BaseLibTest.Forms.Navigation
// ReSharper restore CheckNamespace
// ReSharper disable RedundantNameQualifier
{

    [TestClass]
    // ReSharper disable InconsistentNaming
    // ReSharper disable PartialTypeWithSinglePart
    public partial class DummyNavigableNodeTest
    // ReSharper restore PartialTypeWithSinglePart
    // ReSharper restore InconsistentNaming
    {
        public DummyNavigableNodeTest()
        {
            Testers = TestSuite.GetTypeTesters(typeof(global::OpcLabs.BaseLib.Forms.Navigation.DummyNavigableNode));
        }

        [TestInitialize]
        public void InitializeTest()
        {
            AssertUtilities.WriteLine("Initializing test for OpcLabs.BaseLib.Forms.Navigation.DummyNavigableNode...");
        }

        [NotNull]
        public TesterCollection Testers { get; }

        [TestCategory("GeneratedTest")]
        [TestCategory("Forms")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultCtorTester()
        {
            if (!Testers.TryGetValue("DefaultCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }
    }

// ReSharper restore RedundantNameQualifier
}

// ReSharper disable CheckNamespace
namespace OpcLabs.BaseLibTest.Forms.Navigation
// ReSharper restore CheckNamespace
// ReSharper disable RedundantNameQualifier
{

    [TestClass]
    // ReSharper disable InconsistentNaming
    // ReSharper disable PartialTypeWithSinglePart
    public partial class NavigableBrowseControlTest
    // ReSharper restore PartialTypeWithSinglePart
    // ReSharper restore InconsistentNaming
    {
        public NavigableBrowseControlTest()
        {
            Testers = TestSuite.GetTypeTesters(typeof(global::OpcLabs.BaseLib.Forms.Navigation.NavigableBrowseControl));
        }

        [TestInitialize]
        public void InitializeTest()
        {
            AssertUtilities.WriteLine("Initializing test for OpcLabs.BaseLib.Forms.Navigation.NavigableBrowseControl...");
        }

        [NotNull]
        public TesterCollection Testers { get; }

        [TestCategory("GeneratedTest")]
        [TestCategory("Forms")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultCtorTester()
        {
            if (!Testers.TryGetValue("DefaultCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("Forms")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultValueDataMemberTester()
        {
            if (!Testers.TryGetValue("DefaultValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("Forms")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void InvalidValueDataMemberTester()
        {
            if (!Testers.TryGetValue("InvalidValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("Forms")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ShouldSerializeTester()
        {
            if (!Testers.TryGetValue("ShouldSerializeTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }
    }

// ReSharper restore RedundantNameQualifier
}

// ReSharper disable CheckNamespace
namespace OpcLabs.BaseLibTest.Forms.Net
// ReSharper restore CheckNamespace
// ReSharper disable RedundantNameQualifier
{

    [TestClass]
    // ReSharper disable InconsistentNaming
    // ReSharper disable PartialTypeWithSinglePart
    public partial class NetworkCredentialControlTest
    // ReSharper restore PartialTypeWithSinglePart
    // ReSharper restore InconsistentNaming
    {
        public NetworkCredentialControlTest()
        {
            Testers = TestSuite.GetTypeTesters(typeof(global::OpcLabs.BaseLib.Forms.Net.NetworkCredentialControl));
        }

        [TestInitialize]
        public void InitializeTest()
        {
            AssertUtilities.WriteLine("Initializing test for OpcLabs.BaseLib.Forms.Net.NetworkCredentialControl...");
        }

        [NotNull]
        public TesterCollection Testers { get; }

        [TestCategory("GeneratedTest")]
        [TestCategory("Forms")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultCtorTester()
        {
            if (!Testers.TryGetValue("DefaultCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("Forms")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultValueDataMemberTester()
        {
            if (!Testers.TryGetValue("DefaultValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("Forms")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void InvalidValueDataMemberTester()
        {
            if (!Testers.TryGetValue("InvalidValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("Forms")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ShouldSerializeTester()
        {
            if (!Testers.TryGetValue("ShouldSerializeTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }
    }

// ReSharper restore RedundantNameQualifier
}

// ReSharper disable CheckNamespace
namespace OpcLabs.BaseLibTest.Forms.Networking.Internal
// ReSharper restore CheckNamespace
// ReSharper disable RedundantNameQualifier
{

    [TestClass]
    // ReSharper disable InconsistentNaming
    // ReSharper disable PartialTypeWithSinglePart
    public partial class NetworkAddressControlTest
    // ReSharper restore PartialTypeWithSinglePart
    // ReSharper restore InconsistentNaming
    {
        public NetworkAddressControlTest()
        {
            Testers = TestSuite.GetTypeTesters(typeof(global::OpcLabs.BaseLib.Forms.Networking.Internal.NetworkAddressControl));
        }

        [TestInitialize]
        public void InitializeTest()
        {
            AssertUtilities.WriteLine("Initializing test for OpcLabs.BaseLib.Forms.Networking.Internal.NetworkAddressControl...");
        }

        [NotNull]
        public TesterCollection Testers { get; }

        [TestCategory("GeneratedTest")]
        [TestCategory("Forms")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultCtorTester()
        {
            if (!Testers.TryGetValue("DefaultCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("Forms")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultValueDataMemberTester()
        {
            if (!Testers.TryGetValue("DefaultValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }
    }

// ReSharper restore RedundantNameQualifier
}

// ReSharper disable CheckNamespace
namespace OpcLabs.BaseLibTest.Forms.Networking.Internal
// ReSharper restore CheckNamespace
// ReSharper disable RedundantNameQualifier
{

    [TestClass]
    // ReSharper disable InconsistentNaming
    // ReSharper disable PartialTypeWithSinglePart
    public partial class ResourceAddressControlTest
    // ReSharper restore PartialTypeWithSinglePart
    // ReSharper restore InconsistentNaming
    {
        public ResourceAddressControlTest()
        {
            Testers = TestSuite.GetTypeTesters(typeof(global::OpcLabs.BaseLib.Forms.Networking.Internal.ResourceAddressControl));
        }

        [TestInitialize]
        public void InitializeTest()
        {
            AssertUtilities.WriteLine("Initializing test for OpcLabs.BaseLib.Forms.Networking.Internal.ResourceAddressControl...");
        }

        [NotNull]
        public TesterCollection Testers { get; }

        [TestCategory("GeneratedTest")]
        [TestCategory("Forms")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultCtorTester()
        {
            if (!Testers.TryGetValue("DefaultCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("Forms")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultValueDataMemberTester()
        {
            if (!Testers.TryGetValue("DefaultValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }
    }

// ReSharper restore RedundantNameQualifier
}

// ReSharper disable CheckNamespace
namespace OpcLabs.BaseLibTest.Forms.Runtime
// ReSharper restore CheckNamespace
// ReSharper disable RedundantNameQualifier
{

    [TestClass]
    // ReSharper disable InconsistentNaming
    // ReSharper disable PartialTypeWithSinglePart
    public partial class ComClassRegistrationDialogTest
    // ReSharper restore PartialTypeWithSinglePart
    // ReSharper restore InconsistentNaming
    {
        public ComClassRegistrationDialogTest()
        {
            Testers = TestSuite.GetTypeTesters(typeof(global::OpcLabs.BaseLib.Forms.Runtime.ComClassRegistrationDialog));
        }

        [TestInitialize]
        public void InitializeTest()
        {
            AssertUtilities.WriteLine("Initializing test for OpcLabs.BaseLib.Forms.Runtime.ComClassRegistrationDialog...");
        }

        [NotNull]
        public TesterCollection Testers { get; }

        [TestCategory("GeneratedTest")]
        [TestCategory("Forms")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultCtorTester()
        {
            if (!Testers.TryGetValue("DefaultCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("Forms")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultValueDataMemberTester()
        {
            if (!Testers.TryGetValue("DefaultValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("Forms")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void InvalidValueDataMemberTester()
        {
            if (!Testers.TryGetValue("InvalidValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("Forms")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ShouldSerializeTester()
        {
            if (!Testers.TryGetValue("ShouldSerializeTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }
    }

// ReSharper restore RedundantNameQualifier
}

// ReSharper disable CheckNamespace
namespace OpcLabs.BaseLibTest.Forms.Runtime
// ReSharper restore CheckNamespace
// ReSharper disable RedundantNameQualifier
{

    [TestClass]
    // ReSharper disable InconsistentNaming
    // ReSharper disable PartialTypeWithSinglePart
    public partial class ComClassRegistrationFormTest
    // ReSharper restore PartialTypeWithSinglePart
    // ReSharper restore InconsistentNaming
    {
        public ComClassRegistrationFormTest()
        {
            Testers = TestSuite.GetTypeTesters(typeof(global::OpcLabs.BaseLib.Forms.Runtime.ComClassRegistrationForm));
        }

        [TestInitialize]
        public void InitializeTest()
        {
            AssertUtilities.WriteLine("Initializing test for OpcLabs.BaseLib.Forms.Runtime.ComClassRegistrationForm...");
        }

        [NotNull]
        public TesterCollection Testers { get; }

        [TestCategory("GeneratedTest")]
        [TestCategory("Forms")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultCtorTester()
        {
            if (!Testers.TryGetValue("DefaultCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("Forms")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultValueDataMemberTester()
        {
            if (!Testers.TryGetValue("DefaultValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("Forms")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void InvalidValueDataMemberTester()
        {
            if (!Testers.TryGetValue("InvalidValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("Forms")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ShouldSerializeTester()
        {
            if (!Testers.TryGetValue("ShouldSerializeTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }
    }

// ReSharper restore RedundantNameQualifier
}

// ReSharper disable CheckNamespace
namespace OpcLabs.BaseLibTest.Forms.Security
// ReSharper restore CheckNamespace
// ReSharper disable RedundantNameQualifier
{

    [TestClass]
    // ReSharper disable InconsistentNaming
    // ReSharper disable PartialTypeWithSinglePart
    public partial class NetworkSecurityControlTest
    // ReSharper restore PartialTypeWithSinglePart
    // ReSharper restore InconsistentNaming
    {
        public NetworkSecurityControlTest()
        {
            Testers = TestSuite.GetTypeTesters(typeof(global::OpcLabs.BaseLib.Forms.Security.NetworkSecurityControl));
        }

        [TestInitialize]
        public void InitializeTest()
        {
            AssertUtilities.WriteLine("Initializing test for OpcLabs.BaseLib.Forms.Security.NetworkSecurityControl...");
        }

        [NotNull]
        public TesterCollection Testers { get; }

        [TestCategory("GeneratedTest")]
        [TestCategory("Forms")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultCtorTester()
        {
            if (!Testers.TryGetValue("DefaultCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("Forms")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultValueDataMemberTester()
        {
            if (!Testers.TryGetValue("DefaultValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("Forms")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void InvalidValueDataMemberTester()
        {
            if (!Testers.TryGetValue("InvalidValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("Forms")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ShouldSerializeTester()
        {
            if (!Testers.TryGetValue("ShouldSerializeTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }
    }

// ReSharper restore RedundantNameQualifier
}

// ReSharper disable CheckNamespace
namespace OpcLabs.BaseLibTest.Forms
// ReSharper restore CheckNamespace
// ReSharper disable RedundantNameQualifier
{

    [TestClass]
    // ReSharper disable InconsistentNaming
    // ReSharper disable PartialTypeWithSinglePart
    public partial class SizableCommonDialogTest
    // ReSharper restore PartialTypeWithSinglePart
    // ReSharper restore InconsistentNaming
    {
        public SizableCommonDialogTest()
        {
            Testers = TestSuite.GetTypeTesters(typeof(global::OpcLabs.BaseLib.Forms.SizableCommonDialog));
        }

        [TestInitialize]
        public void InitializeTest()
        {
            AssertUtilities.WriteLine("Initializing test for OpcLabs.BaseLib.Forms.SizableCommonDialog...");
        }

        [NotNull]
        public TesterCollection Testers { get; }

        [TestCategory("GeneratedTest")]
        [TestCategory("Forms")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultCtorTester()
        {
            if (!Testers.TryGetValue("DefaultCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("Forms")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultValueDataMemberTester()
        {
            if (!Testers.TryGetValue("DefaultValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("Forms")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ShouldSerializeTester()
        {
            if (!Testers.TryGetValue("ShouldSerializeTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }
    }

// ReSharper restore RedundantNameQualifier
}

// ReSharper disable CheckNamespace
namespace OpcLabs.BaseLibTest.Forms.Testing
// ReSharper restore CheckNamespace
// ReSharper disable RedundantNameQualifier
{

    [TestClass]
    // ReSharper disable InconsistentNaming
    // ReSharper disable PartialTypeWithSinglePart
    public partial class DialogsFormTest
    // ReSharper restore PartialTypeWithSinglePart
    // ReSharper restore InconsistentNaming
    {
        public DialogsFormTest()
        {
            Testers = TestSuite.GetTypeTesters(typeof(global::OpcLabs.BaseLib.Forms.Testing.DialogsForm));
        }

        [TestInitialize]
        public void InitializeTest()
        {
            AssertUtilities.WriteLine("Initializing test for OpcLabs.BaseLib.Forms.Testing.DialogsForm...");
        }

        [NotNull]
        public TesterCollection Testers { get; }

        [TestCategory("GeneratedTest")]
        [TestCategory("Forms")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultCtorTester()
        {
            if (!Testers.TryGetValue("DefaultCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("Forms")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultValueDataMemberTester()
        {
            if (!Testers.TryGetValue("DefaultValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("Forms")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ShouldSerializeTester()
        {
            if (!Testers.TryGetValue("ShouldSerializeTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }
    }

// ReSharper restore RedundantNameQualifier
}

// ReSharper disable CheckNamespace
namespace OpcLabs.BaseLibTest.Forms.Testing
// ReSharper restore CheckNamespace
// ReSharper disable RedundantNameQualifier
{

    [TestClass]
    // ReSharper disable InconsistentNaming
    // ReSharper disable PartialTypeWithSinglePart
    public partial class ObjectTestbedFormTest
    // ReSharper restore PartialTypeWithSinglePart
    // ReSharper restore InconsistentNaming
    {
        public ObjectTestbedFormTest()
        {
            Testers = TestSuite.GetTypeTesters(typeof(global::OpcLabs.BaseLib.Forms.Testing.ObjectTestbedForm));
        }

        [TestInitialize]
        public void InitializeTest()
        {
            AssertUtilities.WriteLine("Initializing test for OpcLabs.BaseLib.Forms.Testing.ObjectTestbedForm...");
        }

        [NotNull]
        public TesterCollection Testers { get; }

        [TestCategory("GeneratedTest")]
        [TestCategory("Forms")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultCtorTester()
        {
            if (!Testers.TryGetValue("DefaultCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("Forms")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultValueDataMemberTester()
        {
            if (!Testers.TryGetValue("DefaultValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("Forms")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void InvalidValueDataMemberTester()
        {
            if (!Testers.TryGetValue("InvalidValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("Forms")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ShouldSerializeTester()
        {
            if (!Testers.TryGetValue("ShouldSerializeTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }
    }

// ReSharper restore RedundantNameQualifier
}

// ReSharper disable CheckNamespace
namespace OpcLabs.BaseLibTest.Forms.Testing
// ReSharper restore CheckNamespace
// ReSharper disable RedundantNameQualifier
{

    [TestClass]
    // ReSharper disable InconsistentNaming
    // ReSharper disable PartialTypeWithSinglePart
    public partial class SwitchboardFormTest
    // ReSharper restore PartialTypeWithSinglePart
    // ReSharper restore InconsistentNaming
    {
        public SwitchboardFormTest()
        {
            Testers = TestSuite.GetTypeTesters(typeof(global::OpcLabs.BaseLib.Forms.Testing.SwitchboardForm));
        }

        [TestInitialize]
        public void InitializeTest()
        {
            AssertUtilities.WriteLine("Initializing test for OpcLabs.BaseLib.Forms.Testing.SwitchboardForm...");
        }

        [NotNull]
        public TesterCollection Testers { get; }

        [TestCategory("GeneratedTest")]
        [TestCategory("Forms")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultCtorTester()
        {
            if (!Testers.TryGetValue("DefaultCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("Forms")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultValueDataMemberTester()
        {
            if (!Testers.TryGetValue("DefaultValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("Forms")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void ShouldSerializeTester()
        {
            if (!Testers.TryGetValue("ShouldSerializeTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }
    }

// ReSharper restore RedundantNameQualifier
}

// ReSharper disable CheckNamespace
namespace OpcLabs.BaseLibTest.Forms
// ReSharper restore CheckNamespace
// ReSharper disable RedundantNameQualifier
{

    [TestClass]
    // ReSharper disable InconsistentNaming
    // ReSharper disable PartialTypeWithSinglePart
    public partial class UserValueControlTest
    // ReSharper restore PartialTypeWithSinglePart
    // ReSharper restore InconsistentNaming
    {
        public UserValueControlTest()
        {
            Testers = TestSuite.GetTypeTesters(typeof(global::OpcLabs.BaseLib.Forms.UserValueControl));
        }

        [TestInitialize]
        public void InitializeTest()
        {
            AssertUtilities.WriteLine("Initializing test for OpcLabs.BaseLib.Forms.UserValueControl...");
        }

        [NotNull]
        public TesterCollection Testers { get; }

        [TestCategory("GeneratedTest")]
        [TestCategory("Forms")]
        [TestCategory("Construction")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultCtorTester()
        {
            if (!Testers.TryGetValue("DefaultCtorTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }

        [TestCategory("GeneratedTest")]
        [TestCategory("Forms")]
        [TestCategory("DataMembers")]
        [TestMethod]
        // ReSharper disable once InconsistentNaming
        public void DefaultValueDataMemberTester()
        {
            if (!Testers.TryGetValue("DefaultValueDataMemberTester", out Tester tester))
                AssertUtilities.Inconclusive("Tester not found.");
            Debug.Assert(tester != null);
            TestUtilities.RunTests(tester.TestMethods);
        }
    }

// ReSharper restore RedundantNameQualifier
}
